<?php
/**
* @Copyright Copyright (C) 2010 www.profinvent.com. All rights reserved.
* @website http://www.profinvent.com
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 2 of the License, or
* any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
**/

defined('_JEXEC') or die('Restricted access');
jimport('joomla.application.component.controller');

class coursemanControllerapplication extends coursemanController
{

    function __construct($config = array())
    {
        parent::__construct($config);

        $this->registerTask('add', 'display');
        $this->registerTask('edit', 'display');
        $this->childviewname = 'application';
        $this->parentviewname = 'applications';
    }

    function display()
    {
        switch ($this->getTask())
        {
            case 'add':
                {
                    JRequest::setVar('hidemainmenu', 1);
                    JRequest::setVar('layout', 'form');
                    JRequest::setVar('view', $this->childviewname);
                    JRequest::setVar('edit', false);

                    $model = $this->getModel($this->childviewname);
                    $model->checkout();
                }

                break;
            case 'edit':
                {
                    JRequest::setVar('hidemainmenu', 1);
                    JRequest::setVar('layout', 'form');
                    JRequest::setVar('view', $this->childviewname);
                    JRequest::setVar('edit', true);

                    $model = $this->getModel($this->childviewname);
                    $model->checkout();
                }

                break;
        }

        parent::display();
    }


    function save()
    {

		JRequest::checkToken() or jexit('Invalid Token');
        $post = JRequest::get('post');
        $cid = JRequest::getVar('cid', array(0), 'post', 'array');
        $post['id'] = (int)$cid[0];
        $model = $this->getModel($this->childviewname);
		$userId		= JRequest::getVar( 'user_id' , '' , 'POST' );

        if ($applicationid = $model->store($post))
        {
            $msg = JText::_('Record saved');
        } else
        {
            $msg = JText::_('Error saving record');
        }

    	// Process and save custom fields
    	$model		=& $this->getModel( 'application' );
    	$values		= array();
    	$customfields	= $model->getEditableCustomfields( $userId );

    	CFactory::load( 'libraries' , 'customfields' );


    	foreach( $customfields->fields as $group => $fields )
    	{
    		foreach( $fields as $data )
    		{
    			// Get value from posted data and map it to the field.
    			// Here we need to prepend the 'field' before the id because in the form, the 'field' is prepended to the id.
    			$postData				= JRequest::getVar( 'field' . $data['id'] , '' , 'POST' );
    			$values[ $data['id'] ]	= CoursemanCustomfieldsLibrary::formatData( $data['type']  , $postData );

    			// @rule: Validate custom customfields if necessary
    			if( !CoursemanCustomfieldsLibrary::validateField( $data['type'] , $values[ $data['id'] ] , $data['required'] ) )
    			{
    				// If there are errors on the form, display to the user.
    				$message	= JText::sprintf('The field "%1$s" contain improper values' ,  $data['name'] );
    				$this->setredirect( 'index.php?option=com_courseman&controller=application&task=edit&cid[]=' . $post['id'] , $message , 'error' );

					return;
    			}
    		}
    	}
    	//save data from custom fields
    	$model->saveCustomfields($applicationid, $userId, $values);

        $model->checkin();
        $link = 'index.php?option=com_courseman&view=' . $this->parentviewname;
        $this->setRedirect($link, $msg);
    }


    function remove()
    {

        JRequest::checkToken() or jexit('Invalid Token');
        $cid = JRequest::getVar('cid', array(), 'post', 'array');
        JArrayHelper::toInteger($cid);

        if (count($cid) < 1)
        {
            JError::raiseError(500, JText::_('Select an course to delete'));
        }

        $model = $this->getModel($this->childviewname);

        if (!$model->delete($cid))
        {
            echo "<script> alert('" . $model->getError(true) .
                "'); window.history.go(-1); </script>\n";
        }
        $msg = JText::_('Operation was successfull');
        $this->setRedirect('index.php?option=com_courseman&view=' . $this->parentviewname,
            $msg);
    }


    function publish()
    {

        JRequest::checkToken() or jexit('Invalid Token');
        $cid = JRequest::getVar('cid', array(), 'post', 'array');
        JArrayHelper::toInteger($cid);

        if (count($cid) < 1)
        {
            JError::raiseError(500, JText::_('Select an course to publish'));
        }

        $model = $this->getModel($this->childviewname);

        if (!$model->publish($cid, 1))
        {
            echo "<script> alert('" . $model->getError(true) .
                "'); window.history.go(-1); </script>\n";
        }

        $this->setRedirect('index.php?option=com_courseman&view=' . $this->parentviewname);
    }


    function unpublish()
    {

        JRequest::checkToken() or jexit('Invalid Token');
        $cid = JRequest::getVar('cid', array(), 'post', 'array');
        JArrayHelper::toInteger($cid);

        if (count($cid) < 1)
        {
            JError::raiseError(500, JText::_('Select an course to unpublish'));
        }

        $model = $this->getModel($this->childviewname);

        if (!$model->publish($cid, 0))
        {
            echo "<script> alert('" . $model->getError(true) .
                "'); window.history.go(-1); </script>\n";
        }

        $this->setRedirect('index.php?option=com_courseman&view=' . $this->parentviewname);
    }


    function cancel()
    {

        JRequest::checkToken() or jexit('Invalid Token');

        $model = $this->getModel($this->childviewname);
        $model->checkin();
        $this->setRedirect('index.php?option=com_courseman&view=' . $this->parentviewname);
    }


    function orderup()
    {

        JRequest::checkToken() or jexit('Invalid Token');
        $model = $this->getModel($this->childviewname);
        $model->move(-1);
        $this->setRedirect('index.php?option=com_courseman&view=' . $this->parentviewname);
    }


    function orderdown()
    {

        JRequest::checkToken() or jexit('Invalid Token');
        $model = $this->getModel($this->childviewname);
        $model->move(1);
        $this->setRedirect('index.php?option=com_courseman&view=' . $this->parentviewname);
    }


    function saveorder()
    {

        JRequest::checkToken() or jexit('Invalid Token');
        $cid = JRequest::getVar('cid', array(), 'post', 'array');
        $order = JRequest::getVar('order', array(), 'post', 'array');
        JArrayHelper::toInteger($cid);
        JArrayHelper::toInteger($order);
        $model = $this->getModel($this->childviewname);
        $model->saveorder($cid, $order);
        $msg = 'New ordering saved';
        $this->setRedirect('index.php?option=com_courseman&view=' . $this->parentviewname,
            $msg);
    }

    function goback()
    {

        JRequest::checkToken() or jexit('Invalid Token');

        $this->setRedirect('index.php?option=com_courseman&view=settings');
    }

	function changestatus()   {
		// Check for request forgeries
		JRequest::checkToken( 'get' ) or jexit( 'Invalid Token' );
		$cid  = JRequest::getVar( 'cid' );
		//JArrayHelper::toInteger($cid);
		$status = JRequest::getVar('status');
		// Checkin the booking
		$model = $this->getModel('application');

		if ($status == 3)  {
			$status = 0;
		} else {
			$status = $status + 1;
		}

		$model->setstatus($cid, $status);
		$msg = JText::_( 'The status has been updated' );
		$this->setRedirect( 'index.php?option=com_courseman&view=applications', $msg  );
	}



}

?>