<?php
/**
* @Copyright Copyright (C) 2010 www.profinvent.com. All rights reserved.
* @website http://www.profinvent.com
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 2 of the License, or
* any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
**/

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.controller');

class CoursemanControllerArchive extends CoursemanController
{
    function __construct()
    {
        parent::__construct();
    }

    function unarchive()
    {

        JRequest::checkToken() or jexit('Invalid Token');

        $cid = JRequest::getVar('cid', array(0), 'post', 'array');

        if (!is_array($cid) || count($cid) < 1)
        {
            JError::raiseWarning(500, JText::_('SELECT COURSE TO UNARCHIVE'));
        }

        $model = $this->getModel('archive');

        if (!$model->unarchive($cid))
        {
            JError::raiseError(500, $model->getError());
        }

        $total = count($cid);
        $msg = $total . ' ' . JText::_('COURSE(S) UNARCHIVED');

        $this->setRedirect('index.php?option=com_courseman&view=archive', $msg);
    }

    function remove()
    {

        JRequest::checkToken() or jexit('Invalid Token');

        $cid = JRequest::getVar('cid', array(0), 'post', 'array');

        if (!is_array($cid) || count($cid) < 1)
        {
            JError::raiseWarning(500, JText::_('SELECT COURSE TO DELETE'));
        }

        $model = $this->getModel('archive');
        if (!$model->delete($cid))
        {
            JError::raiseError(500, $model->getError());
        }

        $total = count($cid);
        $msg = $total . ' ' . JText::_('COURSE(S) DELETED');

        $this->setRedirect('index.php?option=com_courseman&view=archive', $msg);
    }
}

?>