<?php
/**
* @Copyright Copyright (C) 2010 www.profinvent.com. All rights reserved.
* @website http://www.profinvent.com
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 2 of the License, or
* any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
**/


// Disallow direct access to this file
defined('_JEXEC') or die('Restricted access');

jimport( 'joomla.application.component.controller' );

/**
 * Jom Social Customfields Controller
 */
class CoursemanControllerEditfields extends JController
{
	function __construct()
	{
		parent::__construct();

		$this->registerTask( 'publish' , 'savePublish' );
		$this->registerTask( 'unpublish' , 'savePublish' );
		$this->registerTask( 'orderup' , 'saveOrder' );
		$this->registerTask( 'orderdown' , 'saveOrder' );
	}

	/**
	 * Removes the specific field
	 *
	 * @access public
	 *
	 **/
	function removeField()
	{
		$mainframe	=& JFactory::getApplication();

 		$ids	= JRequest::getVar( 'cid', array(), 'post', 'array' );
		$count	= count($ids);

		foreach( $ids as $id )
		{
			$table	=& JTable::getInstance( 'editfield', 'Table' );
			$table->load( $id );

			if(!$table->delete( $id ))
			{
				// If there are any error when deleting, we just stop and redirect user with error.
				$message	= JText::_('COULD NOT DELETE');
				$mainframe->redirect( 'index.php?option=com_courseman&task=customfields' , $message);
				exit;
			}
		}


		$message	= JText::_( $count . ' Field(s) successfully removed.');
 		$mainframe->redirect( 'index.php?option=com_courseman&view=editfields' , $message );
	}

	/**
	 * Save the ordering of the entire records.
	 *
	 * @access public
	 *
	 **/
	function saveOrder()
	{
		$mainframe	=& JFactory::getApplication();

		// Determine whether to order it up or down
		$direction	= ( JRequest::getWord( 'task' , '' ) == 'orderup' ) ? -1 : 1;

		// Get the ID in the correct location
 		$id			= JRequest::getVar( 'cid', array(), 'post', 'array' );
		$db			=& JFactory::getDBO();

		if( isset( $id[0] ) )
		{
			$id		= (int) $id[0];

			// Load the JTable Object.
			$table	=& JTable::getInstance( 'editfield' , 'table' );

			$table->load( $id );

			if( $table->type == 'group' )
			{
				$query	= 'SELECT * FROM ' . $db->nameQuote( '#__courseman_fields' ) . ' '
						. 'WHERE ' . $db->nameQuote( 'ordering' ) . ' > ' . $db->Quote( $table->ordering ) . ' '
						. 'AND ' . $db->nameQuote( 'type' ) . '=' . $db->Quote( 'group' ) . ' '
						. 'ORDER BY ordering ASC '
						. 'LIMIT 1';

				$db->setQuery( $query );
				$nextGroup	= $db->loadObject();

				if( $nextGroup || $direction == -1 )
				{
					if( $direction == -1 )
					{
						// Get previous group in list
						$query	= 'SELECT * FROM ' . $db->nameQuote( '#__courseman_fields' ) . ' '
								. 'WHERE ' . $db->nameQuote( 'ordering' ) . ' < ' . $db->Quote( $table->ordering ) . ' '
								. 'AND ' . $db->nameQuote( 'type' ) . '=' . $db->Quote( 'group' ) . ' '
								. 'ORDER BY ordering DESC LIMIT 1';

						$db->setQuery( $query );
						$previousGroup	= $db->loadObject();

						$query	= 'SELECT * FROM ' . $db->nameQuote( '#__courseman_fields' ) . ' '
								. 'WHERE ' . $db->nameQuote( 'ordering' ) . ' >= ' . $db->Quote( $table->ordering);

						if( $nextGroup )
						{
							$query	.= ' AND ' . $db->nameQuote( 'ordering' ) . ' < ' . $db->Quote( $nextGroup->ordering );
						}

						$query .= 'ORDER BY ordering ASC';

						$db->setQuery( $query );
						$currentFields	= $db->loadObjectList();

						// Get previous fields in the group
						$query		= 'SELECT * FROM ' . $db->nameQuote( '#__courseman_fields' ) . ' '
									. 'WHERE ' . $db->nameQuote( 'ordering' ) . ' >= ' . $db->Quote( $previousGroup->ordering ) . ' '
									. 'AND ' . $db->nameQuote( 'ordering') . ' < ' . $db->Quote( $table->ordering ) . ' '
									. 'ORDER BY ordering ASC';

						$db->setQuery( $query );
						$previousFields	= $db->loadObjectList();

						for( $i = 0; $i < count( $previousFields ); $i++ )
						{
							$row	=& $previousFields[ $i ];

							$row->ordering			= $row->ordering + count( $currentFields );

							$query	= 'UPDATE ' . $db->nameQuote( '#__courseman_fields' ) . ' '
									. 'SET ' . $db->nameQUote('ordering') . '=' . $db->Quote( $row->ordering ) . ' '
									. 'WHERE ' . $db->nameQuote( 'id' ) . '=' . $db->Quote( $row->id );
							$db->setQuery( $query );
							$db->query();
						}

						for( $i = 0; $i < count( $currentFields ); $i ++ )
						{
							$row	=& $currentFields[ $i ];

							$row->ordering	= $row->ordering - count( $previousFields );

							$query	= 'UPDATE ' . $db->nameQuote( '#__courseman_fields' ) . ' '
									. 'SET ' . $db->nameQUote('ordering') . '=' . $db->Quote( $row->ordering ) . ' '
									. 'WHERE ' . $db->nameQuote( 'id' ) . '=' . $db->Quote( $row->id );
							$db->setQuery( $query );
							$db->query();
						}
					}
					else
					{
						// Get end
						$query	= 'SELECT ordering FROM ' . $db->nameQuote( '#__courseman_fields' ) . ' '
								. 'WHERE ' . $db->nameQuote( 'ordering' ) . ' > ' . $db->Quote( $nextGroup->ordering ) . ' '
								. 'AND ' . $db->nameQuote( 'type' ) . '=' . $db->Quote( 'group' ) . ' '
								. 'ORDER BY ordering ASC '
								. 'LIMIT 1';
						$db->setQuery( $query );
						$nextGroupLimit	= $db->loadResult();

						// Get the next group childs
						if( $nextGroupLimit )
						{
							$query		= 'SELECT * FROM ' . $db->nameQuote( '#__courseman_fields' ) . ' '
										. 'WHERE ordering >=' . $nextGroup->ordering . ' '
										. 'AND ordering < ' . $nextGroupLimit . ' '
										. 'ORDER BY ordering ASC';
						}
						else
						{
							$query		= 'SELECT * FROM ' . $db->nameQuote( '#__courseman_fields' ) . ' '
										. 'WHERE ordering >=' . $nextGroup->ordering . ' '
										. 'ORDER BY ordering ASC';
						}
						$db->setQuery( $query );
						$nextGroupChilds	= $db->loadObjectList();

						$nextGroupsCount	= count( $nextGroupChilds );

						// Get all childs of the current group field
						$query		= 'SELECT * FROM ' . $db->nameQuote( '#__courseman_fields' ) . ' '
									. 'WHERE ordering >=' . $table->ordering . ' '
									. 'AND ordering < ' . $nextGroup->ordering . ' '
									. 'ORDER BY ordering ASC';

						$db->setQuery( $query );
						$currentGroupChilds	= $db->loadObjectList();
						$currentGroupsCount	= count( $currentGroupChilds );

						for( $i = 0; $i < count( $nextGroupChilds ); $i++ )
						{
							$row	=& $nextGroupChilds[ $i ];

							//$row->ordering		= $row->ordering - $currentGroupsCount;
							$row->ordering			= $table->ordering++;
							$query	= 'UPDATE ' . $db->nameQuote( '#__courseman_fields' ) . ' '
									. 'SET ' . $db->nameQUote('ordering') . '=' . $db->Quote( $row->ordering ) . ' '
									. 'WHERE ' . $db->nameQuote( 'id' ) . '=' . $db->Quote( $row->id );

							$db->setQuery( $query );
							$db->query();
						}

						for( $i = 0; $i < count( $currentGroupChilds ); $i ++ )
						{
							$child	=& $currentGroupChilds[ $i ];

							$child->ordering	= $nextGroupsCount + $child->ordering;

							$query	= 'UPDATE ' . $db->nameQuote( '#__courseman_fields' ) . ' '
									. 'SET ' . $db->nameQUote('ordering') . '=' . $db->Quote( $child->ordering ) . ' '
									. 'WHERE ' . $db->nameQuote( 'id' ) . '=' . $db->Quote( $child->id );
							$db->setQuery( $query );
							$db->query();
						}
					}
				}
			}
			else
			{
				$table->move( $direction );
			}

			$cache	=& JFactory::getCache( 'com_content');
			$cache->clean();

			$mainframe->redirect( 'index.php?option=com_courseman&view=editfields' );
		}

	}

	/**
	 * AJAX method to save a field
	 *
	 * @param	int	id	Current field id
	 * @param	Array data	The fields data
	 *
	 * @return	JAXResponse object	Azrul's AJAX Response object
	 **/
	function ajaxSaveGroup( $id , $data )
	{
		$user	=& JFactory::getUser();

		if ( $user->get('guest'))
		{
			JError::raiseError( 403, JText::_('CC ACCESS FORBIDDEN') );
			return;
		}

		$response	= new JAXResponse();

		// Load the JTable Object.
		$row	=& JTable::getInstance( 'editfield' , 'table' );
		$row->load( $id );
		$isValid		= true;
		$data['type']	= 'group';

		$row->bindAjaxPost( $data );

		// Do some validation before blindly saving the customfields.
		if( empty( $row->name ) )
		{
			$error		= JText::_('CC NAME SHOULD NOT BE LEFT EMPTY');

			$response->addScriptCall( 'jQuery("#error-notice").html("' . $error . '");');
			$isValid	= false;
		}

		if( $isValid )
		{
			$groupOrdering	= isset($data['group']) ? $data['group'] : '';
			$row->store( $groupOrdering );
			$parent			= '';

			// Get the view
			$view		=& $this->getView( 'editfields' , 'html' );

			if($id != 0)
			{
				$name	= '<a href="javascript:void(0);" onclick="azcommunity.editField(\'' . $row->id . '\');">' . $row->name . '</a>';
				$type	= '<span id="type' . $row->id . '" onclick="$(\'typeOption\').style.display = \'block\';$(this).style.display = \'none\';">'
						. JString::ucfirst($row->type)
						. '</span>';

				$publish		= $view->getPublish( $row , 'published' , 'editfields,ajaxTogglePublish' );
				$required		= $view->getPublish( $row , 'required' , 'editfields,ajaxTogglePublish');
				$visible		= $view->getPublish( $row , 'visible' , 'editfields,ajaxTogglePublish');
				$registration	= $view->getPublish( $row , 'registration' , 'editfields,ajaxTogglePublish');

				// Set the parent id
				$parent		= $row->id;

				// Update the rows in the table at the page.
				//@todo: need to update the title in a way looks like Joomla initialize the tooltip on document ready
				$response->addAssign('name' . $row->id, 'innerHTML' , $name);

				$response->addAssign('type' . $row->id, 'innerHTML', $type);
				$response->addAssign('published' . $row->id, 'innerHTML', $publish);
				$response->addAssign('required' . $row->id, 'innerHTML', $required);
				$response->addAssign('visible' . $row->id, 'innerHTML', $visible);
				$response->addAssign('registration' . $row->id, 'innerHTML', $registration);
				$response->addAssign('min' . $row->id, 'value', $row->min);
				$response->addAssign('max' . $row->id, 'value', $row->max);

			}
			else
			{
				$response->addScriptCall('window.location.href = "' . JURI::base() . 'index.php?option=com_courseman&view=editfields";');
			}
			$response->addScriptCall('cWindowHide();');
		}

		$response->sendResponse();
	}

	/**
	 * AJAX method to save a field
	 *
	 * @param	int	id	Current field id
	 * @param	Array data	The fields data
	 *
	 * @return	JAXResponse object	Azrul's AJAX Response object
	 **/
	function ajaxSaveField( $id , $data )
	{
		$user	=& JFactory::getUser();

		if ( $user->get('guest')) {
			JError::raiseError( 403, JText::_('CC ACCESS FORBIDDEN') );
			return;
		}

		$response	= new JAXResponse();

		// Load the JTable Object.
		$row	=& JTable::getInstance( 'editfield' , 'table' );
		$row->load( $id );
		$isValid	= true;
		$row->bindAjaxPost( $data );

		// Do some validation before blindly saving the customfields.
		if( empty( $row->name ) )
		{
			$error		= JText::_('CC NAME SHOULD NOT BE LEFT EMPTY');

			$response->addScriptCall( 'jQuery("#error-notice").html("' . $error . '");');
			$isValid	= false;
		}

		if( empty( $row->fieldcode ) )
		{
			$error		= JText::_('CC FIELD CODE SHOULD NOT BE LEFT EMPTY');

			$response->addScriptCall( 'jQuery("#error-notice").html("' . $error . '");');
			$isValid	= false;
		}

		if($row->required && !$row->registration)
		{
			$error		= JText::_('CC A FIELD IN REQUIRED SHOULD SET AS REGISTRATION AS WELL');

			$response->addScriptCall( 'jQuery("#error-notice").html("' . $error . '");');
			$isValid	= false;
		}

		if( $isValid )
		{
			$groupOrdering	= isset($data['group']) ? $data['group'] : '';
			$row->store( $groupOrdering );
			$parent			= '';

			// Get the view
			$view		=& $this->getView( 'editfields' , 'html' );

			if($id != 0)
			{
				$name	= '<a href="javascript:void(0);" onclick="azcommunity.editField(\'' . $row->id . '\');">' . $row->name . '</a>';
				$type	= '<span id="type' . $row->id . '" onclick="$(\'typeOption\').style.display = \'block\';$(this).style.display = \'none\';">'
						. JString::ucfirst($row->type)
						. '</span>';

				$publish		= $view->getPublish( $row , 'published' , 'editfields,ajaxTogglePublish' );
				$required		= $view->getPublish( $row , 'required' , 'editfields,ajaxTogglePublish');
				$visible		= $view->getPublish( $row , 'visible' , 'editfields,ajaxTogglePublish');
				$registration	= $view->getPublish( $row , 'registration' , 'editfields,ajaxTogglePublish');

				// Set the parent id
				$parent		= $row->id;

				// Update the rows in the table at the page.
				//@todo: need to update the title in a way looks like Joomla initialize the tooltip on document ready
				$response->addAssign('name' . $row->id, 'innerHTML' , $name);

				$response->addAssign('type' . $row->id, 'innerHTML', $type);
				$response->addAssign('published' . $row->id, 'innerHTML', $publish);
				$response->addAssign('required' . $row->id, 'innerHTML', $required);
				$response->addAssign('visible' . $row->id, 'innerHTML', $visible);
				$response->addAssign('registration' . $row->id, 'innerHTML', $registration);
				$response->addAssign('min' . $row->id, 'value', $row->min);
				$response->addAssign('max' . $row->id, 'value', $row->max);

			}
			else
			{
				$response->addScriptCall('window.location.href = "' . JURI::base() . 'index.php?option=com_courseman&view=editfields";');
			}
			$response->addScriptCall('cWindowHide();');
		}
		else
		{
			//release the form input back to enabled.
			$response->addScriptCall('jQuery(\'#cWindowContent\').find(\'input, textarea, button\').attr(\'disabled\', false)');
		}

		$response->sendResponse();
	}

	function _registerFieldCheck($id , $field)
	{
		$failed	= false;

		if($field == 'registration' || $field == 'required')
		{
			//if current toggle field is registration, we need to check on 'required'
			// if user disabled this registration field.
			$html	= '';
			$row	=& JTable::getInstance( 'editfield' , 'table' );
			$row->load( $id );

			if(($field == 'registration') && ($row->required && $row->registration))
			{
				// this mean the action is to toggle registration from true to false when required is true.
				// if thats the case, it defeated the rules where required field must
				// be a registration field as well.
				$html	= 'You cannot disable \'registration\' when the field is required.';
				$failed	= true;
			}
			else if(($field == 'required') && (!$row->required && !$row->registration))
			{
				// this mean the action is to toggle required from false to true when registration is false
				// if thats the case, it defeated the rules where required field must
				// be a registration field as well.
				$html	= 'You cannot enable \'required\' when the field is not a registration field.';
				$failed	= true;
			}


			if($failed)
			{
				$response	= new JAXResponse();

				$response->addScriptCall("cWindowShow('jax.call(\"community\",\"\")', 'Error' , 400, 70, 'error');");
				$response->addAssign('cWindowContent', 'innerHTML', $html);
				$response->addScriptCall("jQuery('#cWindowContent').css('overflow','auto');");
				return $response->sendResponse();
			}
		}
	}

	/**
	 * AJAX method to display the form
	 *
	 * @param	int	fieldId	The fieldId that we are editing
	 * @param	boolean	isGroup	Determines whether the current field is a group
	 *
	 * @return	JAXResponse object	Azrul's AJAX Response object
	 **/
	function ajaxEditGroup( $fieldId , $isGroup = false )
	{
		$user	=& JFactory::getUser();

		if ( $user->get('guest'))
		{
			JError::raiseError( 403, JText::_('CC ACCESS FORBIDDEN') );
			return;
		}

		$response	= new JAXResponse();

		$model			=& $this->getModel( 'editfields' );
		$fieldGroups	= $model->getGroups();

		// Load the JTable Object.
		$row	=& JTable::getInstance( 'editfield' , 'table' );
		$row->load( $fieldId );

		ob_start();
?>
<div style="background-color: #F9F9F9; border: 1px solid #D5D5D5; margin-bottom: 10px; padding: 5px;font-weight: bold;">
	<?php echo JText::_('CC CREATE NEW GROUP FOR YOUR CUSTOM EDITFIELDS');?>
</div>
<div id="error-notice" style="color: red; font-weight:700;"></div>
<div style="clear: both;"></div>
<form action="#" method="post" name="editField" id="editField">
<table style="border-spacing: 0px;border: none; width: 100%;padding: 0px;">
	<tbody>
		<tr>
			<td class="key"><?php echo JText::_('CC NAME');?></td>
			<td>:</td>
			<td>
				<input type="text" value="<?php echo $row->name;?>" name="name" style="width:250px;" />
			</td>
		</tr>
		<tr>
			<td class="key"><?php echo JText::_('CC PUBLISHED');?></td>
			<td>:</td>
			<td>
				<span><?php echo $this->_buildRadio($row->published, 'published', array( JText::_('CC YES'), JText::_('CC NO')));?></span>
			</td>
		</tr>
		<tr>
			<td class="key"><?php echo JText::_('CC VISIBLE');?></td>
			<td>:</td>
			<td><?php echo $this->_buildRadio($row->visible, 'visible', array( JText::_('CC YES'), JText::_('CC NO')));?></td>
		</tr>
	</tbody>
</table>
</form>
<?php
		$contents	= ob_get_contents();
		ob_end_clean();

		$buttons	= '<input type="button" class="button" onclick="javascript:azcommunity.saveFieldGroup(\'' . $row->id . '\');return false;" value="' . JText::_('CC SAVE') . '"/>';
		$buttons	.= '&nbsp;&nbsp;<input type="button" class="button" onclick="javascript:cWindowHide();" value="' . JText::_('CC CANCEL') . '"/>';
		$response->addAssign( 'cWindowContent' , 'innerHTML' , $contents );
		$response->addScriptCall( 'cWindowActions' , $buttons );
		return $response->sendResponse();
	}

	/**
	 * AJAX method to display the form
	 *
	 * @param	int	fieldId	The fieldId that we are editing
	 * @param	boolean	isGroup	Determines whether the current field is a group
	 *
	 * @return	JAXResponse object	Azrul's AJAX Response object
	 **/
	function ajaxEditField( $fieldId , $isGroup = false )
	{
		$user	=& JFactory::getUser();

		if ( $user->get('guest')) {
			JError::raiseError( 403, JText::_('CC ACCESS FORBIDDEN') );
			return;
		}

		$response	= new JAXResponse();

		$model			=& $this->getModel( 'editfields' );
		$fieldGroups	= $model->getGroups();

		// Load the JTable Object.
		$row	=& JTable::getInstance( 'editfield' , 'table' );

		$row->load( $fieldId );

		$group			= $model->getFieldGroup( $row->ordering );

		ob_start();
?>
<div style="background-color: #F9F9F9; border: 1px solid #D5D5D5; margin-bottom: 10px; padding: 5px;font-weight: bold;">
	<?php echo JText::_('CC CREATE NEW CUSTOM CUSTOMFIELDS FOR YOUR SITE');?>
</div>
<div id="error-notice" style="color: red; font-weight:700;"></div>
<div style="clear: both;"></div>
<form action="#" method="post" name="editField" id="editField">
<table style="border-spacing: 0px;border: none; width: 100%;padding: 0px;">
	<tbody>
		<tr>
			<td class="key"><?php echo JText::_('CC NAME');?></td>
			<td>:</td>
			<td>
				<input type="text" value="<?php echo $row->name;?>" name="name" />
			</td>
			<td class="key"><?php echo JText::_('CC PUBLISHED');?></td>
			<td>:</td>
			<td>
				<span><?php echo $this->_buildRadio($row->published, 'published', array('Yes', 'No'));?></span>
			</td>
		</tr>
		<tr>
			<td class="key"><?php echo JText::_('CC TYPE');?></td>
			<td>:</td>
			<td><?php echo $this->_buildTypes($row->type);?></td>
			<td class="key"><?php echo JText::_('CC REQUIRED');?></td>
			<td>:</td>
			<td colspan="4"><?php echo $this->_buildRadio($row->required, 'required', array('Yes', 'No'));?></td>
		</tr>
		<tr style="<?php echo ($row->type != 'group') ? 'display: table-row;' : 'display: none;'; ?>" class="fieldGroups">
			<td class="key"><?php echo JText::_('CC GROUP');?></td>
			<td>:</td>
			<td colspan="4">
				<select name="group">
			<?php
				for( $i = 0; $i < count( $fieldGroups ); $i++ )
				{
					$selected	= (isset($group->id) && $group->id == $fieldGroups[$i]->id ) ? ' selected="selected"' : '';
			?>
				<option value="<?php echo $fieldGroups[$i]->ordering;?>"<?php echo $selected;?>><?php echo $fieldGroups[$i]->name; ?></option>
			<?php
				}
			?>
				</select>
			</td>
		</tr>
		<tr>
			<td class="key"><?php echo JText::_('CC FIELD CODE');?></td>
			<td>:</td>
			<td><input type="text" value="<?php echo $row->fieldcode; ?>" name="fieldcode" maxlength="255" /></td>
			<td class="key"><?php echo JText::_('CC VISIBLE');?></td>
			<td>:</td>
			<td><?php echo $this->_buildRadio($row->visible, 'visible', array('Yes', 'No'));?></td>
		</tr>

		<tr>
			<td style="vertical-align:top;" class="key"><?php echo JText::_('CC REGISTRATION');?></td>
			<td style="vertical-align:top;">:</td>
			<td colspan="4">
				<?php echo $this->_buildRadio($row->registration, 'registration', array('Yes', 'No'));?>
			</td>
		</tr>
		<?php echo $this->_buildSize( $row );?>
		<tr>
			<td style="vertical-align:top;" class="key"><?php echo JText::_('CC TOOLTIP');?></td>
			<td style="vertical-align:top;">:</td>
			<td colspan="4">
				<textarea rows="3" cols="50" name="tips"><?php echo $row->tips;?></textarea>
			</td>
		</tr>
		<?php echo $this->_buildOptions($row, $row->id, $row->type);?>
	</tbody>
</table>
</form>
<?php
		$contents	= ob_get_contents();
		ob_end_clean();

		$buttons	= '<input type="button" class="button" onclick="javascript:azcommunity.saveField(\'' . $row->id . '\');return false;" value="' . JText::_('CC SAVE') . '"/>';
		$buttons	.= '&nbsp;&nbsp;<input type="button" class="button" onclick="javascript:cWindowHide();" value="' . JText::_('CC CANCEL') . '"/>';
		$response->addAssign( 'cWindowContent' , 'innerHTML' , $contents );
		$response->addScriptCall( 'cWindowActions' , $buttons );
		return $response->sendResponse();
	}

	/**
	 * Method to build field types data
	 *
	 * @access	private
	 * @param	string	Selected type
	 *
	 * @return	string	HTML output
	 **/
	function _buildTypes( $selectedType )
	{
		$model	=& $this->getModel( 'editfields' );
		$html	= '';
		$types	= $model->getCustomfieldsTypes();

		$html	.= '<select name="type" onchange="azcommunity.changeType(this.value)" id="type">';

		foreach( $types as $type => $value)
		{
			$selected	= ( trim($type) == $selectedType ) ? 'selected="true"' : '';
			$html		.= '<option value="' . $type . '"' . $selected . '>' . $value . '</option>';
		}
		return $html;
	}

	/**
	 * Method to build Radio fields
	 *
	 * @access	private
	 * @param	string
	 *
	 * @return	string	HTML output
	 **/
	function _buildRadio($status, $fieldname, $values)
	{
		$html	= '<span>';

		if($status || $status == '1'){
			$html	.= '<input type="radio" name="' . $fieldname . '" value="1" checked="checked" />' . $values[0];
			$html	.= '<input type="radio" name="' . $fieldname . '" value="0" />' . $values[1];
		} else {
			$html	.= '<input type="radio" name="' . $fieldname . '" value="1" />' . $values[0];
			$html	.= '<input type="radio" name="' . $fieldname . '" value="0" checked="checked" />' . $values[1];
		}
		$html	.= '</span>';

		return $html;
	}

	function _buildOptions(& $row, $id, $type)
	{
		if( $row->type == 'select' || $row->type == 'singleselect' || $row->type == 'radio' || $row->type == 'list' || $row->type == 'checkbox')
		{
			$html	= '<tr style="display: table-row;" class="fieldOptions">';
		}
		else
		{
			$html	= '<tr style="display: none;" class="fieldOptions">';
		}


		$html	.= '	<td class="key" style="vertical-align:top;">
							<span>Option</span><br />
						</td>
						<td style="vertical-align:top;">:</td>
						<td colspan="4">';
		$html	.= '<textarea rows="4" cols="50" name="options">' . $row->options . '</textarea><br />'
				 . '<span>Separate each options with a new line</span>';

		return $html;
	}

	function _buildSize(&$row)
	{
		if( $row->type == 'text' || $row->type == 'textarea' || $row->type == '')
		{
			$html	= '<tr style="display: table-row;" class="fieldSizes">';
		}
		else
		{
			$html	= '<tr style="display: none;" class="fieldSizes">';
		}

		$html	.= '<td class="key">' . JText::_('CC MINIMUM CHARACTERS') . '</td>'
				 . '<td>:</td>'
				 . '<td>'
				 . '	<input type="text" name="min" size="5" value="' . $row->min . '" />'
				 . '</td>'
				 . '<td class="key">' . JText::_('CC MAXIMUM CHARACTERS') . '</td>'
				 . '<td>:</td>'
				 . '<td>'
				 . '	<input type="text" name="max" size="5" value="' . $row->max . '" />'
				 . '</td>'
				 . '</tr>';
		return $html;
	}

function newfield()   {
	// Check for request forgeries
	JRequest::checkToken() or jexit( 'Invalid Token' );
	JRequest::setVar('view', 'editfield');
	JRequest::setVar('hidemainmenu', 1);

	$model = $this->getModel('editfield');
	$user = &JFactory::getUser();

	if ($model->isCheckedOut($user->get('id')))
	{
		$this->setRedirect('index.php?option=com_courseman&view=editfields', JText::_('EDITED BY ANOTHER ADMIN'));
	}

	$model->checkout($user->get('id'));

	parent::display();
}

function newgroup()   {

	// Check for request forgeries
	JRequest::checkToken() or jexit( 'Invalid Token' );
	JRequest::setVar('view', 'editfield');
	JRequest::setVar('layout', 'editgroup');
	JRequest::setVar('hidemainmenu', 1);

	$model = $this->getModel('editfield');
	$user = &JFactory::getUser();

	if ($model->isCheckedOut($user->get('id')))
	{
		$this->setRedirect('index.php?option=com_courseman&view=editfields', JText::_('EDITED BY ANOTHER ADMIN'));
	}

	$model->checkout($user->get('id'));

	parent::display();
}

function publish()   {
	// Check for request forgeries
	JRequest::checkToken() or jexit( 'Invalid Token' );
	$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
	JArrayHelper::toInteger($cid);

	if (count( $cid ) < 1) {
		JError::raiseError(500, JText::_( 'Select an item to publish' ) );
	}

	$model = $this->getModel('editfields');

	if(!$model->publish($cid, 1)) {
		echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>\n";
	}

	$this->setRedirect( 'index.php?option=com_courseman&view=editfields' );
}


function unpublish()   {
	// Check for request forgeries
	JRequest::checkToken() or jexit( 'Invalid Token' );
	$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
	JArrayHelper::toInteger($cid);

	if (count( $cid ) < 1) {
		JError::raiseError(500, JText::_( 'Select an item to unpublish' ) );
	}

	$model = $this->getModel('editfields');

	if(!$model->publish($cid, 0)) {
		echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>\n";
	}

	$this->setRedirect( 'index.php?option=com_courseman&view=editfields' );
}


}