<?php
/**
* @Copyright Copyright (C) 2010 www.profinvent.com. All rights reserved.
* @website http://www.profinvent.com
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 2 of the License, or
* any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
**/

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.controller');

/**
 * Courseman Component Tags Controller
 */
class CoursemanControllerSettings extends CoursemanController
{
	/**
	 * Constructor
	 *
	 * @since 1.0
	 */
	function __construct()
	{
		parent::__construct();

		// Register Extra task
		$this->registerTask( 'add'  ,		 	'edit' );
		$this->registerTask( 'apply', 			'save' );
	}

	/**
	 * logic for cancel an action
	 *
	 * @access public
	 * @return void
	 * @since 1.0
	 */
	function cancel()
	{
		JRequest::checkToken() or jexit( 'Invalid Token' );
		$this->setRedirect( 'index.php?option=com_courseman&view=settings', $msg );
	}

	/**
	 * Logic to create the view for the edit categoryscreen
	 *
	 * @access public
	 * @return void
	 * @since 1.0
	 */
	function edit( )
	{
		JRequest::setVar( 'view', 'tag' );
		JRequest::setVar( 'hidemainmenu', 1 );

		$model 	= $this->getModel('tag');
		$user	=& JFactory::getUser();

		// Error if checkedout by another administrator
		if ($model->isCheckedOut( $user->get('id') )) {
			$this->setRedirect( 'index.php?option=com_courseman&view=tags', JText::_( 'EDITED BY ANOTHER ADMIN' ) );
		}

		$model->checkout( $user->get('id') );

		parent::display();
	}

	/**
	 *  Add new Tag from course screen
	 *
	 */
	function addtag(){
		$name 	= JRequest::getString('name', '');
		$model 	= $this->getModel('tag');
		$model->addtag($name);
	}

function editconfig(){
			global $mainframe, $option;

	JHTML::_('behavior.tooltip');

		//initialise variables
		$user 		= & JFactory::getUser();
		$db  		= & JFactory::getDBO();
		$document	= & JFactory::getDocument();
		$lang 		= & JFactory::getLanguage();

	//only superadmins
	if (!($user->get('gid') == 25)) {
		JError::raiseError(403, JText::_("ALERTNOTAUTH"));
	}



			//add css and submenu to document
		$document->addStyleSheet('components/com_courseman/assets/css/coursemanbackend.css');
		if ($lang->isRTL()) {
			$document->addStyleSheet('components/com_courseman/assets/css/coursemanbackend_rtl.css');
    	}

		//create the toolbar
		JToolBarHelper::title( JText::_( 'PARAMETERS' ), 'generic.png' );
		JToolBarHelper::save();
		JToolBarHelper::cancel();


	$query = "SELECT params FROM #__components WHERE link='option=com_courseman' AND parent='0'";
	$db->setQuery($query);
	$jobsparams = $db->loadResult();
	$file 	= JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_courseman' . DS . 'config.xml';
	$params = new JParameter( $jobsparams, $file, 'component' );

	jimport('joomla.html.pane');
	$pane = &JPane::getInstance('sliders', array('allowAllClose' => true));
?>
		<form action="index.php" method="post" name="adminForm">
<?php

	echo $pane->startPane("menu-pane");
		echo $pane->startPanel(JText :: _('General'), "param-page");
	echo $params->render();
	echo $pane->endPanel();

	echo $pane->startPanel(JText :: _('Default Values'), "param-page");
	echo $params->render('params', 'defaults');
	echo $pane->endPanel();

	echo $pane->startPanel(JText :: _('Uploads'), "param-page");
	echo $params->render('params', 'uploads');
	echo $pane->endPanel();

	echo $pane->startPanel(JText :: _('PayPal'), "param-page");
	echo $params->render('params', 'paypal');
	echo $pane->endPanel();

	echo $pane->startPanel(JText :: _('Supported Extensions'), "param-page");
	echo $params->render('params', 'extension_support');
	echo $pane->endPanel();

	echo $pane->endPane();

?>
	<input type="hidden" name="option" value="<?php echo $option; ?>" />
	<input type="hidden" name="controller" value="settings" />
	<input type="hidden" name="task" value="" />
	<input type="hidden" name="boxchecked" value="0" />
	<?php echo JHTML::_( 'form.token' ); ?>
	</form>
<?php }

function save()
{
			// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
	global $mainframe;
	$params = JRequest::getVar( 'params', array(), 'post', 'array' );
	if (is_array( $params )) {
		$txt = array();
		foreach ( $params as $k=>$v) {
			$txt[] = "$k=$v";
		}
		$params = implode( "\n", $txt );

		$db =& JFactory::getDBO();
		$params = $db->Quote($params);
		$query = "UPDATE #__components SET params=".$params." WHERE link='option=com_courseman' AND parent=0";
		$db->setQuery($query);
		$db->query();
	}

	$msg	= JText::_( 'Parameters are saved' );
	$link	= 'index.php?option=com_courseman&view=settings';
	$mainframe->redirect( $link, $msg );
	return true;
}

	/**
	 * logic for uploading data to db
	 *
	 * @access public
	 * @return void
	 * @since 1.0
	 */
	function uploadcsv()
	{
		// Check for request forgeries
		//JRequest::checkToken() or jexit( 'Invalid Token' );
 	global $mainframe;
	$fcontents 	= JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_courseman' . DS . 'classes'. DS . 'Quick_CSV_import.php';


  for($i=0; $i<sizeof($fcontents); $i++) {
      $line = trim($fcontents[$i]);
      $arr = explode("\t", $line);
      #if your data is comma separated
      # instead of tab separated,
      # change the '\t' above to ','

		$db =& JFactory::getDBO();
		$query = "INSERT INTO #__courseman_test values ('".
                  implode("','", $arr) ."')";
		$db->setQuery($query);

     if (!$db->query()) {
   	$msg	= JText::_( 'Could not import the data' );
	$link	= 'index.php?option=com_courseman&view=settings';
	$mainframe->redirect( $link, $msg );
			}
	}


	$msg	= JText::_( 'Data was imported' );
	$link	= 'index.php?option=com_courseman&view=settings';
	$mainframe->redirect( $link, $msg );
	}
}