<?php
/**
* @Copyright Copyright (C) 2010 www.profinvent.com. All rights reserved.
* @website http://www.profinvent.com
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 2 of the License, or
* any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
**/

defined('_JEXEC') or die('Restricted access');
jimport('joomla.application.component.controller');

class coursemanControllertutor extends coursemanController
{

    function __construct($config = array())
    {
        parent::__construct($config);

        $this->registerTask('add', 'display');
        $this->registerTask('edit', 'display');
        $this->childviewname = 'tutor';
        $this->parentviewname = 'tutors';
    }

    function display()
    {
        switch ($this->getTask())
        {
            case 'add':
                {
                    JRequest::setVar('hidemainmenu', 1);
                    JRequest::setVar('layout', 'form');
                    JRequest::setVar('view', $this->childviewname);
                    JRequest::setVar('edit', false);

                    $model = $this->getModel($this->childviewname);
                    $model->checkout();
                }

                break;
            case 'edit':
                {
                    JRequest::setVar('hidemainmenu', 1);
                    JRequest::setVar('layout', 'form');
                    JRequest::setVar('view', $this->childviewname);
                    JRequest::setVar('edit', true);

                    $model = $this->getModel($this->childviewname);
                    $model->checkout();
                }

                break;
        }

        parent::display();
    }


    function save()
    {
        global $mainframe;

        JRequest::checkToken() or jexit('Invalid Token');

        $db = &JFactory::getDBO();
        $row = &JTable::getInstance('tutor', 'Table');
        $post = JRequest::get('post');
    	$model = $this->getModel($this->childviewname);
        $id = (!empty($post['id'])) ? (int)$post['id'] : 0;
        $row->load($id);

        if (!$row->bind($post))
        {
            JError::raiseError(500, $row->getError());
        }

        if (!$row->check())
        {
            JError::raiseError(500, $row->getError());
        }

        if (!$row->id)
        {
            $where = "id = " . (int)$row->id;
        }

        $file = JRequest::getVar('logofilename', null, 'files', 'array');
    	if (!$row->logofilename = $model->UploadImage($file))
    	{
    		$msg = JText::_('No image was uploaded.');
    	}


        if (!$row->store())
        {
            JError::raiseError(500, $row->getError());
        }


        $row->checkin();

        $msg = $msg . JText::_('Tutor is saved');
        if ($credit > 0)
        {
            $msg .= $msg_credit;
        }

        $link = 'index.php?option=com_courseman&view=tutors';
        $mainframe->redirect($link, $msg);

    }


    function remove()
    {

        JRequest::checkToken() or jexit('Invalid Token');
        $cid = JRequest::getVar('cid', array(), 'post', 'array');
        JArrayHelper::toInteger($cid);

        if (count($cid) < 1)
        {
            JError::raiseError(500, JText::_('Select an course to delete'));
        }

        $model = $this->getModel($this->childviewname);

        if (!$model->delete($cid))
        {
            echo "<script> alert('" . $model->getError(true) .
                "'); window.history.go(-1); </script>\n";
        }
        $msg = JText::_('Operation was successfull');
        $this->setRedirect('index.php?option=com_courseman&view=' . $this->parentviewname,
            $msg);
    }


    function publish()
    {

        JRequest::checkToken() or jexit('Invalid Token');
        $cid = JRequest::getVar('cid', array(), 'post', 'array');
        JArrayHelper::toInteger($cid);

        if (count($cid) < 1)
        {
            JError::raiseError(500, JText::_('Select an course to publish'));
        }

        $model = $this->getModel($this->childviewname);

        if (!$model->publish($cid, 0))
        {
            echo "<script> alert('" . $model->getError(true) .
                "'); window.history.go(-1); </script>\n";
        }

        $this->setRedirect('index.php?option=com_courseman&view=' . $this->parentviewname);
    }


    function unpublish()
    {

        JRequest::checkToken() or jexit('Invalid Token');
        $cid = JRequest::getVar('cid', array(), 'post', 'array');
        JArrayHelper::toInteger($cid);

        if (count($cid) < 1)
        {
            JError::raiseError(500, JText::_('Select an course to unpublish'));
        }

        $model = $this->getModel($this->childviewname);

        if (!$model->publish($cid, 1))
        {
            echo "<script> alert('" . $model->getError(true) .
                "'); window.history.go(-1); </script>\n";
        }

        $this->setRedirect('index.php?option=com_courseman&view=' . $this->parentviewname);
    }


    function cancel()
    {

        JRequest::checkToken() or jexit('Invalid Token');

        $model = $this->getModel($this->childviewname);
        $model->checkin();
        $this->setRedirect('index.php?option=com_courseman&view=' . $this->parentviewname);
    }


    function orderup()
    {

        JRequest::checkToken() or jexit('Invalid Token');
        $model = $this->getModel($this->childviewname);
        $model->move(-1);
        $this->setRedirect('index.php?option=com_courseman&view=' . $this->parentviewname);
    }


    function orderdown()
    {

        JRequest::checkToken() or jexit('Invalid Token');
        $model = $this->getModel($this->childviewname);
        $model->move(1);
        $this->setRedirect('index.php?option=com_courseman&view=' . $this->parentviewname);
    }


    function saveorder()
    {

        JRequest::checkToken() or jexit('Invalid Token');
        $cid = JRequest::getVar('cid', array(), 'post', 'array');
        $order = JRequest::getVar('order', array(), 'post', 'array');
        JArrayHelper::toInteger($cid);
        JArrayHelper::toInteger($order);
        $model = $this->getModel($this->childviewname);
        $model->saveorder($cid, $order);
        $msg = 'New ordering saved';
        $this->setRedirect('index.php?option=com_courseman&view=' . $this->parentviewname,
            $msg);
    }

    function goback()
    {

        JRequest::checkToken() or jexit('Invalid Token');

        $this->setRedirect('index.php?option=com_courseman&view=settings');
    }


}

?>