<?php
/**
* @Copyright Copyright (C) 2010 www.profinvent.com. All rights reserved.
* @website http://www.profinvent.com
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 2 of the License, or
* any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
**/

defined('_JEXEC') or die('Restricted access');

class JHTMLCourseman
{

    function getVersion($defaultVer)
    {

        $version = $defaultVer;
        $xmlFN = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_courseman' . DS .
            'courseman.xml';
        if (file_exists($xmlFN))
        {
            $xmltokens = JApplicationHelper::parseXMLInstallFile($xmlFN);
            if (is_array($xmltokens))
            {
                if (isset($xmltokens{'version'}))
                {
                    $version = $xmltokens{'version'};
                }
            }
        }
        return $version;
    }

    function getSelectUser($var, $default, $disabled)
    {
        global $mainframe;
        $db = &JFactory::getDBO();

        $option = '';
        if ($disabled == 1)
            $option = 'disabled';

        if ($default == '')
            $default = '0';


        $query = 'select id as value, CONCAT_WS(\' / \', username, name, id ) as text from #__users ORDER BY username';
        $db->setQuery($query);
        $users = $db->loadObjectList();

        $types[] = JHTML::_('select.option', '0', '- ' . JText::_('Select User') . ' -');
        foreach ($users as $course)
        {
            $types[] = JHTML::_('select.option', $course->value, JText::_($course->text));
        }

        if ($disabled == 1)
        {
            $disabled = 'disabled';
        }

        $lists = JHTML::_('select.genericlist', $types, $var,
            'class="inputbox" size="1" ' . $disabled . '', 'value', 'text', $default);
        return $lists;

    }

    function getSalutation($var, $default, $disabled)
    {
        global $mainframe;
        $db = &JFactory::getDBO();

        $option = '';
        if ($disabled == 1)
            $option = 'disabled';

        $query = 'select id as value, salutation as text from #__courseman_salutation';
        $db->setQuery($query);
        $users = $db->loadObjectList();

        $types[] = JHTML::_('select.option', '0', '- ' . JText::_('Salutation') . ' -');
        foreach ($users as $course)
        {
            $types[] = JHTML::_('select.option', $course->value, JText::_($course->text));
        }

        $lists = JHTML::_('select.genericlist', $types, $var,
            'class="inputbox" size="1" ' . $option . '', 'value', 'text', $default);

        return $lists;
    }

    function getSelectCountry($var, $default, $disabled)
    {
        global $mainframe;
        $db = &JFactory::getDBO();

        $option = '';
        if ($disabled == 1)
            $option = 'disabled';

        if ($default == '')
            $default = '0';

        $query = 'select id as value, title as text from #__courseman_country order by title';
        $db->setQuery($query);
        $countries = $db->loadObjectList();

        $types[] = JHTML::_('select.option', '0', '- ' . JText::_('Select Country') .
            ' -');
        foreach ($countries as $course)
        {
            $types[] = JHTML::_('select.option', $course->value, JText::_($course->text));
        }

        $lists = JHTML::_('select.genericlist', $types, $var,
            'class="inputbox" size="1" ' . $option . '', 'value', 'text', $default);

        return $lists;

    }

	function getSelectExperienceLevel($var, $default, $disabled)
	{
		global $mainframe;
		$db = &JFactory::getDBO();

		$option = '';
		if ($disabled == 1)
			$option = 'disabled';

		$query = 'select id as value, title as text from #__courseman_experience_level';
		$db->setQuery($query);
		$users = $db->loadObjectList();

		$types[] = JHTML::_('select.option', '0', '- ' . JText::_('Degree Level') . ' -');
		foreach ($users as $course)
		{
			$types[] = JHTML::_('select.option', $course->value, JText::_($course->text));
		}

		$lists = JHTML::_('select.genericlist', $types, $var,
		    'class="inputbox" size="1" ' . $option . '', 'value', 'text', $default);

		return $lists;
	}

	function getSelectATGroup($var, $default, $disabled)
	{
		global $mainframe;
		$db = &JFactory::getDBO();

		$option = '';
		if ($disabled == 1)
			$option = 'disabled';

		$query = 'select id as value, title as text from #__courseman_atgroup';
		$db->setQuery($query);
		$users = $db->loadObjectList();

		$types[] = JHTML::_('select.option', '0', '- ' . JText::_('Attendee Group') .
		    ' -');
		foreach ($users as $course)
		{
			$types[] = JHTML::_('select.option', $course->value, JText::_($course->text));
		}

		$lists = JHTML::_('select.genericlist', $types, $var,
		    'class="inputbox" size="1" ' . $option . '', 'value', 'text', $default);

		return $lists;
	}

    function getSelectCompType($var, $default, $disabled)
    {

        global $mainframe;
        $db = &JFactory::getDBO();

        $option = '';
        if ($disabled == 1)
            $option = 'disabled';

        $query = 'select id as value, title as text from #__courseman_company_type order by ordering';
        $db->setQuery($query);
        $users = $db->loadObjectList();

        $types[] = JHTML::_('select.option', '0', '- ' . JText::_('Select Company Type') .
            ' -');
        foreach ($users as $course)
        {
            $types[] = JHTML::_('select.option', $course->value, JText::_($course->text));
        }

        $lists = JHTML::_('select.genericlist', $types, $var,
            'class="inputbox" size="1" ' . $option . '', 'value', 'text', $default);

        return $lists;
    }

    function YesNo($name, $value = 'y')
    {
        $put[] = JHTML::_('select.option', 'n', JText::_('No'));
        $put[] = JHTML::_('select.option', 'y', JText::_('Yes'));
        $yesno = JHTML::_('select.radiolist', $put, $name, '', 'value', 'text', $value);
        return $yesno;
    }

    function getSelectTutor($var, $default, $disabled)
    {
        global $mainframe;
        $db = &JFactory::getDBO();

        $option = '';
        if ($disabled == 1)
            $option = 'disabled';

        if ($default == '')
            $default = '0';

        $query = 'select id as value, CONCAT_WS(\' / \', title, lastname, id ) as text from #__courseman_tutor ORDER BY title';
        $db->setQuery($query);
        $users = $db->loadObjectList();

        $types[] = JHTML::_('select.option', '0', '- ' . JText::_('Select Tutor') .
            ' -');
        foreach ($users as $course)
        {
            $types[] = JHTML::_('select.option', $course->value, JText::_($course->text));
        }

        if ($disabled == 1)
        {
            $disabled = 'disabled';
        }

        $lists = JHTML::_('select.genericlist', $types, $var,
            'class="inputbox" size="1" ' . $disabled . '', 'value', 'text', $default);
        return $lists;

    }

    function getVirtualTable()
    {
        global $mainframe;
        $document = &JFactory::getDocument();

        $parser = &JFactory::getXMLParser('Simple');

        $pathToXML_File = JPATH_COMPONENT_ADMINISTRATOR . DS . 'tables' . DS .
            'virtual_tables.xml';
        $parser->loadFile($pathToXML_File);
        $document = &$parser->document;

        $tables = &$document->table;
        return $tables;
    }

    function getTableFromXML($tableTitle)
    {
        global $mainframe;
        $document = &JFactory::getDocument();
        $this->tables = JHTMLCourseman::getVirtualTable();

        for ($i = 0, $c = count($this->tables); $i < $c; $i++)
        {

            $album = &$this->tables[$i];
            $name = &$album->getElementByPath('title');
            if ($name->data() == $tableTitle)
            {
                if ($values = &$album->getElementByPath('values'))
                {

                    $listing = &$values->value;


                    for ($ti = 0, $tc = count($listing); $ti < $tc; $ti++)
                    {

                        $value = &$listing[$ti];
                        $XMLvalue[$ti] = $value->data();


                    }

                }
                return $XMLvalue;
            }
        }
    }

    function getListFromXML($tableTitle, $db_field, $disabled, $default)
    {
        $values = JHTMLCourseman::getTableFromXML($tableTitle);

        $option = '';
        if ($disabled == 1)
            $option = 'disabled';

        $options[] = JHTML::_('select.option', '', '- ' . JText::_($tableTitle) . ' -');
        foreach ($values as $course)
        {
            $options[] = JHTML::_('select.option', $course, JText::_($course));
        }

        $lists = JHTML::_('select.genericlist', $options, $db_field,
            'class="inputbox" size="1"' . $option . '', 'value', 'text', $default);

        return $lists;
    }

}