CREATE TABLE IF NOT EXISTS `#__courseman_application` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `course_id` int(11) NOT NULL,
  `user_id` int(11) NOT NULL DEFAULT '0',
  `status` int(11) NOT NULL,
  `first_name` varchar(255) NOT NULL DEFAULT '',
  `last_name` varchar(255) NOT NULL DEFAULT '',
  `salutation` varchar(11) NOT NULL,
  `email` varchar(100) NOT NULL,
  `attendees` double NOT NULL,
  `price_per_attendee` double NOT NULL,
  `price_total` double NOT NULL,
  `comments` text NOT NULL,
  `date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `hits` int(11) NOT NULL DEFAULT '0',
  `checked_out` int(11) NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `archived` tinyint(1) NOT NULL DEFAULT '0',
  `approved` tinyint(1) NOT NULL DEFAULT '0',
  `params` text NOT NULL,
  `published` tinyint(4) NOT NULL DEFAULT '0',
  `transaction_id` varchar(32) NOT NULL,
  `coupon_discount` double NOT NULL,
  `coupon_code` varchar(32) NOT NULL,
  `order_discount` double NOT NULL,
  `order_tax` double NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM;

CREATE TABLE IF NOT EXISTS `#__courseman_atgroup` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(100) DEFAULT NULL,
  `alias` varchar(100) NOT NULL,
  `code` char(2) DEFAULT NULL,
  `color` varchar(7) NOT NULL,
  `description` text,
  `date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `hits` int(11) NOT NULL DEFAULT '0',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(11) NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `archived` tinyint(1) NOT NULL DEFAULT '0',
  `approved` tinyint(1) NOT NULL DEFAULT '0',
  `params` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `name` (`title`)
) ENGINE=MyISAM;

CREATE TABLE IF NOT EXISTS `#__courseman_categories` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `parent_id` int(11) unsigned NOT NULL DEFAULT '0',
  `title` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) NOT NULL DEFAULT '',
  `text` mediumtext NOT NULL,
  `meta_keywords` text NOT NULL,
  `meta_description` text NOT NULL,
  `image` text NOT NULL,
  `icon` text NOT NULL,
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(11) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `access` int(11) unsigned NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM;

CREATE TABLE IF NOT EXISTS `#__courseman_cats_course_relations` (
  `catid` int(11) NOT NULL DEFAULT '0',
  `courseid` int(11) NOT NULL DEFAULT '0',
  `ordering` tinyint(11) NOT NULL,
  PRIMARY KEY (`catid`,`courseid`),
  KEY `catid` (`catid`),
  KEY `itemid` (`courseid`)
) ENGINE=MyISAM;

CREATE TABLE IF NOT EXISTS `#__courseman_company_type` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(100) DEFAULT NULL,
  `alias` varchar(100) NOT NULL,
  `code` char(2) DEFAULT NULL,
  `description` text,
  `date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `hits` int(11) NOT NULL DEFAULT '0',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(11) NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `archived` tinyint(1) NOT NULL DEFAULT '0',
  `approved` tinyint(1) NOT NULL DEFAULT '0',
  `params` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `name` (`title`)
) ENGINE=MyISAM;

CREATE TABLE IF NOT EXISTS `#__courseman_country` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `loc` char(2) DEFAULT NULL,
  `code` char(2) DEFAULT NULL,
  `title` varchar(100) DEFAULT NULL,
  `alias` varchar(100) NOT NULL,
  `description` text,
  `date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `hits` int(11) NOT NULL DEFAULT '0',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(11) NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `archived` tinyint(1) NOT NULL DEFAULT '0',
  `approved` tinyint(1) NOT NULL DEFAULT '0',
  `params` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `name` (`title`),
  KEY `code` (`code`)
) ENGINE=MyISAM;

INSERT INTO `#__courseman_country` (`id`, `loc`, `code`, `title`, `alias`, `description`, `date`, `hits`, `published`, `checked_out`, `checked_out_time`, `ordering`, `archived`, `approved`, `params`) VALUES
(3, 'AF', 'BF', 'Burkina Faso', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 151, 0, 0, ''),
(5, 'AF', 'CM', 'Cameroon', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 137, 0, 0, ''),
(6, 'AF', 'CV', 'Cape Verde', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 136, 0, 0, ''),
(7, 'AF', 'CF', 'Central African Republic', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 135, 0, 0, ''),
(8, 'AF', 'TD', 'Chad', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 134, 0, 0, ''),
(9, 'AF', 'KM', 'Comoros', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 133, 0, 0, ''),
(10, 'AF', 'CG', 'Congo', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 132, 0, 0, ''),
(12, 'AF', 'BJ', 'Benin', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 131, 0, 0, ''),
(14, 'AF', 'BI', 'Burundi', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 130, 0, 0, ''),
(21, 'AF', 'CI', 'Cote DIvorie', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 129, 0, 0, ''),
(22, 'AF', 'DJ', 'Djibouti', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 128, 0, 0, ''),
(23, 'AF', 'GQ', 'Equatorial Guinea', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 138, 0, 0, ''),
(24, 'AF', 'ER', 'Eritrea', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 139, 0, 0, ''),
(25, 'AF', 'ET', 'Ethiopia', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 140, 0, 0, ''),
(26, 'AF', 'EG', 'Egypt', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 150, 0, 0, ''),
(27, 'AF', 'GA', 'Gabon', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 149, 0, 0, ''),
(28, 'AF', 'GH', 'Ghana', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 148, 0, 0, ''),
(29, 'AF', 'GN', 'Guinea', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 147, 0, 0, ''),
(30, 'AF', 'GM', 'Gambia', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 146, 0, 0, ''),
(31, 'AF', 'GW', 'Guinea-Bissau', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 145, 0, 0, ''),
(32, 'AF', 'KE', 'Kenya', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 144, 0, 0, ''),
(33, 'AF', 'LS', 'Lesotho', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 143, 0, 0, ''),
(34, 'AF', 'LR', 'Liberia', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 142, 0, 0, ''),
(35, 'AF', 'MG', 'Madagascar', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 141, 0, 0, ''),
(36, 'AF', 'ML', 'Mali', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 127, 0, 0, ''),
(37, 'AF', 'MR', 'Mauritania', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 126, 0, 0, ''),
(38, 'AF', 'YT', 'Mayotte', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 112, 0, 0, ''),
(39, 'AF', 'MA', 'Morocco', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 111, 0, 0, ''),
(40, 'AF', 'MZ', 'Mozambique', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 110, 0, 0, ''),
(41, 'AF', 'MW', 'Malawi', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 109, 0, 0, ''),
(42, 'AF', 'NA', 'Namibia', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 108, 0, 0, ''),
(43, 'AF', 'NE', 'Niger', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 107, 0, 0, ''),
(44, 'AF', 'NG', 'Nigeria', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 106, 0, 0, ''),
(45, 'AF', 'RE', 'Reunion', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 105, 0, 0, ''),
(46, 'AF', 'SH', 'St. Helena', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 104, 0, 0, ''),
(47, 'AF', 'ST', 'Sao Tome and Principe', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 103, 0, 0, ''),
(48, 'AF', 'SN', 'Senegal', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 113, 0, 0, ''),
(49, 'AF', 'SL', 'Sierra Leone', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 114, 0, 0, ''),
(50, 'AF', 'SO', 'Somalia', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 115, 0, 0, ''),
(51, 'AF', 'ZA', 'South Africa', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 125, 0, 0, ''),
(52, 'AF', 'SD', 'Sudan', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 124, 0, 0, ''),
(53, 'AF', 'SZ', 'Swaziland', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 123, 0, 0, ''),
(54, 'AF', 'TZ', 'Tanzania', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 122, 0, 0, ''),
(55, 'AF', 'TG', 'Togo', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 121, 0, 0, ''),
(56, 'AF', 'UG', 'Uganda', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 120, 0, 0, ''),
(57, 'AF', 'EH', 'Western Sahara', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 119, 0, 0, ''),
(58, 'AF', 'ZR', 'Zaire', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 118, 0, 0, ''),
(59, 'AF', 'ZM', 'Zambia', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 117, 0, 0, ''),
(60, 'AF', 'ZW', 'Zimbabwe', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 116, 0, 0, ''),
(62, 'AS', 'AF', 'Afghanistan', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 102, 0, 0, ''),
(63, 'AS', 'BD', 'Bangladesh', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 152, 0, 0, ''),
(64, 'AS', 'BT', 'Bhutan', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 202, 0, 0, ''),
(65, 'AS', 'BN', 'Brunei', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 188, 0, 0, ''),
(66, 'AS', 'KH', 'Cambodia', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 187, 0, 0, ''),
(67, 'AS', 'CN', 'China', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 186, 0, 0, ''),
(68, 'AS', 'HK', 'Hong Kong', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 185, 0, 0, ''),
(69, 'AS', 'IN', 'India', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 184, 0, 0, ''),
(70, 'AS', 'ID', 'Indonesia', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 183, 0, 0, ''),
(71, 'AS', 'JP', 'Japan', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 182, 0, 0, ''),
(72, 'AS', 'KZ', 'Kazakhstan', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 181, 0, 0, ''),
(73, 'AS', 'KG', 'Kyrgyzstan', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 180, 0, 0, ''),
(74, 'AS', 'LA', 'Laos', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 179, 0, 0, ''),
(75, 'AS', 'MO', 'Macau', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 189, 0, 0, ''),
(76, 'AS', 'MY', 'Malaysia', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 190, 0, 0, ''),
(77, 'AS', 'MV', 'Maldives', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 191, 0, 0, ''),
(78, 'AS', 'MN', 'Mongolia', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 201, 0, 0, ''),
(79, 'AS', 'NP', 'Nepal', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 200, 0, 0, ''),
(80, 'AS', 'PK', 'Pakistan', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 199, 0, 0, ''),
(81, 'AS', 'PH', 'Philippines', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 198, 0, 0, ''),
(82, 'AS', 'KR', 'Republic of Korea', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 197, 0, 0, ''),
(83, 'AS', 'RU', 'Russia', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 196, 0, 0, ''),
(84, 'AS', 'SC', 'Seychelles', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 195, 0, 0, ''),
(85, 'AS', 'SG', 'Singapore', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 194, 0, 0, ''),
(86, 'AS', 'LK', 'Sri Lanka', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 193, 0, 0, ''),
(87, 'AS', 'TW', 'Taiwan', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 192, 0, 0, ''),
(88, 'AS', 'TJ', 'Tajikistan', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 178, 0, 0, ''),
(89, 'AS', 'TH', 'Thailand', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 177, 0, 0, ''),
(90, 'AS', 'TM', 'Turkmenistan', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 163, 0, 0, ''),
(91, 'AS', 'UZ', 'Uzbekistan', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 162, 0, 0, ''),
(92, 'AS', 'VN', 'Vietnam', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 161, 0, 0, ''),
(94, 'AU', 'AU', 'Australia', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 160, 0, 0, ''),
(95, 'AU', 'FM', 'Federated States of Micronesia', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 159, 0, 0, ''),
(96, 'AU', 'FJ', 'Fiji', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 158, 0, 0, ''),
(97, 'AU', 'PF', 'French Polynesia', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 157, 0, 0, ''),
(98, 'AU', 'GU', 'Guam', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 156, 0, 0, ''),
(99, 'AU', 'KI', 'Kiribati', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 155, 0, 0, ''),
(100, 'AU', 'MH', 'Marshall Islands', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 154, 0, 0, ''),
(101, 'AU', 'NR', 'Nauru', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 164, 0, 0, ''),
(102, 'AU', 'NC', 'New Caledonia', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 165, 0, 0, ''),
(103, 'AU', 'NZ', 'New Zealand', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 166, 0, 0, ''),
(104, 'AU', 'MP', 'Northern Mariana Islands', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 176, 0, 0, ''),
(105, 'AU', 'PW', 'Palau', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 175, 0, 0, ''),
(106, 'AU', 'PG', 'Papua New Guinea', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 174, 0, 0, ''),
(107, 'AU', 'PN', 'Pitcairn', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 173, 0, 0, ''),
(108, 'AU', 'SB', 'Solomon Islands', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 172, 0, 0, ''),
(109, 'AU', 'TO', 'Tonga', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 171, 0, 0, ''),
(110, 'AU', 'TV', 'Tuvalu', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 170, 0, 0, ''),
(111, 'AU', 'VU', 'Vanuatu', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 169, 0, 0, ''),
(112, 'CA', 'AI', 'Anguilla', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 168, 0, 0, ''),
(114, 'CA', 'AW', 'Aruba', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 167, 0, 0, ''),
(115, 'CA', 'BS', 'Bahamas', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 153, 0, 0, ''),
(116, 'CA', 'BB', 'Barbados', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 50, 0, 0, ''),
(117, 'CA', 'BM', 'Bermuda', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 36, 0, 0, ''),
(118, 'CA', 'VI', 'British Virgin Islands', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 35, 0, 0, ''),
(119, 'CA', 'KY', 'Cayman Islands', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 34, 0, 0, ''),
(120, 'CA', 'DM', 'Dominica', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 33, 0, 0, ''),
(121, 'CA', 'DO', 'Dominican Republic', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 32, 0, 0, ''),
(122, 'CA', 'GD', 'Grenada', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 31, 0, 0, ''),
(123, 'CA', 'GP', 'Guadeloupe', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 30, 0, 0, ''),
(124, 'CA', 'HT', 'Haiti', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 29, 0, 0, ''),
(125, 'CA', 'JM', 'Jamaica', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 28, 0, 0, ''),
(126, 'CA', 'MQ', 'Martinique', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 27, 0, 0, ''),
(127, 'CA', 'AN', 'Neterlands Antilles', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 37, 0, 0, ''),
(128, 'CA', 'PR', 'Puerto Rico', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 38, 0, 0, ''),
(129, 'CA', 'KN', 'St. Kitts and Nevis', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 39, 0, 0, ''),
(130, 'CA', 'LC', 'St. Lucia', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 49, 0, 0, ''),
(131, 'CA', 'VC', 'St. Vincent and the Grenadines', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 48, 0, 0, ''),
(132, 'CA', 'TT', 'Trinidad and Tobago', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 47, 0, 0, ''),
(133, 'CA', 'TC', 'Turks and Caicos Islands', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 46, 0, 0, ''),
(134, 'CE', 'BZ', 'Belize', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 45, 0, 0, ''),
(135, 'CE', 'CR', 'Costa Rica', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 44, 0, 0, ''),
(136, 'CE', 'SV', 'El Salvador', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 43, 0, 0, ''),
(137, 'CE', 'GT', 'Guatemala', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 42, 0, 0, ''),
(138, 'CE', 'HN', 'Honduras', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 41, 0, 0, ''),
(139, 'CE', 'NI', 'Nicaragua', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 40, 0, 0, ''),
(140, 'CE', 'PA', 'Panama', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 26, 0, 0, ''),
(143, 'CE', 'AM', 'Armenia', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 25, 0, 0, ''),
(144, 'CE', 'AT', 'Austria', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 11, 0, 0, ''),
(145, 'CE', 'AZ', 'Azerbaijan', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 10, 0, 0, ''),
(146, 'CE', 'BY', 'Belarus', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 9, 0, 0, ''),
(147, 'CE', 'BE', 'Belgium', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 8, 0, 0, ''),
(148, 'CE', 'BG', 'Bulgaria', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 7, 0, 0, ''),
(149, 'CE', 'HR', 'Croatia', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 6, 0, 0, ''),
(150, 'CE', 'CY', 'Cyprus', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 5, 0, 0, ''),
(151, 'CE', 'CZ', 'Czech Republic', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 4, 0, 0, ''),
(152, 'CE', 'DK', 'Denmark', 'denmark', '', '2009-11-22 02:08:00', 0, 1, 0, '0000-00-00 00:00:00', 3, 0, 0, ''),
(153, 'CE', 'EE', 'Estonia', 'estonia', '', '2009-11-22 02:08:09', 0, 1, 0, '0000-00-00 00:00:00', 2, 0, 0, ''),
(154, 'CE', 'FO', 'Faroe Islands', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 12, 0, 0, ''),
(155, 'CE', 'FI', 'Finland', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 13, 0, 0, ''),
(156, 'CE', 'FR', 'France', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 14, 0, 0, ''),
(157, 'CE', 'GE', 'Georgia', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 24, 0, 0, ''),
(158, 'CE', 'DE', 'Germany', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 23, 0, 0, ''),
(159, 'CE', 'GI', 'Gibraltar', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 22, 0, 0, ''),
(160, 'CE', 'GR', 'Greece', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 21, 0, 0, ''),
(161, 'CE', 'GL', 'Greenland', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 20, 0, 0, ''),
(162, 'CE', 'HU', 'Hungary', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 19, 0, 0, ''),
(163, 'CE', 'IS', 'Iceland', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 18, 0, 0, ''),
(164, 'CE', 'IE', 'Ireland', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 17, 0, 0, ''),
(165, 'CE', 'IT', 'Italy', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 16, 0, 0, ''),
(166, 'CE', 'LV', 'Latvia', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 15, 0, 0, ''),
(167, 'CE', 'LI', 'Liechtenstein', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 1, 0, 0, ''),
(168, 'CE', 'LT', 'Lithuania', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 51, 0, 0, ''),
(169, 'CE', 'LU', 'Luxembourg', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 101, 0, 0, ''),
(170, 'CE', 'MT', 'Malta', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 87, 0, 0, ''),
(171, 'CE', 'FX', 'Metropolitan France', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 86, 0, 0, ''),
(172, 'CE', 'MD', 'Moldova', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 85, 0, 0, ''),
(173, 'CE', 'NL', 'Netherlands', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 84, 0, 0, ''),
(174, 'CE', 'NO', 'Norway', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 83, 0, 0, ''),
(175, 'CE', 'PL', 'Poland', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 82, 0, 0, ''),
(176, 'CE', 'PT', 'Portugal', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 81, 0, 0, ''),
(177, 'CE', 'RO', 'Romania', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 80, 0, 0, ''),
(178, 'CE', 'SK', 'Slovakia', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 79, 0, 0, ''),
(179, 'CE', 'SI', 'Slovenia', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 78, 0, 0, ''),
(180, 'CE', 'ES', 'Spain', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 88, 0, 0, ''),
(181, 'CE', 'SJ', 'Svalbard and Jan Mayen Islands', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 89, 0, 0, ''),
(182, 'CE', 'SE', 'Sweden', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 90, 0, 0, ''),
(183, 'CE', 'CH', 'Switzerland', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 100, 0, 0, ''),
(184, 'CE', 'MK', 'Republic of Macedonia', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 99, 0, 0, ''),
(185, 'CE', 'TR', 'Turkey', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 98, 0, 0, ''),
(186, 'CE', 'UA', 'Ukraine', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 97, 0, 0, ''),
(187, 'CE', 'GB', 'United Kingdom', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 96, 0, 0, ''),
(188, 'CE', 'VA', 'Vatican City', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 95, 0, 0, ''),
(189, 'CE', 'YU', 'Yugoslavia', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 94, 0, 0, ''),
(190, 'ME', 'IL', 'Israel', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 93, 0, 0, ''),
(191, 'ME', 'JO', 'Jordan', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 92, 0, 0, ''),
(192, 'ME', 'KW', 'Kuwait', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 91, 0, 0, ''),
(193, 'ME', 'LB', 'Lebanon', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 77, 0, 0, ''),
(194, 'ME', 'OM', 'Oman', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 76, 0, 0, ''),
(195, 'ME', 'QA', 'Qatar', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 62, 0, 0, ''),
(196, 'ME', 'SA', 'Saudi Arabia', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 61, 0, 0, ''),
(197, 'ME', 'SY', 'Syria', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 60, 0, 0, ''),
(198, 'ME', 'AE', 'United Arab Emirates', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 59, 0, 0, ''),
(199, 'ME', 'YE', 'Yemen', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 58, 0, 0, ''),
(200, 'NA', 'CA', 'Canada', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 57, 0, 0, ''),
(201, 'NA', 'MX', 'Mexico', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 56, 0, 0, ''),
(202, 'NA', 'US', 'United States', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 55, 0, 0, ''),
(204, 'SA', 'BO', 'Bolivia', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 54, 0, 0, ''),
(205, 'SA', 'BR', 'Brazil', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 53, 0, 0, ''),
(206, 'SA', 'CL', 'Chile', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 63, 0, 0, ''),
(207, 'SA', 'CO', 'Colombia', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 64, 0, 0, ''),
(208, 'SA', 'EC', 'Equador', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 65, 0, 0, ''),
(209, 'SA', 'FK', 'Falkland Islands', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 75, 0, 0, ''),
(210, 'SA', 'GF', 'French Guiana', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 74, 0, 0, ''),
(211, 'SA', 'GY', 'Guyana', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 73, 0, 0, ''),
(212, 'SA', 'PY', 'Paraguay', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 72, 0, 0, ''),
(213, 'SA', 'PE', 'Peru', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 71, 0, 0, ''),
(214, 'SA', 'SR', 'Suriname', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 70, 0, 0, ''),
(215, 'SA', 'UY', 'Uruguay', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 69, 0, 0, ''),
(216, 'SA', 'VE', 'Venezuela', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 68, 0, 0, ''),
(217, 'OT', 'BH', 'Bahrain', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 67, 0, 0, ''),
(218, 'OT', 'BV', 'Bouvet Islands', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 66, 0, 0, ''),
(219, 'OT', 'IO', 'British Indian Ocean Territory', '', NULL, '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 52, 0, 0, ''),
(222, '', '', 'Zakladka', 'zakladka', '', '2009-11-22 17:31:14', 0, 1, 0, '0000-00-00 00:00:00', 203, 0, 0, '');


CREATE TABLE IF NOT EXISTS `#__courseman_coupons` (
  `coupon_id` int(16) NOT NULL AUTO_INCREMENT,
  `coupon_code` varchar(32) NOT NULL DEFAULT '',
  `percent_or_total` varchar(32) NOT NULL DEFAULT 'percent',
  `coupon_type` varchar(32) NOT NULL DEFAULT 'gift',
  `coupon_value` double NOT NULL DEFAULT '0',
  PRIMARY KEY (`coupon_id`)
) ENGINE=MyISAM;


CREATE TABLE IF NOT EXISTS `#__courseman_courses` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `reference_number` varchar(255) NOT NULL,
  `code` varchar(20) NOT NULL DEFAULT '',
  `title` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) NOT NULL DEFAULT '',
  `introtext` mediumtext NOT NULL,
  `fulltext` mediumtext NOT NULL,
  `plus` int(11) DEFAULT '0',
  `minus` int(11) DEFAULT '0',
  `hits` int(11) unsigned NOT NULL DEFAULT '0',
  `version` int(11) unsigned NOT NULL DEFAULT '0',
  `meta_keywords` text NOT NULL,
  `meta_description` text NOT NULL,
  `metadata` text NOT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(11) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` text NOT NULL,
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(11) unsigned NOT NULL DEFAULT '0',
  `attribs` text NOT NULL,
  `checked_out` int(11) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL,
  `state` tinyint(1) NOT NULL DEFAULT '0',
  `ordering` int(11) DEFAULT '0',
  `tutor_id` int(11) DEFAULT NULL,
  `id_group` int(11) NOT NULL,
  `id_experience_level` int(11) NOT NULL DEFAULT '0',
  `price_type` varchar(100) NOT NULL,
  `job_experience` varchar(100) NOT NULL,
  `price` double DEFAULT NULL,
  `currency_price` char(10) DEFAULT NULL,
  `capacity` int(11) NOT NULL DEFAULT '0',
  `location` varchar(100) NOT NULL,
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `url` varchar(250) NOT NULL,
  `image` varchar(255) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM;

CREATE TABLE IF NOT EXISTS `#__courseman_emailtemplate` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `uid` int(11) DEFAULT NULL,
  `templatefor` varchar(50) DEFAULT NULL,
  `title` varchar(50) DEFAULT NULL,
  `subject` varchar(255) DEFAULT NULL,
  `body` text,
  `recipient` varchar(255) NOT NULL,
  `status` tinyint(1) DEFAULT NULL,
  `created` datetime DEFAULT NULL,
  `checked_out` int(11) NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `params` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=9 ;

CREATE TABLE IF NOT EXISTS `#__courseman_experience_level` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(100) DEFAULT NULL,
  `alias` varchar(100) NOT NULL,
  `code` char(2) DEFAULT NULL,
  `color` varchar(7) NOT NULL,
  `description` text,
  `date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `hits` int(11) NOT NULL DEFAULT '0',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(11) NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `archived` tinyint(1) NOT NULL DEFAULT '0',
  `approved` tinyint(1) NOT NULL DEFAULT '0',
  `params` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `name` (`title`),
  KEY `code` (`code`)
) ENGINE=MyISAM;

CREATE TABLE IF NOT EXISTS `#__courseman_favourites` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `courseid` int(11) NOT NULL DEFAULT '0',
  `userid` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`,`courseid`,`userid`),
  KEY `id` (`id`),
  KEY `itemid` (`courseid`),
  KEY `userid` (`userid`)
) ENGINE=MyISAM;

CREATE TABLE IF NOT EXISTS `#__courseman_fields` (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `type` varchar(255) NOT NULL,
  `ordering` int(11) DEFAULT '0',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `min` int(5) NOT NULL,
  `max` int(5) NOT NULL,
  `name` varchar(255) NOT NULL,
  `tips` text NOT NULL,
  `visible` tinyint(1) DEFAULT '0',
  `required` tinyint(1) DEFAULT '0',
  `searchable` tinyint(1) DEFAULT '1',
  `registration` tinyint(1) DEFAULT '1',
  `options` text,
  `fieldcode` varchar(255) NOT NULL,
  `paypalcode` varchar(255) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `fieldcode` (`fieldcode`)
) ENGINE=MyISAM;


CREATE TABLE IF NOT EXISTS `#__courseman_fields_values` (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `applicationid` int(11) NOT NULL,
  `user_id` int(11) NOT NULL,
  `field_id` int(10) NOT NULL,
  `value` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `field_id` (`field_id`),
  KEY `user_id` (`user_id`),
  KEY `idx_user_fieldid` (`user_id`,`field_id`),
  KEY `applicationid` (`applicationid`)
) ENGINE=MyISAM;


CREATE TABLE IF NOT EXISTS `#__courseman_files` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `filename` varchar(255) NOT NULL,
  `altname` varchar(255) NOT NULL,
  `hits` int(11) unsigned NOT NULL DEFAULT '0',
  `uploaded` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `uploaded_by` int(11) unsigned NOT NULL DEFAULT '0',
  `checked_out` int(11) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM;

CREATE TABLE IF NOT EXISTS `#__courseman_files_course_relations` (
  `fileid` int(11) NOT NULL DEFAULT '0',
  `courseid` int(11) NOT NULL DEFAULT '0',
  `ordering` tinyint(11) NOT NULL,
  PRIMARY KEY (`fileid`,`courseid`),
  KEY `fileid` (`fileid`),
  KEY `itemid` (`courseid`)
) ENGINE=MyISAM;

CREATE TABLE IF NOT EXISTS `#__courseman_industry` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `industry` varchar(100) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM;


CREATE TABLE IF NOT EXISTS `#__courseman_job_exp` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(50) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM;



CREATE TABLE IF NOT EXISTS `#__courseman_sessions` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `courseid` int(11) NOT NULL DEFAULT '0',
  `title` varchar(250) NOT NULL DEFAULT '',
  `alias` varchar(250) NOT NULL DEFAULT '',
  `session_date` date NOT NULL DEFAULT '0000-00-00',
  `start_time` time NOT NULL DEFAULT '00:00:00',
  `finish_time` time NOT NULL DEFAULT '00:00:00',
  `duration` double NOT NULL,
  `description` text NOT NULL,
  `session_location` varchar(250) NOT NULL DEFAULT '',
  `date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `hits` int(11) NOT NULL DEFAULT '0',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(11) NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `archived` tinyint(1) NOT NULL DEFAULT '0',
  `params` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `courseid` (`courseid`,`published`,`archived`)
) ENGINE=MyISAM;


CREATE TABLE IF NOT EXISTS `#__courseman_tags` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `alias` varchar(255) NOT NULL,
  `published` tinyint(1) NOT NULL,
  `checked_out` int(11) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM;


CREATE TABLE IF NOT EXISTS `#__courseman_tags_course_relations` (
  `tid` int(11) NOT NULL DEFAULT '0',
  `courseid` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`tid`,`courseid`),
  KEY `tid` (`tid`),
  KEY `itemid` (`courseid`)
) ENGINE=MyISAM;


CREATE TABLE IF NOT EXISTS `#__courseman_tutor` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(11) NOT NULL DEFAULT '0',
  `title` varchar(100) DEFAULT NULL,
  `alias` varchar(100) NOT NULL,
  `code` char(2) DEFAULT NULL,
  `firstname` varchar(100) NOT NULL DEFAULT '',
  `lastname` varchar(100) NOT NULL DEFAULT '',
  `salutation` varchar(11) NOT NULL,
  `other_title` varchar(100) NOT NULL DEFAULT '',
  `comp_name` varchar(100) NOT NULL DEFAULT '',
  `primary_phone` varchar(50) NOT NULL DEFAULT '',
  `fax_number` varchar(50) NOT NULL DEFAULT '',
  `url` varchar(250) NOT NULL DEFAULT '',
  `street` varchar(100) NOT NULL DEFAULT '',
  `id_country` int(11) NOT NULL DEFAULT '0',
  `state` varchar(50) NOT NULL DEFAULT '',
  `city` varchar(50) NOT NULL DEFAULT '',
  `zip` varchar(30) NOT NULL DEFAULT '',
  `id_comp_type` int(11) NOT NULL DEFAULT '0',
  `industry` varchar(100) NOT NULL,
  `description` text,
  `logofilename` varchar(100) DEFAULT NULL,
  `bill_addr` varchar(255) DEFAULT NULL,
  `bill_addr_cont` varchar(255) DEFAULT NULL,
  `bill_id_country` int(11) DEFAULT NULL,
  `bill_state` varchar(50) DEFAULT NULL,
  `bill_city` varchar(100) DEFAULT NULL,
  `bill_zip` varchar(25) DEFAULT NULL,
  `bill_phone` varchar(50) DEFAULT NULL,
  `metadescription` text,
  `metakeywords` text,
  `status` tinyint(1) NOT NULL DEFAULT '0',
  `date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `hits` int(11) NOT NULL DEFAULT '0',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(11) NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `archived` tinyint(1) NOT NULL DEFAULT '0',
  `approved` tinyint(1) NOT NULL DEFAULT '1',
  `params` text NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `user_index` (`user_id`)
) ENGINE=MyISAM;

INSERT INTO `#__courseman_emailtemplate` (`id`, `uid`, `templatefor`, `title`, `subject`, `body`, `recipient`, `status`, `created`, `checked_out`, `checked_out_time`, `params`) VALUES
(1, 0, 'company-approval', NULL, 'Company {COMPANY_NAME} has been approved', '<p>Dear {EMPLOYER_NAME} , aaa<br /><br />Your company <strong>{COMPANY_NAME}</strong> has been approved.</p>\r\n<p>Login and view detail at www.joomshark.com <br /><br />Please do not respond to this message. It is automatically generated and is for information purposes only.</p>', '', 1, '2009-08-17 18:08:41', 0, '0000-00-00 00:00:00', ''),
(2, 0, 'company-rejecting', NULL, 'Your Company {COMPANY_NAME} has been rejected', '<p>Dear  {EMPLOYER_NAME} , </p><p>Your company<strong> {COMPANY_NAME}</strong> has been rejected. </p><p>Login and view detail at www.joomshark.com  </p><p>Please do not respond to this message. It is automatically generated and is for information purposes only. </p>', '', NULL, '2009-08-17 17:54:48', 0, '0000-00-00 00:00:00', ''),
(4, 0, 'job-approval', NULL, 'Your job {JOB_TITLE} has been approved.', '<p>Dear', '', NULL, '2009-08-17 22:10:27', 0, '0000-00-00 00:00:00', ''),
(5, 0, 'job-rejecting', NULL, 'Your job {JOB_TITLE} has been rejected.', '<p>Dear {EMPLOYER_NAME}</p>', '', NULL, '2009-08-17 22:12:43', 0, '0000-00-00 00:00:00', ''),
(6, 0, 'resume-approval', NULL, 'Your resume {RESUME_TITLE} has been approval.', '<p>Dear</p>', '', NULL, '2009-08-17 22:15:12', 0, '0000-00-00 00:00:00', ''),
(7, 0, 'resume-rejecting', NULL, 'Your company {RESUME_TITLE} has been rejected. ', '<p>Dear', '', NULL, '2009-08-17 22:14:52', 0, '0000-00-00 00:00:00', ''),
(8, 0, 'booking-confirmation-user', NULL, 'Application -  {ATTENDEES}  {FIRSTNAME} {LASTNAME} {FIELD_ABOUTME}', '<table class="adminform" border="0" cellspacing="0" cellpadding="5" width="100%">\r\n<tbody>\r\n<tr>\r\n<td>{ADMIN_CUSTOM_RECIPIENT} :RECIPIENT FROM CONFIGURATION</td>\r\n</tr>\r\n<tr>\r\n<td>{ATTENDEES}  :NUMBER OF ATTENDEES</td>\r\n</tr>\r\n<tr>\r\n<td>{SALUTATION} :Salutation</td>\r\n</tr>\r\n<tr>\r\n<td>{FIRSTNAME}  :FIRSTNAME</td>\r\n</tr>\r\n<tr>\r\n<td>{LASTNAME} :Last Name</td>\r\n</tr>\r\n<tr>\r\n<td>{EMAIL_ATTENDEE}  :ATTENDEES EMAIL</td>\r\n</tr>\r\n<tr>\r\n<td>{COURSE} :Course Title</td>\r\n</tr>\r\n<tr>\r\n<td>{COURSE_INTROTEXT}  :Course Introtext</td>\r\n</tr>\r\n<tr>\r\n<td>{COURSE_FULLTEXT} :Course Fulltext</td>\r\n</tr>\r\n<tr>\r\n<td>{COURSE_CAPACITY}  :Course Capacity</td>\r\n</tr>\r\n<tr>\r\n<td>{COURSE_LOCATION} :Course Location</td>\r\n</tr>\r\n<tr>\r\n<td>{COURSE_URL}  :Course Url</td>\r\n</tr>\r\n<tr>\r\n<td>{COURSE_PRICE_PER_ATTENDEE} :Price per  seat</td>\r\n</tr>\r\n<tr>\r\n<td>{COURSE_PRICE_TOTAL} :Total Price</td>\r\n</tr>\r\n<tr>\r\n<td>{COURSE_START_DATE}  :Start Date</td>\r\n</tr>\r\n<tr>\r\n<td>{COURSE_FINISH_DATE} :Finish Date</td>\r\n</tr>\r\n<tr>\r\n<td>{TUTOR}  :Tutor</td>\r\n</tr>\r\n<tr>\r\n<td>{TUTOR_FIRST_NAME} :Tutor First Name</td>\r\n</tr>\r\n<tr>\r\n<td>{TUTOR_LAST_NAME}  :Tutor Last Name</td>\r\n</tr>\r\n<tr>\r\n<td>{GROUP} :Group</td>\r\n</tr>\r\n<tr>\r\n<td>{GROUP_DESC}  :Group Description</td>\r\n</tr>\r\n<tr>\r\n<td>{EXPERIENCE_LEVEL} :Experience  Level</td>\r\n</tr>\r\n<tr>\r\n<td>{EXPERIENCE_LEVEL_DESC} :Experience Level  Description</td>\r\n</tr>\r\n<tr>\r\n<td>{FIELD_ABOUTME} :About me</td>\r\n</tr>\r\n<tr>\r\n<td>{FIELD_ADDRESS}  :Address</td>\r\n</tr>\r\n<tr>\r\n<td>{FIELD_CITY} :City / Town</td>\r\n</tr>\r\n<tr>\r\n<td>{FIELD_COLLEGE}  :College / University</td>\r\n</tr>\r\n<tr>\r\n<td>{FIELD_GRADUATION} :Graduation  Year</td>\r\n</tr>\r\n</tbody>\r\n</table>', '{EMAIL_ATTENDEE}, {ADMIN_CUSTOM_RECIPIENT}', NULL, '2009-08-18 16:46:16', 63, '2010-07-05 11:58:09', 'jobseeker_first_name,jobseeker_last_name,jobseeker_salutation,jobseeker_email,jobseeker_cover_note,jobseeker_phone,employer_name,job_title,job_reference');