<?php
/**
* @Copyright Copyright (C) 2010 www.profinvent.com. All rights reserved.
* @website http://www.profinvent.com
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 2 of the License, or
* any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
**/

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class CoursemanModelCourse extends JModel
{
    var $_course = null;

    function __construct()
    {
        parent::__construct();

        $cid = JRequest::getVar('cid', array(0), '', 'array');
        JArrayHelper::toInteger($cid, array(0));
        $this->setId($cid[0]);
    }

    function setId($id)
    {

        $this->_id = $id;
        $this->_course = null;
    }

    function get($property, $default = null)
    {
        if ($this->_loadCourse())
        {
            if (isset($this->_course->$property))
            {
                return $this->_course->$property;
            }
        }
        return $default;
    }

    function &getCourse()
    {
        if ($this->_loadCourse())
        {
            if (JString::strlen($this->_course->fulltext) > 1)
            {
                $this->_course->text = $this->_course->introtext . "<hr id=\"system-readmore\" />" .
                    $this->_course->fulltext;
            } else
            {
                $this->_course->text = $this->_course->introtext;
            }

            $query = 'SELECT name' . ' FROM #__users' . ' WHERE id = ' . (int)$this->_course->
                created_by;
            $this->_db->setQuery($query);
            $this->_course->creator = $this->_db->loadResult();

            if ($this->_course->created_by == $this->_course->modified_by)
            {
                $this->_course->modifier = $this->_course->creator;
            } else
            {
                $query = 'SELECT name' . ' FROM #__users' . ' WHERE id = ' . (int)$this->_course->
                    modified_by;
                $this->_db->setQuery($query);
                $this->_course->modifier = $this->_db->loadResult();
            }

        } else
            $this->_initCourse();

        return $this->_course;
    }


    function _loadCourse()
    {

        if (empty($this->_course))
        {
            $query = 'SELECT *' . ' FROM #__courseman_courses' . ' WHERE id = ' . $this->_id;
            $this->_db->setQuery($query);
            $this->_course = $this->_db->loadObject();

            return (boolean)$this->_course;
        }
        return true;
    }

    function _initCourse()
    {

        if (empty($this->_course))
        {
            $createdate = &JFactory::getDate();
            $nullDate = $this->_db->getNullDate();

            $course = new stdClass();
            $course->id = 0;
            $course->cid[] = 0;
            $course->reference_number = null;
	    $course->code = null;
            $course->title = null;
            $course->alias = null;
            $course->text = null;
            $course->plus = 0;
            $course->minus = 0;
            $course->hits = 0;
            $course->version = 0;
            $course->meta_description = null;
            $course->meta_keywords = null;
            $course->created = $createdate->toUnix();
            $course->created_by = null;
            $course->created_by_alias = '';
            $course->modified = $nullDate;
            $course->modified_by = null;
            $course->attribs = null;
            $course->metadata = null;
            $course->state = 1;
            $course->job_title = null;
            $course->tutor_id = null;
            $course->id_pos_type = null;
            $course->price_type = null;
            $course->id_experience_level = null;
            $course->job_experience = null;
            $course->id_group = null;
            $course->url = null;
            $course->price = 0;
            $course->currency_price = null;
            $course->capacity = null;
            $course->location = null;
            $course->expire_date = null;
            $createdate = &JFactory::getDate();
            $course->publish_up = $createdate->toUnix();
            $course->publish_down = JText::_('Never');
            $course->expire_down = null;
        	$course->capacity       = null;
            $this->_course = $course;
            $course->email_template = 0;
            return (boolean)$this->_course;
        }
        return true;
    }

    function checkin()
    {
        if ($this->_id)
        {
            $course = &JTable::getInstance('courseman_courses', '');
            return $course->checkin($this->_id);
        }
        return false;
    }

    function checkout($uid = null)
    {
        if ($this->_id)
        {

            if (is_null($uid))
            {
                $user = &JFactory::getUser();
                $uid = $user->get('id');
            }

            $course = &JTable::getInstance('courseman_courses', '');
            return $course->checkout($uid, $this->_id);
        }
        return false;
    }

    function isCheckedOut($uid = 0)
    {
        if ($this->_loadCourse())
        {
            if ($uid)
            {
                return ($this->_course->checked_out && $this->_course->checked_out != $uid);
            } else
            {
                return $this->_course->checked_out;
            }
        } elseif ($this->_id < 1)
        {
            return false;
        } else
        {
            JError::raiseWarning(0, 'UNABLE LOAD DATA');
            return false;
        }
    }

    function store($data)
    {

        JRequest::checkToken() or jexit('Invalid Token');

        $course = &$this->getTable('courseman_courses', '');
        $user = &JFactory::getUser();

        $details = JRequest::getVar('details', array(), 'post', 'array');
        $tags = JRequest::getVar('tag', array(), 'post', 'array');
        $cats = JRequest::getVar('cid', array(), 'post', 'array');
        $files = JRequest::getVar('fid', array(), 'post', 'array');
        $files = array_filter($files);

        if (!is_array($cats) || count($cats) < 1)
        {
            $this->setError('SELECT CATEGORY');
            return false;
        }

        if (!$course->bind($data))
        {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }

        $course->bind($details);

        $course->id = (int)$course->id;

        $nullDate = $this->_db->getNullDate();

        if ($course->id)
        {
            $course->modified = gmdate('Y-m-d H:i:s');
            $course->modified_by = $user->get('id');
        } else
        {
            $course->modified = $nullDate;
            $course->modified_by = '';

            $course->created = gmdate('Y-m-d H:i:s');
            $course->created_by = $user->get('id');
        }

        $course->state = JRequest::getVar('state', 0, '', 'int');
        $params = JRequest::getVar('params', null, 'post', 'array');

        if (is_array($params))
        {
            $txt = array();
            foreach ($params as $k => $v)
            {
                $txt[] = "$k=$v";
            }
            $course->attribs = implode("\n", $txt);
        }

        $metadata = JRequest::getVar('meta', null, 'post', 'array');
        if (is_array($params))
        {
            $txt = array();
            foreach ($metadata as $k => $v)
            {
                if ($k == 'description')
                {
                    $course->meta_description = $v;
                } elseif ($k == 'keywords')
                {
                    $course->meta_keywords = $v;
                } else
                {
                    $txt[] = "$k=$v";
                }
            }
            $course->metadata = implode("\n", $txt);
        }

        courseman_html::saveContentPrep($course);

        if (!$course->id)
        {
            $course->ordering = $course->getNextOrder();
        }

        if (!$course->check())
        {
            $this->setError($course->getError());
            return false;
        }

        $course->version++;

        if (!$course->store())
        {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }

        $this->_course = &$course;

        $query = 'DELETE FROM #__courseman_tags_course_relations WHERE courseid = ' . $course->
            id;
        $this->_db->setQuery($query);
        $this->_db->query();

        foreach ($tags as $tag)
        {
            $query = 'INSERT INTO #__courseman_tags_course_relations (`tid`, `courseid`) VALUES(' .
                $tag . ',' . $course->id . ')';
            $this->_db->setQuery($query);
            $this->_db->query();
        }

        $query = 'DELETE FROM #__courseman_cats_course_relations WHERE courseid = ' . $course->
            id;
        $this->_db->setQuery($query);
        $this->_db->query();

        foreach ($cats as $cat)
        {
            $query = 'INSERT INTO #__courseman_cats_course_relations (`catid`, `courseid`) VALUES(' .
                $cat . ',' . $course->id . ')';
            $this->_db->setQuery($query);
            $this->_db->query();
        }

        $query = 'DELETE FROM #__courseman_files_course_relations WHERE courseid = ' . $course->
            id;
        $this->_db->setQuery($query);
        $this->_db->query();

        foreach ($files as $file)
        {
            $query = 'INSERT INTO #__courseman_files_course_relations (`fileid`, `courseid`) VALUES(' .
                $file . ',' . $course->id . ')';
            $this->_db->setQuery($query);
            $this->_db->query();
        }

        return true;
    }

    function resetHits($id)
    {
        $row = &$this->getTable('courseman_courses', '');
        $row->load($id);
        $row->hits = 0;
        $row->store();
        $row->checkin();
        return $row->id;
    }

    function resetVotes($id)
    {
        $row = &$this->getTable('courseman_courses', '');
        $row->load($id);
        $row->plus = 0;
        $row->minus = 0;
        $row->store();
        $row->checkin();
        return $row->id;
    }

    function gettags()
    {
        $query = 'SELECT * FROM #__courseman_tags ORDER BY name';
        $this->_db->setQuery($query);
        $tags = $this->_db->loadObjectlist();
        return $tags;
    }

    function getusedtags($id)
    {
        $query = 'SELECT DISTINCT tid FROM #__courseman_tags_course_relations WHERE courseid = ' . (int)
            $id;
        $this->_db->setQuery($query);
        $used = $this->_db->loadResultArray();
        return $used;
    }

    function getvotes($id)
    {
        $query = 'SELECT plus, minus FROM #__courseman_courses WHERE id = ' . (int)$id;
        $this->_db->setQuery($query);
        $votes = $this->_db->loadObjectlist();

        return $votes;
    }

    function gethits($id)
    {
        $query = 'SELECT hits FROM #__courseman_courses WHERE id = ' . (int)$id;
        $this->_db->setQuery($query);
        $hits = $this->_db->loadResult();

        return $hits;
    }

    function getCatsselected()
    {
        $query = 'SELECT DISTINCT catid FROM #__courseman_cats_course_relations WHERE courseid = ' . (int)
            $this->_id;
        $this->_db->setQuery($query);
        $used = $this->_db->loadResultArray();
        return $used;
    }

    function getFiles()
    {
        $query = 'SELECT DISTINCT rel.fileid, f.filename' . ' FROM #__courseman_files AS f' .
            ' LEFT JOIN #__courseman_files_course_relations AS rel ON rel.fileid = f.id' .
            ' WHERE rel.courseid = ' . (int)$this->_id;
        $this->_db->setQuery($query);
        $files = $this->_db->loadObjectList();
        return $files;
    }

	function copycourse($cid = array()){

		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		//$this->setRedirect( 'index.php?option=com_courseman' );

		$cid	= JRequest::getVar( 'cid', null, 'post', 'array' );
		$db		=& JFactory::getDBO();
		$table	=& JTable::getInstance('courseman_courses', '');
		//$table =& $this->getTable();
		$user	= &JFactory::getUser();
		$n		= count( $cid );
		if ($n > 0)
		{
			foreach ($cid as $id)
			{
				if ($table->load( (int)$id ))
				{
					$table->id				= 0;
					$table->title			= 'Copy of ' . $table->title;
					$table->alias			= 'copy-of-' . $table->alias;
					$table->hits			= 0;
					$table->state			= 0;
					$table->publish_up		= $table->publish_up;
					$table->publish_down	= $table->publish_down;
					$table->ordering		= 0;
					$table->date			= $db->getNullDate();

					if (!$table->store()) {

						return false;
					}
				}
				else {
					return JError::raiseWarning( 500, $table->getError() );
				}
			}
		}
		else {
			return JError::raiseWarning( 500, JText::_( 'No items selected' ) );
		}
		return $n;
	}

    /**
     * Retrieves e-mail templates for booking
     *
     * @return array of objects with templates
     */
    function getEmailTemplates()
    {
        $query = 'SELECT id, title FROM #__courseman_emailtemplate WHERE templatefor="booking-confirmation-user"';
        $this->_db->setQuery($query);
        return $this->_db->loadObjectList();
    }
}

?>