<?php
/**
* @Copyright Copyright (C) 2010 www.profinvent.com. All rights reserved.
* @website http://www.profinvent.com
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 2 of the License, or
* any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
**/

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class CoursemanModelCourseman extends JModel
{
    function __construct()
    {
        parent::__construct();
    }

    function getLatestJobs()
    {
        $query = 'SELECT id, title' . ' FROM #__courseman_courses' . ' WHERE state = 1' .
            ' ORDER BY created DESC' . ' LIMIT 5';

        $this->_db->SetQuery($query);
        $genstats = $this->_db->loadObjectList();

        return $genstats;
    }

    function getLatestApplications()
    {
        $query = 'SELECT a.id, a.first_name, a.last_name, i.title, a.date' .
            ' FROM #__courseman_application AS a' .
            ' LEFT JOIN #__courseman_courses AS i ON i.id = a.course_id ' .
            ' WHERE a.published = 1' . ' ORDER BY a.date DESC' . ' LIMIT 5';

        $this->_db->SetQuery($query);
        $genstats = $this->_db->loadObjectList();

        return $genstats;
    }

    function getUpdate()
    {
        $url = 'http://joomla.profinvent.com/courseman_current_version.xml';
        $data = '';
        $check = array();
        $check['connect'] = 0;
        $check['version_current'] = '1.5.0';
        $check['versionread_current'] = '1.5.0';

        if (function_exists('curl_init') && function_exists('curl_exec'))
        {
            $ch = @curl_init();

            @curl_setopt($ch, CURLOPT_URL, $url);
            @curl_setopt($ch, CURLOPT_HEADER, 0);

            @curl_setopt($ch, CURLOPT_FAILONERROR, 1);
            @curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);

            @curl_setopt($ch, CURLOPT_TIMEOUT, 5);

            $data = @curl_exec($ch);

            @curl_close($ch);
        }

        if (function_exists('fsockopen') && $data == '')
        {

            $errno = 0;
            $errstr = '';

            $fsock = @fsockopen("joomla.profinvent.com", 80, $errno, $errstr, 5);

            if ($fsock)
            {
                @fputs($fsock, "GET /courseman_current_version.xml HTTP/1.1\r\n");
                @fputs($fsock, "HOST: joomla.profinvent.com\r\n");
                @fputs($fsock, "Connection: close\r\n\r\n");

                @stream_set_blocking($fsock, 1);
                @stream_set_timeout($fsock, 5);

                $get_info = false;
                while (!@feof($fsock))
                {
                    if ($get_info)
                    {
                        $data .= @fread($fsock, 1024);
                    } else
                    {
                        if (@fgets($fsock, 1024) == "\r\n")
                        {
                            $get_info = true;
                        }
                    }
                }
                @fclose($fsock);

                if (!strstr($data, '<?xml version="1.0" encoding="utf-8"?><update>'))
                {
                    $data = '';
                }
            }
        }

        if (function_exists('fopen') && ini_get('allow_url_fopen') && $data == '')
        {

            ini_set('default_socket_timeout', 5);

            $handle = @fopen($url, 'r');

            @stream_set_blocking($handle, 1);
            @stream_set_timeout($handle, 5);

            $data = @fread($handle, 1000);

            @fclose($handle);
        }


        if ($data && strstr($data, '<?xml version="1.0" encoding="utf-8"?><update>'))
        {
            $xml = &JFactory::getXMLparser('Simple');
            $xml->loadString($data);

            $version = &$xml->document->version[0];
            $check['version'] = &$version->data();
            $versionread = &$xml->document->versionread[0];
            $check['versionread'] = &$versionread->data();
            $released = &$xml->document->released[0];
            $check['released'] = &$released->data();
            $check['connect'] = 1;
            $check['enabled'] = 1;

            $check['current'] = version_compare($check['version_current'], $check['version']);
        }

        return $check;
    }
}

?>