<?php
/**
*
* @Copyright Copyright (C) 2010 www.profinvent.com. All rights reserved.
* @website http://www.profinvent.com
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 2 of the License, or
* any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class coursemanModeltutor extends JModel{
    var $_id = null;

    var $_data = null;

    function __construct()
    {
        parent::__construct();

        $array = JRequest::getVar('cid', array(0), '', 'array');
        $edit = JRequest::getVar('edit', true);
        if ($edit)
            $this->setId((int)$array[0]);
        $this->childviewname = 'tutor';
    }

    function setId($id)
    {
        $this->_id = $id;
        $this->_data = null;
    }

    function &getData()
    {
        if ($this->_loadData()){
            $user = &JFactory::getUser();
        }else
            $this->_initData();

        return $this->_data;
    }

    function isCheckedOut($uid = 0)
    {
        if ($this->_loadData()){
            if ($uid){
                return ($this->_data->checked_out && $this->_data->checked_out != $uid);
            }else{
                return $this->_data->checked_out;
            }
        }
    }

    function checkin()
    {
        if ($this->_id){
            $group = &$this->getTable();
            if (!$group->checkin($this->_id)){
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
        }
        return false;
    }

    function checkout($uid = null)
    {
        if ($this->_id){
            if (is_null($uid)){
                $user = &JFactory::getUser();
                $uid = $user->get('id');
            }

            $group = &$this->getTable();
            if (!$group->checkout($uid, $this->_id)){
                $this->setError($this->_db->getErrorMsg());
                return false;
            }

            return true;
        }
        return false;
    }

    function store($data)
    {
        $row = &$this->getTable();

        if (!$row->bind($data)){
            $this->setError($this->_db->getErrorMsg());
            return false;
        }

        $row->date = gmdate('Y-m-d H:i:s');

        if (!$row->id){
            $where = '';
            $row->ordering = $row->getNextOrder($where);
        }

        if (!$row->store()){
            $this->setError($this->_db->getErrorMsg());
            return false;
        }

        return true;
    }

    function delete($cid = array())
    {
        $result = false;

        if (count($cid)){
            JArrayHelper::toInteger($cid);
            $cids = implode(',', $cid);

            $query_check = 'SELECT groupid FROM #__courseman_courses' . ' WHERE ' . $this->childviewname . 'id IN ( ' . $cids . ' )';
            $this->_db->setQuery($query_check);
            $relatedRecords = $this->_db->loadResult();
            if ($relatedRecords > 0){
                JError::raiseWarning('ERROR_CODE', JText::_('There are records assigned to selected course. Please delete the related records first.'));
                return false;
            }

            $query = 'DELETE FROM #__courseman_' . $this->childviewname . ' WHERE id IN ( ' . $cids .
            ' )';
            $this->_db->setQuery($query);
            if (!$this->_db->query()){
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
        }

        return true;
    }

    function approve($cid = array(), $approve = 1)
    {
        $user = &JFactory::getUser();

        if (count($cid)){
            JArrayHelper::toInteger($cid);
            $cids = implode(',', $cid);

            $query = 'UPDATE #__courseman_' . $this->childviewname . ' SET approved = ' . (int)
            $approved . ' WHERE id IN ( ' . $cids . ' )' .
            ' AND ( checked_out = 0 OR ( checked_out = ' . (int)$user->get('id') . ' ) )';
            $this->_db->setQuery($query);
            if (!$this->_db->query()){
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
        }

        return true;
    }

    function publish($cid = array(), $publish = 1)
    {
        $user = &JFactory::getUser();

        if (count($cid)){
            JArrayHelper::toInteger($cid);
            $cids = implode(',', $cid);

            $query = 'select user_id from #__courseman_tutor WHERE id IN ( ' . $cids . ' )';
            $this->_db->setQuery($query);
            $user_id = $this->_db->loadResultArray();
            JArrayHelper::toInteger($user_id);
            $user_ids = implode(',', $user_id);

            $query = 'UPDATE #__users' . ' SET block = ' . (int)$publish . ' WHERE id IN ( ' .
            $user_ids . ' )';
            $this->_db->setQuery($query);
            if (!$this->_db->query()){
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
        }

        return true;
    }

    function move($direction)
    {
        $row = &$this->getTable();
        if (!$row->load($this->_id)){
            $this->setError($this->_db->getErrorMsg());
            return false;
        }

        if (!$row->move($direction, ' published >= 0 ')){
            $this->setError($this->_db->getErrorMsg());
            return false;
        }

        return true;
    }

    function saveorder($cid = array(), $order)
    {
        $row = &$this->getTable();

        for ($i = 0; $i < count($cid); $i++){
            $row->load((int)$cid[$i]);

            if ($row->ordering != $order[$i]){
                $row->ordering = $order[$i];
                if (!$row->store()){
                    $this->setError($this->_db->getErrorMsg());
                    return false;
                }
            }
        }

        $row->reorder('');

        return true;
    }

    function _loadData()
    {
        if (empty($this->_data)){
            $query = 'SELECT w.*' . ' FROM #__courseman_' . $this->childviewname . ' AS w' .
            ' WHERE w.id = ' . (int)$this->_id;
            $this->_db->setQuery($query);
            $this->_data = $this->_db->loadObject();
            return (boolean)$this->_data;
        }
        return true;
    }

    function YesNo($name, $value = 'y')
    {
        $put[] = JHTML::_('select.option', 'n', JText::_('No'));
        $put[] = JHTML::_('select.option', 'y', JText::_('Yes'));
        $yesno = JHTML::_('select.radiolist', $put, $name, '', 'value', 'text', $value);
        return $yesno;
    }

    function UploadImage($file)
    {
        if ($file['size'] > 0){
            jimport('joomla.filesystem.file');
            $post = JRequest::get('post');
    		$params =& JComponentHelper::getParams( 'com_courseman' );

            $path = COM_COURSEMAN_IMAGEPATH . DS . $post['logotodelete'];
            if (JFile::exists($path)){
                JFile::delete($path);
            }

            $filename = JFile::makeSafe($post['id'] . $file['name']);

            $src = $file['tmp_name'];
            $dest = COM_COURSEMAN_IMAGEPATH . DS . $filename;
            $extensions = $params->get('image_extensions');
            $extensions = explode(',', $extensions);
            for ($i = 0; $i < count($data); $i++){
                if (strtolower(JFile::getExt($filename)) == $data[$i]){
                    $fileextensions = 1;
                }
            }
            if ($fileextensions = 1){
                if (JFile::upload($src, $dest)){
                    $row->logofilename = $post['id'] . $file['name'];

                    require_once JPATH_COMPONENT . DS . 'classes' . DS . 'thumb' . DS .
                    'ThumbLib.inc.php';

                    $thumb = PhpThumbFactory::create($dest);
                    $thumb->resize($params->get('pwidth'), $params->get('pheight'));
                    $thumb->save($dest);
                    return $row->logofilename;
                }else{
                    $msg .= JText::_('Error uploading image');
                    return false;
                }
            }else{
                return false;
            }
        }
    }

    function _initData()
    {
        if (empty($this->_data)){
            $tutor = new stdClass();
            $tutor->id = 0;
            $tutor->title = null;
            $tutor->alias = null;
            $tutor->code = null;
            $tutor->description = null;
            $tutor->date = null;
            $tutor->hits = 0;
            $tutor->published = 0;
            $tutor->checked_out = 0;
            $tutor->checked_out_time = 0;
            $tutor->ordering = 0;
            $tutor->archived = 0;
            $tutor->approved = 0;
            $tutor->params = null;
            $tutor->user_id = null;
            $tutor->firstname = null;
            $tutor->lastname = null;
            $tutor->salutation = null;
            $tutor->other_title = null;
            $tutor->comp_name = null;
            $tutor->primary_phone = null;
            $tutor->fax_number = null;
            $tutor->url = null;
            $tutor->street = null;
            $tutor->id_country = null;
            $tutor->state = null;
            $tutor->city = null;
            $tutor->zip = null;
            $tutor->id_comp_type = null;
            $tutor->industry = null;
            $tutor->logofilename = null;
            $tutor->logo = null;
            $tutor->bill_addr = null;
            $tutor->bill_addr_cont = null;
            $tutor->bill_id_country = null;
            $tutor->bill_state = null;
            $tutor->bill_city = null;
            $tutor->bill_zip = null;
            $tutor->bill_phone = null;
            $tutor->metadescription = null;
            $tutor->metakeywords = null;
            $tutor->status = null;

            $this->_data = $tutor;
            return (boolean)$this->_data;
        }
        return true;
    }
}