<?php
/**
*
* @Copyright Copyright (C) 2010 www.profinvent.com. All rights reserved.
* @website http://www.profinvent.com
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 2 of the License, or
* any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

defined('_JEXEC') or die('Restricted access');

class courseman_courses extends JTable{
    var $id = null;
    var $reference_number = '';
    var $title = '';
    var $alias = '';
    var $code = '';
    var $introtext = '';
    var $fulltext = '';
    var $plus = 0;
    var $minus = 0;
    var $hits = 0;
    var $version = 0;
    var $meta_description = null;
    var $meta_keywords = null;
    var $metadata = null;
    var $created = '';
    var $created_by = '';
    var $created_by_alias = '';
    var $modified = '';
    var $modified_by = '';
    var $state = null;
    var $attribs = null;
    var $checked_out = 0;
    var $checked_out_time = '';
    var $id_experience_level = 0;
    var $id_group = 0;
    var $ordering = null;
    var $tutor_id = null;
    var $price_type = null;
    var $job_experience = null;
    var $price = null;
    var $currency_price = null;
    var $capacity = 0;
    var $location = null;
    var $expire_date = null;
    var $publish_up = null;
    var $publish_down = null;
    var $url = null;
    var $image = null;
    var $email_template = 0;

    function courseman_courses(&$db)
    {
        parent::__construct('#__courseman_courses', 'id', $db);
    }

    function check()
    {
        if (trim($this->title) == ''){
            $this->_error = JText::_('ADD TITLE');
            JError::raiseWarning('SOME_ERROR_CODE', $this->_error);
            return false;
        }

    	if(empty($this->alias)) {
    		$this->alias = $this->title;
    	}

    	$this->alias = JFilterOutput::stringURLSafe($this->alias);
    	if(trim(str_replace('-','',$this->alias)) == '') {
    		$datenow =& JFactory::getDate();
    		$this->alias = $datenow->toFormat("%Y-%m-%d-%H-%M-%S");
    	}

    	/** check for existing alias */
    	$query = 'SELECT id FROM #__courseman_courses WHERE alias = '.$this->_db->Quote($this->alias);
    	$this->_db->setQuery($query);
    	$xid = intval($this->_db->loadResult());

    	if ($xid && $xid != intval($this->id)) {
    		$this->setError(JText::sprintf('WARNNAMETRYAGAIN', JText::_('Alias already exists')));
    		$datenow =& JFactory::getDate();
    		$this->alias = $this->alias . $datenow->toFormat("%y%m%d%H%M%S");


    	}


    	if (!(eregi('http://', $this->url) || (eregi('https://', $this->url)) || (eregi('ftp://', $this->url)))) {
    		$this->url = 'http://'.$this->url;
    	}

        return true;
    }
}

?>