<?php
/**
* @Copyright Copyright (C) 2010 www.profinvent.com. All rights reserved.
* @website http://www.profinvent.com
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 2 of the License, or
* any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
**/

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class CareerModelTags extends JModel
{
    var $_data = null;

    var $_tag = null;

    var $_total = null;

    function __construct()
    {
        parent::__construct();

        global $mainframe;

        $params = &$mainframe->getParams('com_career');

        $limit = JRequest::getInt('limit', $params->get('limit'));
        $limitstart = JRequest::getInt('limitstart');
        $id = JRequest::getInt('id', 0);

        $this->setId((int)$id);

        $this->setState('limit', $limit);
        $this->setState('limitstart', $limitstart);

        $this->setState('filter_order', JRequest::getCmd('filter_order', 'i.title'));
        $this->setState('filter_order_dir', JRequest::getCmd('filter_order_Dir', 'ASC'));
    }

    function setId($id)
    {

        $this->_id = $id;
        $this->_data = null;
    }

    function getData()
    {

        if (empty($this->_data))
        {
            $query = $this->_buildQuery();
            $this->_data = $this->_getList($query, $this->getState('limitstart'), $this->
                getState('limit'));
        }

        return $this->_data;
    }

    function getTotal()
    {

        if (empty($this->_total))
        {
            $query = $this->_buildQuery();
            $this->_total = $this->_getListCount($query);
        }

        return $this->_total;
    }

    function _buildQuery()
    {

        $where = $this->_buildItemWhere();
        $orderby = $this->_buildItemOrderBy();

        $query = 'SELECT i.id, i.title, i.*, (i.plus / (i.plus + i.minus) ) * 100 AS votes,cy.title AS country, emp.comp_name AS employer,' .
            ' CASE WHEN CHAR_LENGTH(i.alias) THEN CONCAT_WS(\':\', i.id, i.alias) ELSE i.id END as slug,' .
            ' CASE WHEN CHAR_LENGTH(c.alias) THEN CONCAT_WS(\':\', c.id, c.alias) ELSE c.id END as categoryslug' .
            ' FROM #__career_items AS i' .
            ' INNER JOIN #__career_tags_item_relations AS t ON t.itemid = i.id' .
            ' LEFT JOIN #__career_cats_item_relations AS rel ON rel.itemid = i.id' .
            ' LEFT JOIN #__career_country AS cy ON cy.id = i.id_country' .
            ' LEFT JOIN #__career_employer AS emp ON emp.id = i.employer_id' .
            ' LEFT JOIN #__career_categories AS c ON c.id = rel.catid' . $where .
            ' GROUP BY i.id' . $orderby;

        return $query;
    }

    function _buildItemOrderBy()
    {
        $filter_order = $this->getState('filter_order');
        $filter_order_dir = $this->getState('filter_order_dir');

        $orderby = ' ORDER BY ' . $filter_order . ' ' . $filter_order_dir . ', i.title';

        return $orderby;
    }

    function _buildItemWhere()
    {
        global $mainframe;

        $user = &JFactory::getUser();
        $gid = (int)$user->get('aid');
        $params = &$mainframe->getParams('com_career');

        $jnow = &JFactory::getDate();
        $now = $jnow->toMySQL();
        $nullDate = $this->_db->getNullDate();

        $state = 1;

        $where = ' WHERE t.tid = ' . $this->_id;

        $where .= ' AND c.access <= ' . $gid;

        switch ($state)
        {
            case 1:

                $where .= ' AND i.state = 1' . ' AND ( publish_up = ' . $this->_db->Quote($nullDate) .
                    ' OR publish_up <= ' . $this->_db->Quote($now) . ' )' . ' AND ( publish_down = ' .
                    $this->_db->Quote($nullDate) . ' OR publish_down >= ' . $this->_db->Quote($now) .
                    ' )';

                break;

            case - 1:

                $year = JRequest::getInt('year', date('Y'));
                $month = JRequest::getInt('month', date('m'));

                $where .= ' AND i.state = -1';
                $where .= ' AND YEAR( i.created ) = ' . (int)$year;
                $where .= ' AND MONTH( i.created ) = ' . (int)$month;
                break;

            default:
                $where .= ' AND i.state = ' . (int)$state;
                break;
        }


        if ($params->get('filter'))
        {
            $filter = JRequest::getString('filter', '', 'request');
            $filter_location = JRequest::getString('filter_location', '', 'request');
            $filter_positiontype = JRequest::getString('filter_positiontype', '', 'request');

            if ($filter)
            {

                $filter = $this->_db->getEscaped(trim(JString::strtolower($filter)));

                $where .= ' AND LOWER( i.title ) LIKE ' . $this->_db->Quote('%' . $this->_db->
                    getEscaped($filter, true) . '%', false);
            }

            if ($filter_location)
            {

                $filter_location = $this->_db->getEscaped(trim(JString::strtolower($filter_location)));

                $where .= ' AND LOWER( i.city ) LIKE ' . $this->_db->Quote('%' . $this->_db->
                    getEscaped($filter_location, true) . '%', false);
            }

            if ($filter_positiontype)
            {
                $where .= ' AND LOWER( i.id_pos_type ) = ' . $filter_positiontype;
            }
        }
        return $where;
    }

    function getTag()
    {

        $query = 'SELECT t.name, t.id,' .
            ' CASE WHEN CHAR_LENGTH(t.alias) THEN CONCAT_WS(\':\', t.id, t.alias) ELSE t.id END as slug' .
            ' FROM #__career_tags AS t' . ' WHERE t.id = ' . $this->_id .
            ' AND t.published = 1';

        $this->_db->setQuery($query);
        $this->_tag = $this->_db->loadObject();

        return $this->_tag;
    }

    function gettitles()
    {
        $user = &JFactory::getUser();
        $gid = (int)$user->get('aid');
        $ordering = 'ordering ASC';

        $query = 'SELECT id, title' . ' FROM #__career_position_type' .
            ' WHERE published = 1' . ' ORDER BY ' . $ordering;

        $this->_db->setQuery($query);
        $this->_subs = $this->_db->loadObjectList();

        return $this->_subs;
    }
}

?>