<?php
/**
* @Copyright Copyright (C) 2010 www.profinvent.com. All rights reserved.
* @website http://www.profinvent.com
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 2 of the License, or
* any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
**/

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.view');

class coursemanViewapplication extends JView
{
    function display($tpl = null)
    {
        global $mainframe;
        $childviewname = 'application';


        if ($this->getLayout() == 'form')
        {
            $this->_displayForm($tpl);
            return;
        }

        $application = &$this->get('data');

        if ($application->url)
        {

            $mainframe->redirect($application->url);
        }

        parent::display($tpl);
    }

    function _displayForm($tpl)
    {
        global $mainframe, $option;

        $db = &JFactory::getDBO();
        $uri = &JFactory::getURI();
        $user = &JFactory::getUser();
        $model = &$this->getModel();
        $document = &JFactory::getDocument();
        $lang = &JFactory::getLanguage();

        $document->addStyleSheet('components/com_courseman/assets/css/coursemanbackend.css');
        if ($lang->isRTL())
        {
            $document->addStyleSheet('components/com_courseman/assets/css/coursemanbackend_rtl.css');
        }

        require_once (JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_courseman' . DS .
            'helpers' . DS . 'courseman.php');
require_once( JPATH_ROOT . DS . 'components' . DS . 'com_courseman' . DS . 'libraries' . DS . 'customfields.php' );

        $lists = array();

        $application = &$this->get('data');
        $isNew = ($application->id < 1);

        if ($model->isCheckedOut($user->get('id')))
        {
            $msg = JText::sprintf('DESCBEINGEDITTED', JText::_('Application'), $application->
                id);
            $mainframe->redirect('index.php?option=' . $option, $msg);
        }

        if (!$isNew)
        {
            $model->checkout($user->get('id'));
            $disabled = 1;
            $formType['isNew'] = null;
        } else
        {


            $formType['isNew'] = 1;
            $disabled = 0;
            $application->published = 1;
            $application->approved = 1;
            $application->order = 0;
        }
    	$params =& JComponentHelper::getParams( 'com_courseman' );
    	$application->currency_price = $params->get( 'currency' );

        $query = 'SELECT ordering AS value, CONCAT_WS(\' \', first_name, last_name) AS text' .
            ' FROM #__courseman_application' . ' ORDER BY ordering';

        $lists['ordering'] = JHTML::_('list.specificordering', $application, $application->
            id, $query);

        $lists['published'] = JHTML::_('select.booleanlist', 'published',
            'class="inputbox"', $application->published);

        $lists['salutation'] = JHTMLCourseman::getListFromXML('Salutation', 'salutation', 0,
            $application->salutation);

        $lists['username'] = JHTMLCourseman::getSelectUser('user_id', $application->
            user_id, $disabled);

    	// build status list
    	$statuslist[]         = JHTML::_('select.option',  '0', JText::_( 'Submitted' ), 'value', 'text' );
    	$statuslist[]         = JHTML::_('select.option',  '1', JText::_( 'Pending' ), 'value', 'text' );
    	$statuslist[]         = JHTML::_('select.option',  '2', JText::_( 'Paid' ), 'value', 'text' );
    	$statuslist[]         = JHTML::_('select.option',  '3', JText::_( 'Canceled' ), 'value', 'text' );
    	$lists['status']      = JHTML::_('select.radiolist', $statuslist, 'status', 'class="inputbox" size="1"','value', 'text', $application->status );



        JFilterOutput::objectHTMLSafe($group, ENT_QUOTES, 'description');

        $file = JPATH_COMPONENT . DS . 'models' . DS . 'application.xml';
        $params = new JParameter($application->params, $file);

    	//$model		=& $this->getModel( 'Users' );
    	$customfields	= $model->getEditableCustomfields( $application->id );
    	$user->customfields	=& $customfields;
    	$this->assignRef( 'user' , $user );
        $this->assignRef('lists', $lists);
        $this->assignRef('application', $application);
        $this->assignRef('params', $params);

        parent::display($tpl);
    }
}