<?php
/**
* @Copyright Copyright (C) 2010 www.profinvent.com. All rights reserved.
* @website http://www.profinvent.com
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 2 of the License, or
* any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
**/

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.view');

class coursemanViewapplications extends JView
{
    function display($tpl = null)
    {
        global $mainframe, $option;

        $db = &JFactory::getDBO();
        $uri = &JFactory::getURI();
        $childviewname = 'application';
        $document = &JFactory::getDocument();
        $lang = &JFactory::getLanguage();

        $document->addStyleSheet('components/com_courseman/assets/css/coursemanbackend.css');
        if ($lang->isRTL())
        {
            $document->addStyleSheet('components/com_courseman/assets/css/coursemanbackend_rtl.css');
        }

        JSubMenuHelper::addEntry(JText::_('HOME'), 'index.php?option=com_courseman');
        JSubMenuHelper::addEntry(JText::_('APPLICATIONS'),
            'index.php?option=com_courseman&view=applications', true);
        JSubMenuHelper::addEntry(JText::_('COURSES'),
            'index.php?option=com_courseman&view=courses');
        JSubMenuHelper::addEntry(JText::_('CATEGORIES'),
            'index.php?option=com_courseman&view=categories');
        JSubMenuHelper::addEntry(JText::_('TAGS'),
            'index.php?option=com_courseman&view=tags');
        JSubMenuHelper::addEntry(JText::_('TUTORS'),
            'index.php?option=com_courseman&view=tutors');

        JToolBarHelper::title(JText::_('APPLICATIONS'), 'applications');
        JToolBarHelper::publishList();
        JToolBarHelper::unpublishList();
        JToolBarHelper::deleteList();
        JToolBarHelper::editListX();
        ////JToolBarHelper::help('courseman.help', 1);

        $filter_state = $mainframe->getUserStateFromRequest($option . $childviewname .
            '.filter_state', 'filter_state', '', 'word');
        $filter_order = $mainframe->getUserStateFromRequest($option . $childviewname .
            '.filter_order', 'filter_order', 'a.id', 'cmd');
        $filter_order_Dir = $mainframe->getUserStateFromRequest($option . $childviewname .
            '.filter_order_Dir', 'filter_order_Dir', 'desc', 'word');
    	$filter_courseid	= $mainframe->getUserStateFromRequest( $option.'.applications.filter_courseid',		'filter_courseid',		0,				'int' );
    	$filter_statusid	= $mainframe->getUserStateFromRequest( $option.'.applications.filter_statusid',		'filter_statusid',		0,				'int' );
    	$filter_search		= $mainframe->getUserStateFromRequest( $option.'.applications.filter_search',		'filter_search',		'',				'int' );

        $search = $mainframe->getUserStateFromRequest($option . $childviewname .
            '.search', 'search', '', 'string');
        $search = JString::strtolower($search);

        $courses = &$this->get('Data');
        $total = &$this->get('Total');
        $pagination = &$this->get('Pagination');

        $requestURL = &$uri->toString();

    	$titles = & $this->get( 'titles' );

    	// build list of courses
    	$javascript 	= 'onchange="document.adminForm.submit();"';
    	$catlist[]         = JHTML::_('select.option',  '0', JText::_( '- Select Course -' ), 'id', 'title' );
    	$catlist         = array_merge( $catlist, $titles );
    	$lists['courseid']      = JHTML::_('select.genericlist', $catlist, 'filter_courseid', 'class="inputbox" size="1" onchange="submitform( );"','id', 'title', $filter_courseid );

    	//search filter - what field to use for search
    	$filters = array();
    	$filters[] = JHTML::_('select.option', '1', JText::_( 'Last Name' ) );
    	$filters[] = JHTML::_('select.option', '2', JText::_( 'First Name' ) );
    	$filters[] = JHTML::_('select.option', '3', JText::_( 'Email' ) );
    	$lists['filter_search'] = JHTML::_('select.genericlist', $filters, 'filter_search', 'size="1" class="inputbox"', 'value', 'text', $filter_search );


    	// build list of statuses
    	$javascript 	= 'onchange="document.adminForm.submit();"';
    	$statuslist[]         = JHTML::_('select.option',  '0', JText::_( '- Select Status -' ), 'id', 'state' );
    	$statuslist[]         = JHTML::_('select.option',  '1', JText::_( 'Submitted' ), 'id', 'state' );
    	$statuslist[]         = JHTML::_('select.option',  '2', JText::_( 'Pending' ), 'id', 'state' );
    	$statuslist[]         = JHTML::_('select.option',  '3', JText::_( 'Paid' ), 'id', 'state' );
    	$statuslist[]         = JHTML::_('select.option',  '4', JText::_( 'Canceled' ), 'id', 'state' );
    	//	$statuslist         = array_merge( $statuslist, $titles );
    	$lists['statusid']      = JHTML::_('select.genericlist', $statuslist, 'filter_statusid', 'class="inputbox" size="1" onchange="submitform( );"','id', 'state', $filter_statusid );


        $lists['state'] = JHTML::_('grid.state', $filter_state);

        $lists['order_Dir'] = $filter_order_Dir;
        $lists['order'] = $filter_order;

        $lists['search'] = $search;

        $this->assignRef('user', JFactory::getUser());
        $this->assignRef('lists', $lists);
        $this->assignRef('courses', $courses);
        $this->assignRef('pagination', $pagination);
        $this->assignRef('requestURL', $requestURL);

        parent::display($tpl);
    }
}