<?php
/**
* @Copyright Copyright (C) 2010 www.profinvent.com. All rights reserved.
* @website http://www.profinvent.com
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 2 of the License, or
* any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
**/

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.view');

class CoursemanViewCategories extends JView
{

    function display($tpl = null)
    {
        global $mainframe, $option;

        $user = &JFactory::getUser();
        $db = &JFactory::getDBO();
        $document = &JFactory::getDocument();
        $lang = &JFactory::getLanguage();

        JHTML::_('behavior.tooltip');

        $filter_order = $mainframe->getUserStateFromRequest($option .
            '.categories.filter_order', 'filter_order', 'c.ordering', 'cmd');
        $filter_order_Dir = $mainframe->getUserStateFromRequest($option .
            '.categories.filter_order_Dir', 'filter_order_Dir', '', 'word');
        $filter_state = $mainframe->getUserStateFromRequest($option .
            '.categories.filter_state', 'filter_state', '*', 'word');
        $search = $mainframe->getUserStateFromRequest($option . '.categories.search',
            'search', '', 'string');
        $search = $db->getEscaped(trim(JString::strtolower($search)));

        $document->addStyleSheet('components/com_courseman/assets/css/coursemanbackend.css');
        if ($lang->isRTL())
        {
            $document->addStyleSheet('components/com_courseman/assets/css/coursemanbackend_rtl.css');
        }

    	JSubMenuHelper::addEntry(JText::_('HOME'), 'index.php?option=com_courseman');
    	JSubMenuHelper::addEntry(JText::_('APPLICATIONS'),'index.php?option=com_courseman&view=applications');
    	JSubMenuHelper::addEntry(JText::_('COURSES'),'index.php?option=com_courseman&view=courses');
    	JSubMenuHelper::addEntry(JText::_('CATEGORIES'),'index.php?option=com_courseman&view=categories', true);
    	JSubMenuHelper::addEntry(JText::_('TAGS'),'index.php?option=com_courseman&view=tags');
    	JSubMenuHelper::addEntry(JText::_('TUTORS'),'index.php?option=com_courseman&view=tutors');

        JToolBarHelper::title(JText::_('CATEGORIES'), 'qfcategories');
        JToolBarHelper::publishList();
        JToolBarHelper::spacer();
        JToolBarHelper::unpublishList();
        JToolBarHelper::spacer();
        JToolBarHelper::addNew();
        JToolBarHelper::spacer();
        JToolBarHelper::editList();
        JToolBarHelper::spacer();
        JToolBarHelper::deleteList();

        $rows = &$this->get('Data');
        $pageNav = &$this->get('Pagination');

        $lists['state'] = JHTML::_('grid.state', $filter_state);

        $lists['search'] = $search;

        $lists['order_Dir'] = $filter_order_Dir;
        $lists['order'] = $filter_order;

        $ordering = ($lists['order'] == 'c.ordering');

        $this->assignRef('lists', $lists);
        $this->assignRef('rows', $rows);
        $this->assignRef('pageNav', $pageNav);
        $this->assignRef('ordering', $ordering);
        $this->assignRef('user', $user);
        $this->assignRef('direction', $lang);

        parent::display($tpl);
    }
}

?>