<?php
/**
* @Copyright Copyright (C) 2010 www.profinvent.com. All rights reserved.
* @website http://www.profinvent.com
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 2 of the License, or
* any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
**/

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.view');

class CoursemanViewCategory extends JView
{

    function display($tpl = null)
    {
        global $mainframe;

        jimport('joomla.html.pane');

        $editor = &JFactory::getEditor();
        $document = &JFactory::getDocument();
        $user = &JFactory::getUser();
        $lang = &JFactory::getLanguage();
        $pane = &JPane::getInstance('sliders');

        $cid = JRequest::getVar('cid');

        $document->addStyleSheet('components/com_courseman/assets/css/coursemanbackend.css');
        if ($lang->isRTL())
        {
            $document->addStyleSheet('components/com_courseman/assets/css/coursemanbackend_rtl.css');
        }

        if ($cid)
        {
            JToolBarHelper::title(JText::_('EDIT CATEGORY'), 'qfcategoryedit');

        } else
        {
            JToolBarHelper::title(JText::_('NEW CATEGORY'), 'qfcategoryedit');

            JSubMenuHelper::addEntry(JText::_('HOME'), 'index.php?option=com_courseman');
            JSubMenuHelper::addEntry(JText::_('courseS'),
                'index.php?option=com_courseman&view=courses');
            JSubMenuHelper::addEntry(JText::_('CATEGORIES'),
                'index.php?option=com_courseman&view=categories');
            JSubMenuHelper::addEntry(JText::_('TAGS'),
                'index.php?option=com_courseman&view=tags');
            JSubMenuHelper::addEntry(JText::_('ARCHIVE'),
                'index.php?option=com_courseman&view=archive');
            JSubMenuHelper::addEntry(JText::_('FILEMANAGER'),
                'index.php?option=com_courseman&view=filemanager');
            JSubMenuHelper::addEntry(JText::_('STATISTICS'),
                'index.php?option=com_courseman&view=stats');
        }
        JToolBarHelper::apply();
        JToolBarHelper::spacer();
        JToolBarHelper::save();
        JToolBarHelper::spacer();
        JToolBarHelper::media_manager();
        JToolBarHelper::spacer();
        JToolBarHelper::cancel();

        $model = &$this->getModel();
        $row = &$this->get('Category');
        $categories = courseman_cats::getCategoriesTree(0);

        foreach ($categories as $category)
        {

            if ($category->id == $row->id)
            {
                unset($categories[$category->id]);
            }
        }

        if ($row->id)
        {
            if ($model->isCheckedOut($user->get('id')))
            {
                JError::raiseWarning('SOME_ERROR_CODE', $row->title . ' ' . JText::_('EDITED BY ANOTHER ADMIN'));
                $mainframe->redirect('index.php?option=com_courseman&view=categories');
            }
        }

        JFilterOutput::objectHTMLSafe($row, ENT_QUOTES, 'text');

        $Lists = array();
        $javascript = "onchange=\"javascript:if (document.forms[0].image.options[selectedIndex].value!='') {document.imagelib.src='../images/stories/' + document.forms[0].image.options[selectedIndex].value} else {document.imagelib.src='../images/blank.png'}\"";
        $Lists['imagelist'] = JHTML::_('list.images', 'image', $row->image, $javascript,
            '/images/stories/');
    	$javascript2 = "onchange=\"javascript:if (document.forms[0].icon.options[selectedIndex].value!='') {document.iconlib.src='../images/M_images/' + document.forms[0].icon.options[selectedIndex].value} else {document.iconlib.src='../images/blank.png'}\"";
    	$Lists['iconlist'] = JHTML::_('list.images', 'icon', $row->icon, $javascript2,
    		'/images/M_images/');
        $Lists['access'] = JHTML::_('list.accesslevel', $row);
        $Lists['parent_id'] = courseman_cats::buildcatselect($categories, 'parent_id', $row->
            parent_id, true);

        $this->assignRef('Lists', $Lists);
        $this->assignRef('row', $row);
        $this->assignRef('editor', $editor);
        $this->assignRef('pane', $pane);

        parent::display($tpl);
    }
}

?>