<?php
/**
* @Copyright Copyright (C) 2010 www.profinvent.com. All rights reserved.
* @website http://www.profinvent.com
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 2 of the License, or
* any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
**/

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.view');

class CoursemanViewCourse extends JView
{

    function display($tpl = null)
    {
        global $mainframe;

        jimport('joomla.html.pane');

        $editor = &JFactory::getEditor();
        $document = &JFactory::getDocument();
        $user = &JFactory::getUser();
        $db = &JFactory::getDBO();
        $lang = &JFactory::getLanguage();
        $pane = &JPane::getInstance('sliders');


        JHTML::_('behavior.tooltip');

        $nullDate = $db->getNullDate();

        $cid = JRequest::getVar('cid');

        $document->addStyleSheet('components/com_courseman/assets/css/coursemanbackend.css');
        if ($lang->isRTL())
        {
            $document->addStyleSheet('components/com_courseman/assets/css/coursemanbackend_rtl.css');
        }

        $document->addScript(JURI::base() .
            'components/com_courseman/assets/js/coursescreen.js');


        require_once (JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_courseman' . DS .
            'helpers' . DS . 'courseman.php');

        if ($cid)
        {
            JToolBarHelper::title(JText::_('EDIT COURSE'), 'courseedit');

        } else
        {
            JToolBarHelper::title(JText::_('NEW COURSE'), 'courseedit');

            JSubMenuHelper::addEntry(JText::_('HOME'), 'index.php?option=com_courseman');
            JSubMenuHelper::addEntry(JText::_('courseS'),
                'index.php?option=com_courseman&view=courses');
            JSubMenuHelper::addEntry(JText::_('CATEGORIES'),
                'index.php?option=com_courseman&view=categories');
            JSubMenuHelper::addEntry(JText::_('TAGS'),
                'index.php?option=com_courseman&view=tags');
            JSubMenuHelper::addEntry(JText::_('ARCHIVE'),
                'index.php?option=com_courseman&view=archive');
            JSubMenuHelper::addEntry(JText::_('FILEMANAGER'),
                'index.php?option=com_courseman&view=filemanager');
            JSubMenuHelper::addEntry(JText::_('STATISTICS'),
                'index.php?option=com_courseman&view=stats');
        }
        JToolBarHelper::apply();
        JToolBarHelper::spacer();
        JToolBarHelper::save();
        JToolBarHelper::spacer();
        JToolBarHelper::cancel();

        $model = &$this->getModel();
        $row = &$this->get('Course');
        $files = &$this->get('Files');
        $categories = courseman_cats::getCategoriesTree(1);
        $selectedcats = &$this->get('Catsselected');
        $disabled = 0;

        if ($row->id)
        {
            if ($model->isCheckedOut($user->get('id')))
            {
                JError::raiseWarning('SOME_ERROR_CODE', $row->title . ' ' . JText::_('EDITED BY ANOTHER ADMIN'));
                $mainframe->redirect('index.php?option=com_courseman&view=categories');
            }
            $disabled = 1;
        }

        JFilterOutput::objectHTMLSafe($row, ENT_QUOTES);

        $lists = array();
        $lists['cid'] = courseman_cats::buildcatselect($categories, 'cid[]', $selectedcats, false,
            'multiple="multiple" size="8"');

        $form = new JParameter('', JPATH_COMPONENT . DS . 'models' . DS . 'course.xml');

        $active = (intval($row->created_by) ? intval($row->created_by) : $user->get('id'));
        $form->set('created_by', $active);
        $form->set('created_by_alias', $row->created_by_alias);
        $form->set('created', JHTML::_('date', $row->created, '%Y-%m-%d %H:%M:%S'));
        $form->set('publish_up', JHTML::_('date', $row->publish_up, '%Y-%m-%d %H:%M:%S'));
        if (JHTML::_('date', $row->publish_down, '%Y') <= 1969 || $row->publish_down ==
            $db->getNullDate())
        {
            $form->set('publish_down', JText::_('Never'));
        } else
        {
            $form->set('publish_down', JHTML::_('date', $row->publish_down,
                '%Y-%m-%d %H:%M:%S'));
        }

        $form->loadINI($row->attribs);

        $form->set('description', $row->meta_description);
        $form->set('keywords', $row->meta_keywords);
        $form->loadINI($row->metadata);

        $js = "
		function qfSelectFile(id, file) {

			var name = 'a_name'+id;
			var ixid = 'a_id'+id;
			var txt = document.createElement('input');
			var hid = document.createElement('input');
			var br = document.createElement('br');

			var filelist = document.getElementById('filelist');

			var button = document.createElement('input');
			button.type = 'button';
			button.name = 'removebutton_'+id;
			button.id = 'removebutton_'+id;
			$(button).addEvent('click', function() { qfRemoveFile('" . JText::_('REMOVED') .
            "', id ) });
			button.value = '" . JText::_('REMOVE') . "';

			txt.type = 'text';
			txt.disabled = 'disabled';
			txt.id	= name;
			txt.value	= file;

			hid.type = 'hidden';
			hid.name = 'fid[]';
			hid.value = id;
			hid.id = ixid;

			filelist.appendChild(txt);
			filelist.appendChild(button);
			filelist.appendChild(hid);
			filelist.appendChild(br);
		}

		function qfRemoveFile(file, i) {

			var name = 'a_name' + i;
			var id = 'a_id' + i;

			document.getElementById(id).value = 0;
			document.getElementById(name).value = file;
		}";

        $document->addScriptDeclaration($js);

        JHTML::_('behavior.modal', 'a.modal');

        $i = 0;
        $fileselect = '';

        if ($files)
        {

            foreach ($files as $file)
            {
                $fileselect .= "\n<input style=\"background: #ffffff;\" type=\"text\" id=\"a_name" .
                    $i . "\" value=\"$file->filename\" disabled=\"disabled\" />";
                $fileselect .= "\n<input type=\"hidden\" id=\"a_id" . $i . "\" name=\"fid[]\" value=\"$file->fileid\" />";
                $fileselect .= "\n&nbsp;<input class=\"inputbox\" type=\"button\" onclick=\"qfRemoveFile('" .
                    JText::_('REMOVED') . "', " . $i . " );\" value=\"" . JText::_('REMOVE') . "\" />";
                $i++;
            }
        }
        $linkfsel = 'index.php?option=com_courseman&amp;view=fileselement&amp;tmpl=component&amp;index=' .
            $i;

        $lists['state'] = JHTML::_('select.booleanlist', 'state', '', $row->state);

        $lists['experience_level'] = JHTMLCourseman::getSelectExperienceLevel('id_experience_level', $row->
            id_experience_level, '');

        $lists['username'] = JHTMLCourseman::getSelectTutor('tutor_id', $row->
            tutor_id, '');

        $lists['atgroup'] = JHTMLCourseman::getSelectATGroup('id_group', $row->
            id_group, '');

        $lists['job_experience'] = JHTMLCourseman::getListFromXML('Job Experience',
            'job_experience', 0, $row->job_experience);

        $lists['price_type'] = JHTMLCourseman::getListFromXML('Price Type', 'price_type',
            '', $row->price_type);

        //$lists['currency_price'] = JHTMLCourseman::getListFromXML('Currency','currency_price', 0, $row->currency_price);

        $lists['email_template'] = JHTMLCourseman::getSelectEmailTemplate('email_template',
            $row->email_template, 0);

        $this->assignRef('lists', $lists);
        $this->assignRef('row', $row);
        $this->assignRef('editor', $editor);
        $this->assignRef('pane', $pane);
        $this->assignRef('nullDate', $nullDate);
        $this->assignRef('form', $form);
        $this->assignRef('fileselect', $fileselect);
        $this->assignRef('linkfsel', $linkfsel);
        parent::display($tpl);
    }
}

?>