<?php
/**
* @Copyright Copyright (C) 2010 www.profinvent.com. All rights reserved.
* @website http://www.profinvent.com
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 2 of the License, or
* any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
**/

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.view');

class CoursemanViewCourseman extends JView
{
    function display($tpl = null)
    {
        global $mainframe;

        jimport('joomla.html.pane');

        $document = &JFactory::getDocument();
        $pane = &JPane::getInstance('sliders');
        $lang = &JFactory::getLanguage();
        $template = $mainframe->getTemplate();
        $params = &JComponentHelper::getParams('com_courseman');

        $latestJobs = &$this->get('LatestJobs');
        $latestApplications = &$this->get('LatestApplications');

        JToolBarHelper::title(JText::_('Course Manager'), 'courseman');

        $document->addStyleSheet('components/com_courseman/assets/css/coursemanbackend.css');
        if ($lang->isRTL())
        {
            $document->addStyleSheet('components/com_courseman/assets/css/coursemanbackend_rtl.css');
        }

    	JSubMenuHelper::addEntry(JText::_('HOME'), 'index.php?option=com_courseman',true);
    	JSubMenuHelper::addEntry(JText::_('APPLICATIONS'),'index.php?option=com_courseman&view=applications');
    	JSubMenuHelper::addEntry(JText::_('COURSES'),'index.php?option=com_courseman&view=courses');
    	JSubMenuHelper::addEntry(JText::_('CATEGORIES'),'index.php?option=com_courseman&view=categories');
    	JSubMenuHelper::addEntry(JText::_('TAGS'),'index.php?option=com_courseman&view=tags');
    	JSubMenuHelper::addEntry(JText::_('TUTORS'),'index.php?option=com_courseman&view=tutors');

        if ($params->get('show_updatecheck'))
        {
            $check = &$this->get('Update');

        } else
        {
            $check = array();
            $check['enabled'] = 0;
            $check['connect'] = 0;
        }


        $this->assignRef('pane', $pane);
        $this->assignRef('latestApplications', $latestApplications);
        $this->assignRef('latestJobs', $latestJobs);
        $this->assignRef('check', $check);
        $this->assignRef('template', $template);

        parent::display($tpl);

    }

    function quickiconButton($link, $image, $text, $modal = 0)
    {

        $lang = &JFactory::getLanguage();

?>

		<div class="<?php

        echo ($lang->isRTL()) ? 'floright' : 'floleft';

?>;">
			<div class="icon">
				<?php

        if ($modal == 1)
        {
            JHTML::_('behavior.modal');

?>
					<a href="<?php

            echo $link . '&amp;tmpl=component';

?>" style="cursor:pointer" class="modal" rel="{handler: 'iframe', size: {x: 650, y: 400}}">
				<?php

        } else
        {

?>
					<a href="<?php

            echo $link;

?>">
				<?php

        }

        echo JHTML::_('image', 'administrator/components/com_courseman/assets/images/' . $image,
            $text);

?>
					<span><?php

        echo $text;

?></span>
				</a>
			</div>
		</div>
		<?php

    }
}

?>