<?php
/**
* @Copyright Copyright (C) 2010 www.profinvent.com. All rights reserved.
* @website http://www.profinvent.com
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 2 of the License, or
* any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
**/

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.view');

class CoursemanViewCourses extends JView
{

    function display($tpl = null)
    {
        global $mainframe, $option;

        $user = &JFactory::getUser();
        $db = &JFactory::getDBO();
        $document = &JFactory::getDocument();
        $lang = &JFactory::getLanguage();
    	$params = &JComponentHelper::getParams( 'com_courseman' );


        JHTML::_('behavior.tooltip');

        $filter_order = $mainframe->getUserStateFromRequest($option .'.courses.filter_order', 'filter_order', 'i.ordering', 'cmd');
        $filter_order_Dir = $mainframe->getUserStateFromRequest($option .
            '.courses.filter_order_Dir', 'filter_order_Dir', '', 'word');
        $filter_state = $mainframe->getUserStateFromRequest($option .
            '.courses.filter_state', 'filter_state', '*', 'word');
	$filter_category = $mainframe->getUserStateFromRequest($option .
            '.courses.filter_category', 'filter_category', '*');
     $search = $mainframe->getUserStateFromRequest($option . '.courses.search',
            'search', '', 'string');
        $search = $db->getEscaped(trim(JString::strtolower($search)));

        $document->addStyleSheet('components/com_courseman/assets/css/coursemanbackend.css');
        if ($lang->isRTL())
        {
            $document->addStyleSheet('components/com_courseman/assets/css/coursemanbackend_rtl.css');
        }

    	JSubMenuHelper::addEntry(JText::_('HOME'), 'index.php?option=com_courseman');
    	JSubMenuHelper::addEntry(JText::_('APPLICATIONS'),'index.php?option=com_courseman&view=applications');
    	JSubMenuHelper::addEntry(JText::_('COURSES'),'index.php?option=com_courseman&view=courses', true);
    	JSubMenuHelper::addEntry(JText::_('CATEGORIES'),'index.php?option=com_courseman&view=categories');
    	JSubMenuHelper::addEntry(JText::_('TAGS'),'index.php?option=com_courseman&view=tags');
    	JSubMenuHelper::addEntry(JText::_('TUTORS'),'index.php?option=com_courseman&view=tutors');

        JToolBarHelper::title(JText::_('COURSES'), 'courses');
        JToolBarHelper::addNew();
        JToolBarHelper::editList();
    	//JToolBarHelper::customX( 'copy', 'copy.png', 'copy_f2.png', 'Copy' );
        JToolBarHelper::deleteList();
        JToolBarHelper::archiveList();
        $rows = &$this->get('Data');
        $pageNav = &$this->get('Pagination');



    	foreach ($rows as $row):
    	//show sessions
    	$db =& JFactory::getDBO();
    	$sql = 'SELECT min(session_date) AS start_date, max(session_date) AS finish_date FROM #__courseman_sessions'
    		. ' WHERE published = 1'
    		. ' AND courseid = '.$row->id
    		. ' ORDER BY ordering';
    	$db->setQuery($sql);
    	$course_sessions_dates = $db->loadObjectList();

    		foreach ($course_sessions_dates as $course_sessions2):
    			$row->start_date = $course_sessions2->start_date;
    			$row->finish_date = $course_sessions2->finish_date;
    		endforeach;

    	$sql = 'SELECT * FROM #__courseman_sessions'
    			. ' WHERE published = 1'
    			. ' AND courseid = '.$row->id
    			. ' ORDER BY ordering';
    		$db->setQuery($sql);
    		$course_sessions = $db->loadObjectList();
		$row->count_sessions = count($course_sessions);



    	$itemParams = new JParameter($row->attribs);

    	//set start and finish dates
    	if ($itemParams->get('show_start_date')){
    	} elseif ($itemParams->get('show_start_date')<>"") {
    		$row->start_date = JText::_('Not Specified');
    	}
    	if ($itemParams->get('show_finish_date')){
    	} elseif ($itemParams->get('show_finish_date')<>"") {
    		$row->finish_date = JText::_('Not Specified');
    	}

    		//capacity check
    		switch ($params->get('current_capacity'))
    		{
    			// cases for a parameter
    			case 1:
    				$current_capacity_setting=-1;
    				break;

    			case 2:
    				$current_capacity_setting=0;
    				break;

    			default:
    				$current_capacity_setting=-1;
    				break;
    		}
    		//add currentbookings information
    		$db =& JFactory::getDBO();
    		$sql = 'SELECT SUM(b.attendees)'
    			. ' FROM #__courseman_application AS b'
    			. ' WHERE b.published = 1'
    			. ' AND b.course_id = '.$row->id
    			. ' AND b.status > '.$current_capacity_setting
    			. ' AND b.status < 3';
    		$db->setQuery($sql);
    		$row->currentAvailability = ($row->capacity)-($db->loadResult());
		endforeach;




        $lists['state'] = JHTML::_('grid.state', $filter_state);

        $lists['search'] = $search;

        $lists['order_Dir'] = $filter_order_Dir;
        $lists['order'] = $filter_order;

        $ordering = ($lists['order'] == 'i.ordering');

        $categories = courseman_cats::getCategoriesTree(0);
        $lists['category'] = courseman_cats::buildcatselect($categories, 'filter_category', $filter_category, true, 'class="inputbox" onchange="submitform( );"');

        $this->assignRef('lists', $lists);
        $this->assignRef('rows', $rows);
        $this->assignRef('pageNav', $pageNav);
        $this->assignRef('ordering', $ordering);
        $this->assignRef('user', $user);
        $this->assignRef('direction', $lang);

        parent::display($tpl);
    }
}

?>