<?php
/**
* @Copyright Copyright (C) 2010 www.profinvent.com. All rights reserved.
* @website http://www.profinvent.com
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 2 of the License, or
* any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
**/

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.view');

class CoursemanViewEditfield extends JView
{

    function display($tpl = null)
    {
        global $mainframe;

        $document = &JFactory::getDocument();
        $user = &JFactory::getUser();
        $lang = &JFactory::getLanguage();
    	JHTML::_('behavior.tooltip');

        $cid = JRequest::getVar('cid');

        $document->addStyleSheet('components/com_courseman/assets/css/coursemanbackend.css');
        if ($lang->isRTL())
        {
            $document->addStyleSheet('components/com_courseman/assets/css/coursemanbackend_rtl.css');
        }

        if ($cid)
        {
            JToolBarHelper::title(JText::_('Edit Custom Field'), 'config');

        } else
        {
            JToolBarHelper::title(JText::_('Add Custom Field'), 'config');
            JSubMenuHelper::addEntry(JText::_('HOME'), 'index.php?option=com_courseman');
            JSubMenuHelper::addEntry(JText::_('courses'),
                'index.php?option=com_courseman&view=courses');
            JSubMenuHelper::addEntry(JText::_('CATEGORIES'),
                'index.php?option=com_courseman&view=categories');
            JSubMenuHelper::addEntry(JText::_('TAGS'),
                'index.php?option=com_courseman&view=tags');
            JSubMenuHelper::addEntry(JText::_('ARCHIVE'),
                'index.php?option=com_courseman&view=archive');
            JSubMenuHelper::addEntry(JText::_('FILEMANAGER'),
                'index.php?option=com_courseman&view=filemanager');
            JSubMenuHelper::addEntry(JText::_('STATISTICS'),
                'index.php?option=com_courseman&view=stats');
        }
        JToolBarHelper::apply();
        JToolBarHelper::spacer();
        JToolBarHelper::save();
        JToolBarHelper::spacer();
        JToolBarHelper::cancel();

        $model = &$this->getModel();
        $row = &$this->get('Tag');

        if ($row->id)
        {
            if ($model->isCheckedOut($user->get('id')))
            {
                JError::raiseWarning('SOME_ERROR_CODE', $row->name . ' ' . JText::_('EDITED BY ANOTHER ADMIN'));
                $mainframe->redirect('index.php?option=com_courseman&view=editfields');
            }
        }

        //JFilterOutput::objectHTMLSafe($row, ENT_QUOTES);

    	//custom fields
    	//$model			=& $this->getModel( 'editfields' );
    	$fieldGroups	= $model->getGroups();
    	$group			= $model->getFieldGroup( $row->ordering );
    	//end cf


        $this->assignRef('row', $row);
    	$this->assignRef('fieldGroups', $fieldGroups);
    	$this->assignRef('group', $group);

        parent::display($tpl);
    }
	function _buildRadio($status, $fieldname, $values)
	{
		$html	= '<span>';

		if($status || $status == '1'){
			$html	.= '<input type="radio" name="' . $fieldname . '" value="1" checked="checked" />' . $values[0];
			$html	.= '<input type="radio" name="' . $fieldname . '" value="0" />' . $values[1];
		} else {
			$html	.= '<input type="radio" name="' . $fieldname . '" value="1" />' . $values[0];
			$html	.= '<input type="radio" name="' . $fieldname . '" value="0" checked="checked" />' . $values[1];
		}
		$html	.= '</span>';

		return $html;
	}

	function _buildTypes( $selectedType )
	{

		$model	=& $this->getModel( 'Editfield' );
		$html	= '';
		$types	= $model->getCustomfieldsTypes();

		$html	.= '<select name="type" onchange="azcommunity.changeType(this.value)" id="type">';

		foreach( $types as $type => $value)
		{
			$selected	= ( trim($type) == $selectedType ) ? 'selected="true"' : '';
			$html		.= '<option value="' . $type . '"' . $selected . '>' . $value . '</option>';
		}
		return $html;
	}


	function _buildOptions(& $row, $id, $type)
	{
		if( $this->row->type == 'select' || $this->row->type == 'singleselect' || $this->row->type == 'radio' || $this->row->type == 'list' || $this->row->type == 'checkbox')
		{
			$html	= '<tr style="display: table-row;" class="fieldOptions">';
		}
		else
		{
			$html	= '<tr style="display: none;" class="fieldOptions">';
		}


		$html	.= '	<td class="key" valign="top">
							<span>Option</span><br />
						</td>
						<td valign="top">:</td>
						<td colspan="4">';
		$html	.= '<textarea rows="4" cols="50" name="options">' . $this->row->options . '</textarea><br />'
				 . '<span>Separate each options with a new line</span>';

		return $html;
	}

	function _buildSize(&$row)
	{
		if( $this->row->type == 'text' || $this->row->type == 'textarea' || $this->row->type == '')
		{
			$html	= '<tr style="display: table-row;" class="fieldSizes">';
		}
		else
		{
			$html	= '<tr style="display: none;" class="fieldSizes">';
		}

		$html	.= '<td class="key">' . JText::_('MINIMUM CHARACTERS') . '</td>'
				 . '<td>:</td>'
				 . '<td>'
				 . '	<input type="text" name="min" size="5" value="' . $this->row->min . '" />'
				 . '</td>'
				 . '<td class="key">' . JText::_('MAXIMUM CHARACTERS') . '</td>'
				 . '<td>:</td>'
				 . '<td>'
				 . '	<input type="text" name="max" size="5" value="' . $this->row->max . '" />'
				 . '</td>'
				 . '</tr>';
		return $html;
	}
}

?>