<?php
/**
* @Copyright Copyright (C) 2010 www.profinvent.com. All rights reserved.
* @website http://www.profinvent.com
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 2 of the License, or
* any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
**/

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.view');

class CoursemanViewEditvirtualtables extends JView
{

    function display($tpl = null)
    {

        global $mainframe;

        $document = &JFactory::getDocument();
        $user = &JFactory::getUser();
        $lang = &JFactory::getLanguage();

        if ($user->get('gid') < 24)
        {
            JError::raiseWarning('ERROR', JText::_('ALERTNOTAUTH'));
            $mainframe->redirect('index.php?option=com_courseman&view=courseman');
        }

        $option = JRequest::getVar('option');
        $filename = 'virtual_tables.xml';
        $path = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_courseman' . DS .
            'tables';
        $xml_path = $path . DS . $filename;

        JToolBarHelper::title(JText::_('EDIT XML TABLES'), 'qfeditcss');
        JToolBarHelper::apply('applyxml');
        JToolBarHelper::spacer();
        JToolBarHelper::save('savexml');
        JToolBarHelper::spacer();
        JToolBarHelper::cancel();

        JRequest::setVar('hidemainmenu', 1);

        $document->addStyleSheet('components/com_courseman/assets/css/coursemanbackend.css');
        if ($lang->isRTL())
        {
            $document->addStyleSheet('components/com_courseman/assets/css/coursemanbackend_rtl.css');
        }

        jimport('joomla.filesystem.file');
        $content = JFile::read($xml_path);

        jimport('joomla.client.helper');
        $ftp = &JClientHelper::setCredentialsFromRequest('ftp');

        if ($content !== false)
        {
            $content = htmlspecialchars($content, ENT_COMPAT, 'UTF-8');
        } else
        {
            $msg = JText::sprintf('FAILED TO OPEN FILE FOR WRITING', $xml_path);
            $mainframe->redirect('index.php?option=' . $option, $msg);
        }

        $this->assignRef('xml_path', $xml_path);
        $this->assignRef('content', $content);
        $this->assignRef('filename', $filename);
        $this->assignRef('ftp', $ftp);


        parent::display($tpl);
    }
}