<?php
/**
* @Copyright Copyright (C) 2010 www.profinvent.com. All rights reserved.
* @website http://www.profinvent.com
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 2 of the License, or
* any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
**/

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.view');

class CoursemanViewTag extends JView
{

    function display($tpl = null)
    {
        global $mainframe;

        $document = &JFactory::getDocument();
        $user = &JFactory::getUser();
        $lang = &JFactory::getLanguage();

        $cid = JRequest::getVar('cid');

        $document->addStyleSheet('components/com_courseman/assets/css/coursemanbackend.css');
        if ($lang->isRTL())
        {
            $document->addStyleSheet('components/com_courseman/assets/css/coursemanbackend_rtl.css');
        }

        if ($cid)
        {
            JToolBarHelper::title(JText::_('EDIT TAG'), 'tagedit');

        } else
        {
            JToolBarHelper::title(JText::_('ADD TAG'), 'tagedit');

            JSubMenuHelper::addEntry(JText::_('HOME'), 'index.php?option=com_courseman');
            JSubMenuHelper::addEntry(JText::_('courseS'),
                'index.php?option=com_courseman&view=courses');
            JSubMenuHelper::addEntry(JText::_('CATEGORIES'),
                'index.php?option=com_courseman&view=categories');
            JSubMenuHelper::addEntry(JText::_('TAGS'),
                'index.php?option=com_courseman&view=tags');
            JSubMenuHelper::addEntry(JText::_('ARCHIVE'),
                'index.php?option=com_courseman&view=archive');
            JSubMenuHelper::addEntry(JText::_('FILEMANAGER'),
                'index.php?option=com_courseman&view=filemanager');
            JSubMenuHelper::addEntry(JText::_('STATISTICS'),
                'index.php?option=com_courseman&view=stats');
        }
        JToolBarHelper::apply();
        JToolBarHelper::spacer();
        JToolBarHelper::save();
        JToolBarHelper::spacer();
        JToolBarHelper::cancel();

        $model = &$this->getModel();
        $row = &$this->get('Tag');

        if ($row->id)
        {
            if ($model->isCheckedOut($user->get('id')))
            {
                JError::raiseWarning('SOME_ERROR_CODE', $row->name . ' ' . JText::_('EDITED BY ANOTHER ADMIN'));
                $mainframe->redirect('index.php?option=com_courseman&view=tags');
            }
        }

        JFilterOutput::objectHTMLSafe($row, ENT_QUOTES);

        $this->assignRef('row', $row);

        parent::display($tpl);
    }
}

?>