<?php
/**
* @Copyright Copyright (C) 2010 www.profinvent.com. All rights reserved.
* @website http://www.profinvent.com
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 2 of the License, or
* any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
**/

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.view');

class coursemanViewtutor extends JView
{
    function display($tpl = null)
    {
        global $mainframe;
        $childviewname = 'tutor';

        if ($this->getLayout() == 'form')
        {
            $this->_displayForm($tpl);
            return;
        }

        $tutor = &$this->get('data');

        if ($tutor->url)
        {

            $mainframe->redirect($tutor->url);
        }

        parent::display($tpl);
    }

    function _displayForm($tpl)
    {
        global $mainframe, $option;

        $db = &JFactory::getDBO();
        $uri = &JFactory::getURI();
        $user = &JFactory::getUser();
        $model = &$this->getModel();
        $document = &JFactory::getDocument();
        $lang = &JFactory::getLanguage();

        $document->addStyleSheet('components/com_courseman/assets/css/coursemanbackend.css');
        if ($lang->isRTL())
        {
            $document->addStyleSheet('components/com_courseman/assets/css/coursemanbackend_rtl.css');
        }


        $lists = array();

        $tutor = &$this->get('data');
        $isNew = ($tutor->id < 1);

        require_once (JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_courseman' . DS .
            'helpers' . DS . 'courseman.php');

        $document->addScript(JURI::base() .
            'components/com_courseman/assets/js/fieldsmanipulation.js');

        if ($model->isCheckedOut($user->get('id')))
        {
            $msg = JText::sprintf('DESCBEINGEDITTED', JText::_('Tutor'), $tutor->
                title);
            $mainframe->redirect('index.php?option=' . $option, $msg);
        }

        if (!$isNew)
        {
            $model->checkout($user->get('id'));
            $disabled = 1;
        } else
        {

            $disabled = 0;
            $tutor->published = 1;
            $tutor->approved = 1;
            $tutor->order = 0;
        }

        $query = 'SELECT ordering AS value, title AS text' . ' FROM #__courseman_tutor' .
            ' ORDER BY ordering';

        $lists['ordering'] = JHTML::_('list.specificordering', $tutor, $tutor->id,
            $query);

        $lists['published'] = JHTML::_('select.booleanlist', 'published',
            'class="inputbox"', $tutor->published);

        $lists['username'] = JHTMLCourseman::getSelectUser('user_id', $tutor->user_id, $disabled);

        $lists['salutation'] = JHTMLCourseman::getListFromXML('Salutation', 'salutation', 0,
            $tutor->salutation);

        $lists['country'] = JHTMLCourseman::getSelectCountry('id_country', $tutor->
            id_country, '');

        $lists['company_type'] = JHTMLCourseman::getSelectCompType('id_comp_type', $tutor->
            id_comp_type, '');

        $lists['industry'] = JHTMLCourseman::getListFromXML('Industry', 'industry', 0, $tutor->
            industry);

        $lists['billing_country'] = JHTMLCourseman::getSelectCountry('bill_id_country', $tutor->
            bill_id_country, '');

        JFilterOutput::objectHTMLSafe($tutor, ENT_QUOTES, 'description');

        $file = JPATH_COMPONENT . DS . 'models' . DS . 'tutor.xml';
        $params = new JParameter($tutor->params, $file);

        $this->assignRef('lists', $lists);
        $this->assignRef('tutor', $tutor);
        $this->assignRef('params', $params);

        parent::display($tpl);
    }
}