<?php
/**
* @Copyright Copyright (C) 2010 www.profinvent.com. All rights reserved.
* @website http://www.profinvent.com
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 2 of the License, or
* any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
**/

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.view');

class coursemanViewtutors extends JView
{
    function display($tpl = null)
    {
        global $mainframe, $option;

        $db = &JFactory::getDBO();
        $uri = &JFactory::getURI();
        $document = &JFactory::getDocument();
        $lang = &JFactory::getLanguage();
        $childviewname = 'tutors';

        $document->addStyleSheet('components/com_courseman/assets/css/coursemanbackend.css');
        if ($lang->isRTL())
        {
            $document->addStyleSheet('components/com_courseman/assets/css/coursemanbackend_rtl.css');
        }

    	JSubMenuHelper::addEntry(JText::_('HOME'), 'index.php?option=com_courseman');
    	JSubMenuHelper::addEntry(JText::_('APPLICATIONS'),'index.php?option=com_courseman&view=applications');
    	JSubMenuHelper::addEntry(JText::_('COURSES'),'index.php?option=com_courseman&view=courses');
    	JSubMenuHelper::addEntry(JText::_('CATEGORIES'),'index.php?option=com_courseman&view=categories');
    	JSubMenuHelper::addEntry(JText::_('TAGS'),'index.php?option=com_courseman&view=tags');
    	JSubMenuHelper::addEntry(JText::_('TUTORS'),'index.php?option=com_courseman&view=tutors', true);

        JToolBarHelper::title(JText::_('Tutors'), 'tutors');
        JToolBarHelper::publishList();
        JToolBarHelper::unpublishList();
        JToolBarHelper::deleteList();
        JToolBarHelper::editListX();
        JToolBarHelper::addNewX();
        //JToolBarHelper::help('courseman.help', 1);

        $filter_state = $mainframe->getUserStateFromRequest($option .
            '.tutors.filter_state', 'filter_state', '', 'word');
        $filter_order = $mainframe->getUserStateFromRequest($option .
            '.tutors.filter_order', 'filter_order', 'a.ordering', 'cmd');
        $filter_order_Dir = $mainframe->getUserStateFromRequest($option .
            '.tutors.filter_order_Dir', 'filter_order_Dir', '', 'word');
        $search = $mainframe->getUserStateFromRequest($option . '.tutors.search',
            'search', '', 'string');
        $search = JString::strtolower($search);

        $courses = &$this->get('Data');
        $total = &$this->get('Total');
        $pagination = &$this->get('Pagination');

        for ($i = 0; $i < count($courses); $i++)
        {

            if (($courses[$i]->userpublished) == 1)
            {
                $courses[$i]->published = 0;
            } else
            {
                $courses[$i]->published = 1;
            }
        }

        $requestURL = &$uri->toString();

        $lists['state'] = JHTML::_('grid.state', $filter_state);

        $lists['order_Dir'] = $filter_order_Dir;
        $lists['order'] = $filter_order;

        $lists['search'] = $search;

        $this->assignRef('user', JFactory::getUser());
        $this->assignRef('lists', $lists);
        $this->assignRef('courses', $courses);
        $this->assignRef('pagination', $pagination);
        $this->assignRef('requestURL', $requestURL);

        parent::display($tpl);
    }
}