<?php
/**
* @Copyright Copyright (C) 2010 www.profinvent.com. All rights reserved.
* @website http://www.profinvent.com
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 2 of the License, or
* any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
**/

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.controller');

class CoursemanController extends JController
{
    function __construct()
    {
        parent::__construct();
    }

    function display()
    {



        $user = &JFactory::getUser();
        if ($user->get('id') || JRequest::getVar('view') == 'category')
        {
            parent::display(false);
        } else
        {
            parent::display(true);
        }
    }

    function edit()
    {
        $user = &JFactory::getUser();

        $view = &$this->getView('Courses', 'html');

        if (!($user->authorize('com_courseman', 'edit') || $user->authorize('com_content',
            'edit', 'content', 'own')))
        {
            JError::raiseError(403, JText::_("ALERTNOTAUTH"));
        }

        $model = &$this->getModel('Courses');

        if ($model->get('id') > 1 && !($user->authorize('com_courseman', 'edit') || ($user->
            authorize('com_content', 'edit', 'content', 'own') && $model->get('created_by') ==
            $user->get('id'))))
        {
            JError::raiseError(403, JText::_("ALERTNOTAUTH"));
        }

        if ($model->isCheckedOut($user->get('id')))
        {
            $msg = JText::sprintf('DESCBEINGEDITTED', JText::_('The course'), $model->get('title'));
            $this->setRedirect(JRoute::_('index.php?view=courses&id=' . $model->get('id'), false),
                $msg);
            return;
        }

        $model->checkout();

        $view->setModel($model, true);

        $view->setLayout('form');

        $view->display();
    }

    function add()
    {
        $user = &JFactory::getUser();

        $view = &$this->getView('Courses', 'html');

        if (!$user->authorize('com_courseman', 'add'))
        {
            JError::raiseError(403, JText::_("ALERTNOTAUTH"));
        }

        $model = &$this->getModel('Courses');

        $view->setModel($model, true);

        $view->setLayout('form');

        $view->display();
    }

    function save()
    {

        JRequest::checkToken() or jexit('Invalid Token');

        $db = &JFactory::getDBO();
        $user = &JFactory::getUser();

        $model = $this->getModel('Courses');

        $post = JRequest::get('post');

        $isNew = ((int)$post['id'] < 1);

        if ($user->get('id') < 1)
        {
            JError::raiseError(403, JText::_('ALERTNOTAUTH'));
            return;
        }

        if (!(($user->authorize('com_courseman', 'edit') || $user->authorize('com_content',
            'edit', 'content', 'own')) || $user->authorize('com_courseman', 'add')))
        {
            JError::raiseError(403, JText::_("ALERTNOTAUTH"));
        }

        if ($model->store($post))
        {
            if ($isNew)
            {
                $post['id'] = (int)$model->get('id');
            }
        } else
        {
            $msg = JText::_('ERROR STORING course');
            JError::raiseError(500, $model->getError());
        }

        $model->checkin();

        if ($isNew)
        {

            $query = 'SELECT DISTINCT c.id, c.title,' .
                ' CASE WHEN CHAR_LENGTH(c.alias) THEN CONCAT_WS(\':\', c.id, c.alias) ELSE c.id END as slug' .
                ' FROM #__courseman_categories AS c' .
                ' LEFT JOIN #__courseman_cats_course_relations AS rel ON rel.catid = c.id' .
                ' WHERE rel.courseid = ' . (int)$model->get('id');

            $db->setQuery($query);

            $categories = $db->loadObjectList();

            $n = count($categories);
            $i = 0;
            $catstring = '';
            foreach ($categories as $category)
            {
                $catstring .= $category->title;
                $i++;
                if ($i != $n)
                {
                    $catstring .= ', ';
                }
            }

            $query = 'SELECT id, email, name' . ' FROM #__users' . ' WHERE sendEmail = 1';
            $db->setQuery($query);
            if (!$db->query())
            {
                JError::raiseError(500, $db->stderr(true));
                return;
            }
            $adminRows = $db->loadObjectList();

            require_once (JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_messages' . DS .
                'tables' . DS . 'message.php');

            foreach ($adminRows as $adminRow)
            {



                $message = new TableMessage($db);
                $message->send($user->get('id'), $adminRow->id, JText::_('NEW courseman course'),
                    JText::sprintf('ON NEW course', $post['title'], $user->get('username'), $catstring));
            }

        } else
        {

            $cache = &JFactory::getCache('com_courseman');
            $cache->clean();
        }

        if ($user->authorize('com_courseman', 'state'))
        {
            $msg = JText::_('course SAVED');
        } else
        {
            $msg = $isNew ? JText::_('THANKS SUBMISSION') : JText::_('course SAVED');
        }

        $link = JRequest::getString('referer', JURI::base(), 'post');
        $this->setRedirect($link, $msg);
    }

    function cancel()
    {

        $user = &JFactory::getUser();

        $course = &JTable::getInstance('courseman_courses', '');
        $course->bind(JRequest::get('post'));

        if ($user->authorize('com_courseman', 'edit') || $user->authorize('com_courseman',
            'edit', 'own'))
        {
            $course->checkin();
        }

        $referer = JRequest::getString('referer', JURI::base(), 'post');
        $this->setRedirect($referer);
    }

    function vote()
    {
        global $mainframe;

        $id = JRequest::getInt('id', 0);
        $cid = JRequest::getInt('cid', 0);
        $vote = JRequest::getInt('vote', 0);
        $session = &JFactory::getSession();
        $params = &$mainframe->getParams('com_courseman');

        if (!$params->get('show_vote'))
        {
            return;
        }

        $cookieName = JUtility::getHash($mainframe->getName() . 'coursemanvote' . $id);
        $voted = JRequest::getVar($cookieName, '0', 'COOKIE', 'INT');

        $votecheck = false;
        if ($session->has('vote', 'courseman'))
        {
            $votecheck = $session->get('vote', 0, 'courseman');
            $votecheck = in_array($id, $votecheck);
        }

        if ($voted || $votecheck)
        {
            JError::raiseWarning(JText::_('SOME ERROR CODE'), JText::_('YOU ALLREADY VOTED'));
        } else
        {
            setcookie($cookieName, '1', time() + 1 * 24 * 60 * 60 * 60);

            $stamp = array();
            $stamp[] = $id;
            $session->set('vote', $stamp, 'courseman');

            $model = $this->getModel('courses');
            if ($model->storevote($id, $vote))
            {
                $msg = JText::_('VOTE COUNTED');
            } else
            {
                $msg = JText::_('VOTE FAILURE');
                JError::raiseError(500, $model->getError());
            }
        }

        $cache = &JFactory::getCache('com_courseman');
        $cache->clean();

        $this->setRedirect(JRoute::_('index.php?view=courses&cid=' . $cid . '&id=' . $id, false),
            $msg);
    }

    function getajaxtags()
    {
        $user = JFactory::getUser();

        if (!$user->authorize('com_courseman', 'newtags'))
        {
            return;
        }

        $id = JRequest::getInt('id', 0);
        $model = $this->getModel('Courses');
        $tags = $model->getAlltags();

        $used = null;

        if ($id)
        {

            $used = $model->getUsedtags();
        }
        if (!is_array($used))
        {
            $used = array();
        }

        $rsp = '';
        $n = count($tags);
        for ($i = 0, $n; $i < $n; $i++)
        {
            $tag = $tags[$i];

            if (($i % 5) == 0)
            {
                if ($i != 0)
                {
                    $rsp .= '</div>';
                }
                $rsp .= '<div class="qf_tagline">';
            }
            $rsp .= '<span class="qf_tag"><span class="qf_tagidbox"><input type="checkbox" name="tag[]" value="' .
                $tag->id . '"' . (in_array($tag->id, $used) ? 'checked="checked"' : '') .
                ' /></span>' . $tag->name . '</span>';
        }
        $rsp .= '</div>';
        $rsp .= '<div class="clear"></div>';
        $rsp .= '<div class="qf_addtag">';
        $rsp .= '<label for="addtags">' . JText::_('ADD TAG') . '</label>';
        $rsp .= '<input type="text" id="tagname" class="inputbox" size="30" />';
        $rsp .= '<input type="button" class="button" value="' . JText::_('ADD TAG BUTTON') .
            '" onclick="addtag()" />';
        $rsp .= '</div>';

        echo $rsp;
    }

    function addtag()
    {

        $user = JFactory::getUser();

        $name = JRequest::getString('name', '');

        if ($user->authorize('com_courseman', 'newtags'))
        {
            $model = $this->getModel('courses');
            $model->addtag($name);
        }
        return;
    }

    function addfavourite()
    {
        $cid = JRequest::getInt('cid', 0);
        $id = JRequest::getInt('id', 0);

        $model = $this->getModel('courses');
        if ($model->addfav())
        {
            $msg = JText::_('FAVOURITE ADDED');
        } else
        {
            JError::raiseError(500, $model->getError());
            $msg = JText::_('FAVOURITE NOT ADDED');
        }

        $cache = &JFactory::getCache('com_courseman');
        $cache->clean();

        $this->setRedirect(JRoute::_('index.php?view=courses&cid=' . $cid . '&id=' . $id, false),
            $msg);

        return;
    }

    function removefavourite()
    {
        $cid = JRequest::getInt('cid', 0);
        $id = JRequest::getInt('id', 0);

        $model = $this->getModel('courses');
        if ($model->removefav())
        {
            $msg = JText::_('FAVOURITE REMOVED');
        } else
        {
            JError::raiseError(500, $model->getError());
            $msg = JText::_('FAVOURITE NOT REMOVED');
        }

        $cache = &JFactory::getCache('com_courseman');
        $cache->clean();

        if ($cid)
        {
            $this->setRedirect(JRoute::_('index.php?option=com_courseman&view=courses&cid=' . $cid . '&id=' . $id, false),
                $msg);
        } else
        {
            $this->setRedirect(JRoute::_('index.php?option=com_courseman&view=favourites', false), $msg);
        }

        return;
    }


    function download()
    {
        global $mainframe;

        jimport('joomla.filesystem.file');

        $id = JRequest::getInt('fileid', 0);
        $db = &JFactory::getDBO();

        $query = 'SELECT filename' . ' FROM #__courseman_files' . ' WHERE id = ' . (int)$id;
        $db->setQuery($query);
        $file = $db->loadResult();

        $basePath = COM_courseman_FILEPATH;

        $abspath = str_replace(DS, '/', JPath::clean($basePath . DS . $file));

        if (!JFile::exists($abspath))
        {
            return;
        }

        $size = filesize($abspath);
        $ext = strtolower(JFile::getExt($file));

        $filetable = &JTable::getInstance('courseman_files', '');
        $filetable->hit($id);

        if (ini_get('zlib.output_compression'))
        {
            ini_set('zlib.output_compression', 'Off');
        }

        switch ($ext)
        {
            case "pdf":
                $ctype = "application/pdf";
                break;
            case "exe":
                $ctype = "application/octet-stream";
                break;
            case "rar":
            case "zip":
                $ctype = "application/zip";
                break;
            case "txt":
                $ctype = "text/plain";
                break;
            case "doc":
                $ctype = "application/msword";
                break;
            case "xls":
                $ctype = "application/vnd.ms-excel";
                break;
            case "ppt":
                $ctype = "application/vnd.ms-powerpoint";
                break;
            case "gif":
                $ctype = "image/gif";
                break;
            case "png":
                $ctype = "image/png";
                break;
            case "jpeg":
            case "jpg":
                $ctype = "image/jpg";
                break;
            case "mp3":
                $ctype = "audio/mpeg";
                break;
            default:
                $ctype = "application/force-download";
        }
        header("Pragma: public");

        header("Expires: 0");
        header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
        header("Cache-Control: private", false);

        header("Content-Type: $ctype");

        header("Content-Disposition: attachment; filename=\"" . $file . "\";");
        header("Content-Transfer-Encoding: binary");
        header("Content-Length: " . $size);

        readfile($abspath);
        $mainframe->close();
    }
}

?>