<?php
/**
*
* @Copyright Copyright (C) 2010 www.profinvent.com. All rights reserved.
* @website http://www.profinvent.com
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 2 of the License, or
* any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.controller');

class coursemanControllerApplication extends coursemanController{
    function save()
    {
        JRequest::checkToken() or jexit('Invalid Token');

        $db = &JFactory::getDBO();
        $user = &JFactory::getUser();
        global $mainframe;
        $params = &$mainframe->getParams();
        $model = $this->getModel('application');
        $post = JRequest::get('post');
        $post['user_id'] = $user->get('id');
        $post['published'] = 1;

        $values = array();
        $model = $this->getModel('courses');
        $editfields = $model->getEditableCustomfields($post['user_id']);
        $model = $this->getModel('application');
        $mainframe = &JFactory::getApplication();
        CFactory::load('libraries' , 'customfields');

        // tincaptcha-
        if ($params->get('show_tincaptcha')){
        $captchk = plgSystemTincaptcha::check(JRequest::getVar('captcha', '', 'post'));
        if ($captchk !== true) {
            JError::raiseWarning(0, $captchk);
            return false;
            }
        }
      // -tincaptcha

        foreach($editfields['fields'] as $group => $fields){
            foreach($fields as $data){
                // Get value from submitted form = post data.
                $postData = JRequest::getVar('field' . $data['id'] , '' , 'POST');
                $values[ $data['id'] ] = CoursemanCustomfieldsLibrary::formatData($data['type'] , $postData);
                //  @rule : Validate custom customfields if necessary
                if (!CoursemanCustomfieldsLibrary::validateField($data['type'] , $values[ $data['id'] ] , $data['required'])){
                    // If there are errors on the form, display to the user.
                    $message = JText::sprintf('FIELD CONTAINS NOT ACCEPTABLE VALUES' , $data['name']);
                    $mainframe->enqueueMessage($message , 'error');
                    return;
                }
            }
        }
        // list of courses
        $query = 'SELECT *' . ' FROM #__courseman_courses' . ' WHERE id =' . $post['course_id'];
        $db->setQuery($query);
        if (!$db->query()){
            JError::raiseError(500, $db->stderr(true));
            return;
        }
        $courseRows = $db->loadObject();
        // show sessions
        $db = &JFactory::getDBO();
        $sql = 'SELECT min(session_date) AS start_date, max(session_date) AS finish_date FROM #__courseman_sessions'
         . ' WHERE published = 1'
         . ' AND courseid = ' . $post['course_id']
         . ' ORDER BY ordering';
        $db->setQuery($sql);
        $course_sessions_dates = $db->loadObjectList();

        foreach ($course_sessions_dates as $course_sessions):
        $post['start_date'] = $course_sessions->start_date;
        $post['finish_date'] = $course_sessions->finish_date;
        endforeach;

        $post['price_per_attendee'] = $courseRows->price;
        $post['price_total'] = $post['price_per_attendee'] * $post['attendees'];
        // check the capacity
        if ($params->get('current_capacity') > 0){
            $current_bookings = &$model->getCurrentBookings();
            // available capacity = full capacity - published bookings with specific status
            $currentBookings = ($courseRows->capacity) - (int)($current_bookings);

            if ($currentBookings >= $post['attendees']){
                // ok
            }else{
                // no more bookings can be made for the course selected
                $mainframe->redirect(JRoute::_("index.php"), JText::_('The course is full'));
            }
        }

        // save data to application table
        if ($applicationid = $model->store($post)){
            $post['applicationid'] = $applicationid;
            // register user
        	$usersConfig = &JComponentHelper::getParams('com_users');
        	if ($usersConfig->get('allowUserRegistration') == '0')
        	{
        		//no registration is allowed
        	} elseif ($post['user_id'] == 0){

        		$usern = clone (JFactory::getUser());
        		jimport('joomla.user.helper');
        		$usern->set('activation', JUtility::getHash(JUserHelper::genRandomPassword()));
                $userandpass = $model->registerUser($post['user_id'], $post['email'], $post['last_name'], $applicationid, $usern->activation);
            }

            if ($userandpass){
                $temppass = $userandpass[0];
                $username = $userandpass[1];
                $post['user_id'] = $userandpass[2];
            	$usern->set('name', $username);
            	$usern->set('email', $post['email']);
            	$usern->set('username', $username);

            	$model->sendRegistrationEmail($usern, $temppass);
            }
            // save custom fields
            $model->saveCustomfields($applicationid, $post['user_id'], $values);

            if ($model->sendemail('booking-confirmation-user', $post, $courseRows->email_template)){
                $msg = (JText::_('THANK YOU FOR YOUR APPLICATION'));

                if (($params->get('enable_paypal') || $params->get('enable_creditcard')) && (($courseRows->price) > 0)){
                    $this->setRedirect(JRoute::_('index.php?option=com_courseman&view=paypal&bookingid=' .
                            $applicationid, false), $msg);
                }else{
                    $this->setRedirect(JRoute::_('index.php?option=com_courseman', false), $msg);
                }
            }else{
                $msg = JText::_('Error Sending Emails.');
                $this->setRedirect(JRoute::_('index.php', false), $msg);
            }
        }else{
            $msg = JText::_('Error Processing Your Application');
            $this->setRedirect(JRoute::_('index.php', false), $msg);
        }
    }
}

?>