<?php
/**
 *
 * @Copyright Copyright (C) 2010 www.profinvent.com. All rights reserved.
 * @website http://www.profinvent.com
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.controller');

/**
* courseman course Controller
*
* @package Course Manager
* @subpackage courseman
* @since 1.5.0
*/
class coursemanControllerPaypal extends coursemanController{
    function success() // Order was successful...
    {
        global $mainframe;
        // Setup class
        require_once(JPATH_COMPONENT_ADMINISTRATOR . DS . 'classes' . DS . 'paypal.class.php'); // include the class file
        $p = new paypal_class; // initiate an instance of the class
        // $p->paypal_url = 'https://www.sandbox.paypal.com/cgi-bin/webscr';   // testing paypal url
        $p->paypal_url = 'https://www.paypal.com/cgi-bin/webscr'; // paypal url

        // setup a variable for this script (ie: 'http://www.micahcarrick.com/paypal.php')
        $this_script = 'http://' . $_SERVER['HTTP_HOST'] . $_SERVER['PHP_SELF'];

        $model = &$this->getModel('paypal');
        // if($model->updatestatus()){
        if (isset($_POST)){
            $msg = (JText::_('Thank you for your payment.'));
            $this->setRedirect(JRoute::_('index.php', false), $msg);
            // echo "<html><head><title>Success</title></head><body><h3>Thank you for your order.</h3>";
            // foreach ($_POST as $key => $value) { echo "$key: $value<br>"; }
            // echo "</body></html>";
        }else{
            $msg = (JText::_('Payment has not been completed.'));
            $this->setRedirect(JRoute::_('index.php', false), $msg);
        }
    }

    function cancel() // Order was canceled...
    {
        // The order was canceled before being completed.
        $msg = (JText::_('The payment was canceled.'));
        $this->setRedirect(JRoute::_('index.php', false), $msg);
    }

    function ipn() // Paypal is calling page for IPN validation...
    {
        require_once(JPATH_COMPONENT_ADMINISTRATOR . DS . 'classes' . DS . 'paypal.class.php'); // include the class file
        $p = new paypal_class; // initiate an instance of the class
        //$p->paypal_url = 'https://www.sandbox.paypal.com/cgi-bin/webscr'; // testing paypal url
        $p->paypal_url = 'https://www.paypal.com/cgi-bin/webscr';     // paypal url
        $this_script = 'http://' . $_SERVER['HTTP_HOST'] . $_SERVER['PHP_SELF'];

        if ($p->validate_ipn()){
            global $mainframe;
            $params = &$mainframe->getParams();
            $config = &JFactory::getConfig();

            $model = &$this->getModel('paypal');
            if ($model->updatestatusIPN($p->ipn_data['item_number'], $p->ipn_data['txn_id'])){
                $mailSender = &JFactory::getMailer();
                // $mailSender ->addRecipient( $user->get('email'));
                $mailSender->addRecipient($config->getValue('mailfrom'));
                $mailSender->addBCC($params->get('component_email'));
                $mailSender->setSender(array($config->getValue('mailfrom') , $config->getValue('mailfrom')));
                $mailSender->setSubject(JText::_('SEND_MSG_IPN_ADMIN_SUBJECT') . ' - ' . $p->ipn_data['transaction_subject'] . ' - ' . $p->ipn_data['last_name']);
                $email_body = sprintf (JText::_('SEND_MSG_IPN_ADMIN'));

                foreach ($p->ipn_data as $key => $value){
                    $body .= "\n$key: $value";
                }
                $email_body = $email_body . $body;
                $email_body = html_entity_decode($email_body, ENT_QUOTES);
                $mailSender->setBody($email_body);
                jimport('joomla.utilities.mail');
                if (!$mailSender->Send()){
                    $this->setError(JText::_('EMAIL_NOT_SENT'));
                }
            }
        }
    }

    function save_credit_card() // save credit card
    {
        // Check for request forgeries
        JRequest::checkToken() or jexit('Invalid Token');
        // Get some objects from the JApplication
        global $mainframe;
        $db = &JFactory::getDBO();
        $user = &JFactory::getUser();
        $params = &$mainframe->getParams();
        $config = &JFactory::getConfig();
        // get data from the request
        $post = JRequest::getVar('jform', array(), 'post', 'array');
        $CardNumber = JRequest::getVar('CardNumber');
        $CardOwner = JRequest::getVar('CardOwner');
        $CardType = JRequest::getVar('CardType');
        $ExpMon = JRequest::getVar('ExpMon');
        $ExpYear = JRequest::getVar('ExpYear');
        $Card_csc = JRequest::getVar('Card_csc');
        $post['userid'] = $user->get('id');
        $model = $this->getModel('paypal');
        if ($model->checkCreditCard($CardNumber, $CardType, &$errornumber, &$errortext)){
            if ($model->updateCreditCardDeatails($CardNumber, $CardType, $CardOwner, $ExpMon, $ExpYear, $Card_csc, $post['bookingid'])){
                $msg = (JText::_('THANK YOU FOR SUBMITTING YOUR CREDIT CARD DETAILS.'));
                // list of courses
                $query = 'SELECT bookingtable.*, coursetable.title, coursetable.start_date, coursetable.finish_date' .
                ' FROM #__profinvent_bookings as bookingtable' .
                ' LEFT JOIN #__profinvent_courses AS coursetable ON coursetable.id = bookingtable.courseid' .
                ' WHERE bookingtable.id =' . (int)$post['bookingid'];
                $db->setQuery($query);
                if (!$db->query()){
                    JError::raiseError(500, $db->stderr(true));
                    return;
                }
                $bookingRows = $db->loadObject();

                $sender = $config->getValue('mailfrom');
                $fromname = $config->getValue('fromname');
                $sitename = $config->getValue('sitename');
                $mailSender = &JFactory::getMailer();

                if ($params->get('component_email')){
                    $email_recipient = $params->get('component_email');
                    $regex1 = '/^[_a-z0-9-][^\(\)\<\>\@\,\;\:\\"\[\] ]*\@([a-z0-9\-]+\.)+[a-z]{2,4}$/i';
                    if (preg_match(' ' . $regex1 . ' ', $email_recipient)){
                        $recipient = $params->get('component_email');
                    }else{
                        $recipient = $config->getValue('mailfrom');
                    }
                }else{
                    $recipient = $config->getValue('mailfrom');
                }
                $mailSender->addRecipient($recipient);
                $mailSender->setSender(array($sender , $fromname));
                $mailSender->setSubject(sprintf (JText::_('Creditcard_details_submitted_subject'), $bookingRows->firstname . ' ' . $bookingRows->surname));
                $email_body = sprintf (JText::_('Creditcard_details_submitted_MSG0'), $bookingRows->firstname . ' ' . $bookingRows->surname, $bookingRows->id , $bookingRows->title, $bookingRows->courseid, $bookingRows->email, $bookingRows->phone1);
                $mailSender->setBody($email_body);
                jimport('joomla.utilities.mail');
                if (!$mailSender->Send()){
                    $this->setError(JText::_('EMAIL_NOT_SENT'));
                }
            }else{
                $msg = (JText::_('IT IS NOT POSSIBLE TO ATTACH THE CREDIT CARD DETAILS TO YOUR BOOKING.'));
            }
            $this->setRedirect(JRoute::_('index.php', false), $msg);
            return;
        }
        $msg = (JText::_('THE CREDIT CARD NUMBER SEEMS TO BE INVALID.'));
        $this->setRedirect(JRoute::_('index.php', false), $msg);
    }
}

?>