<?php
/**
*
* @Copyright Copyright (C) 2010 www.profinvent.com. All rights reserved.
* @website http://www.profinvent.com
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 2 of the License, or
* any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class coursemanModelapplication extends JModel{
    var $_id = null;

    var $_data = null;

    function __construct()
    {
        parent::__construct();

        $id = JRequest::getVar('id', 0, '', 'int');
        $this->_course_id = JRequest::getVar('course_id', 0, '', 'int');
        $this->setId((int)$id);
    }

    function setId($id)
    {
        $this->_id = $id;
        $this->_data = null;
    }

    function &getData()
    {
        if ($this->_loadData()){
            $user = &JFactory::getUser();

            if (!$this->_data->published){
                JError::raiseError(404, JText::_("Resource Not Found"));
                return false;
            }

            if (!$this->_data->cat_pub){
                JError::raiseError(404, JText::_("Resource Not Found"));
                return;
            }

            if ($this->_data->cat_access > $user->get('aid', 0)){
                JError::raiseError(403, JText::_('ALERTNOTAUTH'));
                return;
            }
        }else
            $this->_initData();

        return $this->_data;
    }

    function hit()
    {
        global $mainframe;

        if ($this->_id){
            $booking = &$this->getTable();
            $booking->hit($this->_id);
            return true;
        }
        return false;
    }

    function isCheckedOut($uid = 0)
    {
        if ($this->_loadData()){
            if ($uid){
                return ($this->_data->checked_out && $this->_data->checked_out != $uid);
            }else{
                return $this->_data->checked_out;
            }
        }
    }

    function checkin()
    {
        if ($this->_id){
            $booking = &$this->getTable();
            if (!$booking->checkin($this->_id)){
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
            return true;
        }
        return false;
    }

    function checkout($uid = null)
    {
        if ($this->_id){
            if (is_null($uid)){
                $user = &JFactory::getUser();
                $uid = $user->get('id');
            }

            $booking = &$this->getTable();
            if (!$booking->checkout($uid, $this->_id)){
                $this->setError($this->_db->getErrorMsg());
                return false;
            }

            return true;
        }
        return false;
    }

    function store($data)
    {
        JTable::addIncludePath(JPATH_ADMINISTRATOR . DS . 'components' . DS .
            'com_courseman' . DS . 'tables');

        $row = &JTable::getInstance('application', 'Table');

        if (!$row->bind($data)){
            $this->setError($this->_db->getErrorMsg());
            return false;
        }

        $row->date = gmdate('Y-m-d H:i:s');

        if (!$row->id){
            $where = 'course_id = ' . (int)$row->course_id;
            $row->ordering = $row->getNextOrder($where);
        }

        if (!$row->check()){
            $this->setError($this->_db->getErrorMsg());
            return false;
        }

        if (!$row->store()){
            $this->setError($this->_db->getErrorMsg());
            return false;
        }
        return ($row->id);
    }

    function uploadfile()
    {
        global $mainframe;
        $params = &JComponentHelper::getParams('com_courseman');

        $file = JRequest::getVar('cv', null, 'files', 'array');

        if ($file['size'] > 0){
            jimport('joomla.filesystem.file');

            $path = COM_courseman_CVFILEPATH . DS;

            $filename = courseman_upload::sanitize($path, $file['name']);

            $filepath = JPath::clean($path . strtolower($filename));

            $src = $file['tmp_name'];

            $dest = $filepath;

            if (!courseman_upload::check($file, $err)){
                if ($format == 'json'){
                    jimport('joomla.error.log');
                    $log = &JLog::getInstance('com_courseman.error.php');
                    $log->addEntry(array('comment' => 'Invalid: ' . $filepath . ': ' . $err));
                    header('HTTP/1.0 415 Unsupported Media Type');
                    die('Error. Unsupported Media Type!');
                }else{
                    JError::raiseNotice(100, JText::_($err));

                    if ($return){
                        $mainframe->redirect(base64_decode($return));
                    }
                    return;
                }
            }

            if (JFile::upload($src, $dest)){
                return $filename;
            }else{
                $msg .= "File upload failed.";
                return false;
            }
        }
    }

    function copyfile($file)
    {
        global $mainframe;

        jimport('joomla.filesystem.file');
        $filename = JFile::makeSafe($file);

        $path = COM_courseman_CVFILEPATH . DS;

        $filename_new = $this->updateFilename($filename);
        $filename_new = courseman_upload::sanitize($path, $filename_new);

        $src = COM_courseman_UPLOADEDCVFILEPATH . DS . $filename;
        $dst = COM_courseman_CVFILEPATH . DS . $filename_new;
        if (JFile::copy($src, $dst)){
            return $filename_new;
        }
        return false;
    }
    function updateFilename($filename)
    {
        global $mainframe;

        jimport('joomla.filesystem.file');

        $filename = preg_replace("/^[.]*/", '', $filename);
        $filename = preg_replace("/[.]*$/", '', $filename);

        $lastdotpos = strrpos($filename, '.');

        $chars = '[^0-9a-zA-Z()_-]';
        $filename = strtolower(preg_replace("/$chars/", '_', $filename));

        $beforedot = substr($filename, 0, $lastdotpos);
        $afterdot = substr($filename, $lastdotpos + 1);

        $filename_new = substr($beforedot, 0, (strlen($beforedot) - 11)) . '.' . $afterdot;
        return $filename_new;
    }

    function sendemail($templatefor, $emaildata, $emailTemplate = 0)
    {
        global $mainframe;
        $db = &JFactory::getDBO();

        if($emailTemplate != 0) {
            $emailCond = " AND id=".$emailTemplate;
        }

        $query = "SELECT * FROM " . $db->nameQuote('#__courseman_emailtemplate') .
        " WHERE (templatefor = " . $db->Quote($templatefor).$emailCond.")";
        $db->setQuery($query);
        $template = $db->loadObject();
        if ($template){
            $msgSubject = $template->subject;
            $msgBody = $template->body;
            $msgRecipient = $template->recipient;

            switch ($templatefor){
                case 'booking-confirmation-user':
                    if (!$this->sendEmailToUserApplication($emaildata, $msgSubject, $msgBody, $msgRecipient)){
                        return false;
                    }
                    break;

                case 'other':
                default:
                    $this->sendEmailToUserApplication($emaildata, $msgSubject, $msgBody, $msgRecipient);
                    break;
            }
            return true;
        }
        return false;
    }

    function sendEmailToUserApplication($emaildata, $msgSubject, $msgBody, $msgRecipient)
    {
        global $mainframe;
        $db = &JFactory::getDBO();
        $message = &JFactory::getMailer();
        $config = &JFactory::getConfig();
        $params = &JComponentHelper::getParams('com_courseman');

        $query = 'SELECT app.*, c.reference_number, c.title AS course, c.introtext, c.fulltext, c. capacity, c.location, c.url, app.price_per_attendee, app.price_total, tut.title AS tutor, tut.salutation AS tutor_salutation, tut.firstname AS tutor_first_name, tut.lastname AS tutor_last_name, gr.title AS atgroup, gr.description AS atgroup_desc, ex.title AS experience_level, ex.description AS experience_level_desc' .
        ' FROM #__courseman_application AS app' .
        ' LEFT JOIN #__courseman_courses AS c ON c.id = app.course_id' .
        ' LEFT JOIN #__courseman_tutor AS tut ON tut.id = c.tutor_id' .
        ' LEFT JOIN #__courseman_atgroup AS gr ON gr.id = c.id_group' .
        ' LEFT JOIN #__courseman_experience_level AS ex ON ex.id = c.id_experience_level' .
        ' WHERE app.id = ' . $emaildata['applicationid'];

        $db->setQuery($query);
        $queryResult = $db->loadObject();
        if ($queryResult){
            $userQuery = "SELECT name, email FROM " . $db->nameQuote('#__users') . "
			WHERE id = " . $emaildata['user_id'];

            $db->setQuery($userQuery);
            $user = $db->loadObject();

            $tutorQuery = "SELECT name, email FROM " . $db->nameQuote('#__users') . "
			WHERE id = " . $queryResult->user_id;

            $db->setQuery($tutorQuery);
            $tutor = $db->loadObject();

            $query = 'SELECT field.*, value.value '
             . 'FROM ' . $db->nameQuote('#__courseman_fields') . ' AS field '
             . 'LEFT JOIN ' . $db->nameQuote('#__courseman_fields_values') . ' AS value '
             . 'ON field.id=value.field_id AND value.applicationid=' . $emaildata['applicationid'] . ' '
             . 'WHERE field.published=' . $db->Quote('1') . ' '
             . 'ORDER BY field.ordering';
            $this->_db->setQuery($query);
            $fields = $db->loadAssocList();

            for($i = 0; $i < count($fields); $i++){
                $msgSubject = str_replace('{' . strtoupper($fields[$i]['fieldcode']) . '}', $fields[$i]['value'], $msgSubject);
                $msgBody = str_replace('{' . strtoupper($fields[$i]['fieldcode']) . '}', $fields[$i]['value'], $msgBody);
            }

            $ApplicantName = $user->name;
            $ApplicantFirst_name = $emaildata['first_name'];
            $ApplicantLast_name = $emaildata['last_name'];
            $ApplicantSalutation = $emaildata['salutation'];
            $ApplicantCover_note = $emaildata['cover_note'];
            $ApplicantPhone = $emaildata['phone'];
            $ApplicantEmail = $emaildata['email'];
            $CourseReference = $queryResult->reference_number;
            $siteAddress = JURI::base();

            $msgSubject = str_replace('{ADMIN_CUSTOM_RECIPIENT}', $params->get('component_email'), $msgSubject);
            $msgSubject = str_replace('{ATTENDEES}', $queryResult->attendees, $msgSubject);
            $msgSubject = str_replace('{SALUTATION}', $queryResult->salutation, $msgSubject);
            $msgSubject = str_replace('{FIRSTNAME}', $queryResult->first_name, $msgSubject);
            $msgSubject = str_replace('{LASTNAME}', $queryResult->last_name, $msgSubject);
            $msgSubject = str_replace('{EMAIL_ATTENDEE}', $queryResult->email, $msgSubject);
            $msgSubject = str_replace('{ATTENDEES}', $queryResult->attendees, $msgSubject);
            $msgSubject = str_replace('{COURSE}', $queryResult->course, $msgSubject);
            $msgSubject = str_replace('{COURSE_INTROTEXT}', $queryResult->introtext, $msgSubject);
            $msgSubject = str_replace('{COURSE_FULLTEXT}', $queryResult->fulltext, $msgSubject);
            $msgSubject = str_replace('{COURSE_CAPACITY}', $queryResult->capacity, $msgSubject);
            $msgSubject = str_replace('{COURSE_LOCATION}', $queryResult->location, $msgSubject);
            $msgSubject = str_replace('{COURSE_URL}', $queryResult->url, $msgSubject);
            $msgSubject = str_replace('{COURSE_PRICE_PER_ATTENDEE}', $queryResult->price_per_attendee, $msgSubject);
            $msgSubject = str_replace('{COURSE_PRICE_TOTAL}', $queryResult->price_total, $msgSubject);
            $msgSubject = str_replace('{COURSE_START_DATE}', date('d-m-Y', strtotime($emaildata['start_date'])), $msgSubject);
            $msgSubject = str_replace('{COURSE_FINISH_DATE}', date('d-m-Y', strtotime($emaildata['finish_date'])), $msgSubject);
            $msgSubject = str_replace('{TUTOR}', $queryResult->tutor, $msgSubject);
            $msgSubject = str_replace('{TUTOR_FIRST_NAME}', $queryResult->tutor_first_name, $msgSubject);
            $msgSubject = str_replace('{TUTOR_LAST_NAME}', $queryResult->tutor_last_name, $msgSubject);
            $msgSubject = str_replace('{GROUP}', $queryResult->atgroup, $msgSubject);
            $msgSubject = str_replace('{GROUP_DESC}', $queryResult->atgroup_desc, $msgSubject);
            $msgSubject = str_replace('{EXPERIENCE_LEVEL}', $queryResult->experience_level, $msgSubject);
            $msgSubject = str_replace('{EXPERIENCE_LEVEL_DESC}', $queryResult->experience_level_desc, $msgSubject);

            $msgBody = str_replace('{ADMIN_CUSTOM_RECIPIENT}', $params->get('component_email'), $msgBody);
            $msgBody = str_replace('{ATTENDEES}', $queryResult->attendees, $msgBody);
            $msgBody = str_replace('{SALUTATION}', $queryResult->salutation, $msgBody);
            $msgBody = str_replace('{FIRSTNAME}', $queryResult->first_name, $msgBody);
            $msgBody = str_replace('{LASTNAME}', $queryResult->last_name, $msgBody);
            $msgBody = str_replace('{EMAIL_ATTENDEE}', $queryResult->email, $msgBody);
            $msgBody = str_replace('{COURSE}', $queryResult->course, $msgBody);
            $msgBody = str_replace('{COURSE_INTROTEXT}', $queryResult->introtext, $msgBody);
            $msgBody = str_replace('{COURSE_FULLTEXT}', $queryResult->fulltext, $msgBody);
            $msgBody = str_replace('{COURSE_CAPACITY}', $queryResult->capacity, $msgBody);
            $msgBody = str_replace('{COURSE_LOCATION}', $queryResult->location, $msgBody);
            $msgBody = str_replace('{COURSE_URL}', $queryResult->url, $msgBody);
            $msgBody = str_replace('{COURSE_PRICE_PER_ATTENDEE}', $queryResult->price_per_attendee, $msgBody);
            $msgBody = str_replace('{COURSE_PRICE_TOTAL}', $queryResult->price_total, $msgBody);
            $msgBody = str_replace('{COURSE_START_DATE}', date('d-m-Y', strtotime($emaildata['start_date'])), $msgBody);
            $msgBody = str_replace('{COURSE_FINISH_DATE}', date('d-m-Y', strtotime($emaildata['finish_date'])), $msgBody);
            $msgBody = str_replace('{TUTOR}', $queryResult->tutor, $msgBody);
            $msgBody = str_replace('{TUTOR_FIRST_NAME}', $queryResult->tutor_first_name, $msgBody);
            $msgBody = str_replace('{TUTOR_LAST_NAME}', $queryResult->tutor_last_name, $msgBody);
            $msgBody = str_replace('{GROUP}', $queryResult->atgroup, $msgBody);
            $msgBody = str_replace('{GROUP_DESC}', $queryResult->atgroup_desc, $msgBody);
            $msgBody = str_replace('{EXPERIENCE_LEVEL}', $queryResult->experience_level, $msgBody);
            $msgBody = str_replace('{EXPERIENCE_LEVEL_DESC}', $queryResult->experience_level_desc, $msgBody);

            $msgRecipient = str_replace('{EMAIL_ATTENDEE}', $queryResult->email, $msgRecipient);
            $msgRecipient = str_replace('{ADMIN_CUSTOM_RECIPIENT}', $params->get('component_email'), $msgRecipient);

            $senderEmail = $config->getValue('mailfrom');
            $senderName = $config->getValue('fromname');
            $message->addRecipient($msgRecipient);

            $message->setSubject($msgSubject);
            $message->setBody($msgBody);
            $sender = array($senderEmail, $senderName);
            $message->setSender($sender);
            $message->IsHTML(true);

            $cv_file_path = $params->get('cv_file_path');
            $cv = JPATH_SITE . DS . $cv_file_path . DS . $emaildata['cv'];
            $message->addAttachment($cv);

            $sent = $message->send();
            return $sent;
        }
    }

    function saveCustomfields($applicationId, $userId, $fields)
    {
        jimport('joomla.utilities.date');
        $db = &$this->getDBO();

        foreach($fields as $id => $value){
            // Check if field value exists before inserting or updating
            $strSQL = "SELECT COUNT(*) FROM #__courseman_fields_values"
             . " WHERE field_id='$id' AND user_id=" . $db->Quote($userId) . "AND applicationid=" . $db->Quote($applicationId);
            $db->setQuery($strSQL);

            $isNew = ($db->loadResult() <= 0) ? true : false;

            $strSQL = "INSERT INTO " . $db->nameQuote('#__courseman_fields_values')
             . ' SET ' . $db->nameQuote('applicationid') . '=' . $db->Quote($applicationId) . ', '
             . $db->nameQuote('user_id') . '=' . $db->Quote($userId) . ', '
             . $db->nameQuote('field_id') . '=' . $db->Quote($id) . ', ' . $db->nameQuote('value')
             . '=' . $db->Quote($value);

            if (!$isNew){
                $strSQL = 'UPDATE ' . $db->nameQuote('#__courseman_fields_values') . ' SET '
                 . $db->nameQuote('value') . '=' . $db->Quote($value)
                 . ' WHERE ' . $db->nameQuote('applicationid') . '=' . $db->Quote($applicationId)
                 . ' AND ' . $db->nameQuote('user_id') . '=' . $db->Quote($userId)
                 . ' AND ' . $db->nameQuote('field_id') . '=' . $db->Quote($id);
            }
            // echo $strSQL;
            $db->setQuery($strSQL);
            $db->query();
        }
    }

    function getAdminEmails()
    {
        $emails = '';
        $db = &$this->getDBO();

        $query = 'SELECT ' . $db->nameQuote('email')
         . ' FROM ' . $db->nameQuote('#__users')
         . ' WHERE ' . $db->nameQuote('gid') . '=' . $db->quote(24)
         . ' OR ' . $db->nameQuote('gid') . '=' . $db->Quote(25);

        $db->setQuery($query);
        $emails = $db->loadResultArray();

        return $emails;
    }

    function getCurrentBookings()
    {
        global $mainframe;
        $params = &$mainframe->getParams();
        if ($params->get('current_capacity') == 1){
            $statusTopLimit = 3;
            $statusBottomLimit = - 1;
        }
        if ($params->get('current_capacity') == 2){
            $statusTopLimit = 3;
            $statusBottomLimit = 0;
        }

        $db = &JFactory::getDBO();
        $sql = 'SELECT SUM(b.attendees)'
         . ' FROM #__courseman_application AS b'
         . ' WHERE b.published = 1'
         . ' AND b.course_id = ' . $this->_course_id
         . ' AND b.status <' . $statusTopLimit = 3
         . ' AND b.status >' . $statusBottomLimit;
        $db->setQuery($sql);
        $current_bookings = $db->loadResult();
        return $current_bookings;
    }

    function rst_random_pass($length = 6)
    {
        $chars = "abcdefghijkmnopqrstuvwxyz0123456789";
        $i = 1;
        $pass = '';
        while ($i <= $length){
            $num = mt_rand(0, 34);
            $tmp = substr($chars, $num, 1);
            $pass = $pass . $tmp;
            $i++;
        }
        return $pass;
    }

    /**
    * Method to register new user if now exists
    *
    * @access public
    * @return string
    */
    function registerUser($userid, $email, $fullname, $newbookingid, $activationstring)
    {
        $db = &JFactory::getDBO();
        // find a user with the same email address
        $query = 'SELECT id FROM #__users WHERE email =' . $db->Quote($email);
        $db->setQuery($query);
        if (!$db->query()){
            JError::raiseError(500, $db->stderr(true));
            return;
        }
        $existinguser = $db->loadResult();
        if ($existinguser > 0){
            // user already registered - overwrite user id
            $userid = $existinguser;
        }else{
            // GENERATE A NEW USER - CHECK IF USERNAME EXISTS
            list($username, $domain) = split("@", $email);
            $db->setQuery("SELECT `id` as `UserId` FROM `#__users` WHERE `username` LIKE '" . $username . "' LIMIT 1");
            $resultuser = $db->loadResult();
            $db->query();
            if ($resultuser > 0)
                while ($db->getNumRows() > 0){
                $username = $username . mt_rand(0, 9);
                $db->setQuery("SELECT `id` as `UserId` FROM `#__users` WHERE `username`='" . $username . "' LIMIT 1");
                $db->query();
            }
            // CREATE A NEW USER & SEND WELCOME EMAIL
            $temppass = $this->rst_random_pass();

        	$usersConfig = &JComponentHelper::getParams('com_users');
        	$useractivation = $usersConfig->get('useractivation');
        	if ($useractivation == '1'){
        	$block = 1;
        	} else {
        	$block = 0;
        	}

            $db->setQuery("INSERT INTO `#__users` (`name`, `username`, `email`, `password`, `usertype`, `block`, `sendEmail`, `gid`, `registerDate`, `lastvisitDate`, `activation`, `params`) VALUES('" . $fullname . "', '" . $username . "', '" . $email . "', '" . md5($temppass) . "', 'Registered', '" .$block ."', 0, 18, now(), '', '" .$activationstring ."', '');");
            $db->query();
            $userid = $db->insertid();

            $db->setQuery("INSERT INTO `#__core_acl_aro` (`id`, `section_value`, `value`, `order_value`, `name`, `hidden`) VALUES('', 'users', '" . $userid . "', 0, '" . $fullname . "', 0);");
            $db->query();
            $aro_id = $db->insertid();

            $db->setQuery("INSERT INTO `#__core_acl_groups_aro_map` (`group_id`,`section_value`,`aro_id`) VALUES ('18','','" . $aro_id . "')");
            $db->query();
            // rst_send_email($email,RST_NEW_USER_SUBJECT,array('username' => $username,'password' => $temppass),'new_user',$fullname);
            $result = array($temppass, $username, $userid);
            return $result;
        }
    	if ($newbookingid){
    		$db->setQuery('UPDATE #__courseman_application'
    		     . ' SET user_id = ' . $userid
    		     . ' WHERE id = ' . (int) $newbookingid);

    		if (!$db->query()){
    			$this->setError(JText::_('DATABASE_ERROR'));
    			return false;
    		}
    	}
    }

	function sendRegistrationEmail(&$usern, $password)
	{
		global $mainframe;

		$lang = &JFactory::getLanguage();
		$lang->load('com_user', JPATH_SITE);

		$db = &JFactory::getDBO();

		$name = $usern->get('name');
		$email = $usern->get('email');
		$username = $usern->get('username');

		$usersConfig = &JComponentHelper::getParams('com_users');
		$sitename = $mainframe->getCfg('sitename');
		$useractivation = $usersConfig->get('useractivation');
		$mailfrom = $mainframe->getCfg('mailfrom');
		$fromname = $mainframe->getCfg('fromname');
		$siteURL = JURI::base();

		$subject = sprintf(JText::_('ACCOUNT DETAILS FOR'), $name, $sitename);
		$subject = html_entity_decode($subject, ENT_QUOTES);

		if ($useractivation == 1)
		{
			$message = sprintf(JText::_('SEND_MSG_ACTIVATE'), $name, $sitename, $siteURL .
			    "index.php?option=com_user&task=activate&activation=" . $usern->get('activation'),
			    $siteURL, $username, $password);
		} else
		{
			$message = sprintf(JText::_('SEND_MSG'), $name, $sitename, $siteURL);
		}

		$message = html_entity_decode($message, ENT_QUOTES);

		$query = 'SELECT name, email, sendEmail' . ' FROM #__users' .
		    ' WHERE LOWER( usertype ) = "super administrator"';
		$db->setQuery($query);
		$rows = $db->loadObjectList();

		if (!$mailfrom || !$fromname)
		{
			$fromname = $rows[0]->name;
			$mailfrom = $rows[0]->email;
		}

		JUtility::sendMail($mailfrom, $fromname, $email, $subject, $message);

		$subject2 = sprintf(JText::_('ACCOUNT DETAILS FOR'), $name, $sitename);
		$subject2 = html_entity_decode($subject2, ENT_QUOTES);

		$lang = &JFactory::getLanguage();
		$lang->load('com_user', JPATH_SITE);

		foreach ($rows as $row)
		{
			if ($row->sendEmail)
			{
				$message2 = sprintf(JText::_('SEND_MSG_ADMIN'), $row->name, $sitename, $name, $email,
				    $username);
				$message2 = html_entity_decode($message2, ENT_QUOTES);
				JUtility::sendMail($mailfrom, $fromname, $row->email, $subject2, $message2);
			}
		}
	}
}