<?php

/**
* @Copyright Copyright (C) 2010 www.profinvent.com. All rights reserved.
* @website http://www.profinvent.com
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 2 of the License, or
* any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
**/
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class CoursemanModelCategory extends JModel
{
    var $_id = null;

    var $_data = null;

    var $_childs = null;

    var $_category = null;

    var $_total = null;

    function __construct()
    {
        parent::__construct();

        global $mainframe;

        $params = &$mainframe->getParams('com_courseman');

        $cid = JRequest::getInt('cid', 0);

        $limit = $mainframe->getUserStateFromRequest('com_courseman.category.limit',
            'limit', $params->def('limit', 0), 'int');

        $limitstart = JRequest::getInt('limitstart');

        $this->setId((int)$cid);

        $this->setState('limit', $limit);
        $this->setState('limitstart', $limitstart);

        $this->setState('filter_order', JRequest::getCmd('filter_order', 'i.title'));
        $this->setState('filter_order_dir', JRequest::getCmd('filter_order_Dir', 'ASC'));
    }

    function setId($cid)
    {

        $this->_id = $cid;

    }

    function getData()
    {

        if (empty($this->_data))
        {
            $query = $this->_buildQuery($this->_id);
            $this->_data = $this->_getList($query, $this->getState('limitstart'), $this->
                getState('limit'));
        }

        return $this->_data;
    }

    function getTotal()
    {

        if (empty($this->_total))
        {
            $query = $this->_buildQuery();
            $this->_total = $this->_getListCount($query);
        }

        return $this->_total;
    }

    function _buildQuery()
    {

        $where = $this->_buildCourseWhere();
        $orderby = $this->_buildCourseOrderBy();

        $query = 'SELECT DISTINCT i.*, (i.plus / (i.plus + i.minus) ) * 100 AS votes, emp.comp_name AS tutor,' .
            ' CASE WHEN CHAR_LENGTH(i.alias) THEN CONCAT_WS(\':\', i.id, i.alias) ELSE i.id END as slug,' .
            ' gr.title AS cgroup, lev.title AS level' .
            ' FROM #__courseman_courses AS i' .
            ' LEFT JOIN #__courseman_cats_course_relations AS rel ON rel.courseid = i.id' .
            ' LEFT JOIN #__courseman_tutor AS emp ON emp.id = i.tutor_id' .
            ' LEFT JOIN #__courseman_atgroup AS gr ON gr.id = i.id_group' .
            ' LEFT JOIN #__courseman_experience_level AS lev ON lev.id = i.id_experience_level' .
            ' LEFT JOIN #__courseman_sessions AS ses ON ses.courseid = i.id' .
            ' LEFT JOIN #__courseman_categories AS c ON c.id = ' . $this->_id . $where . $orderby;




        return $query;
    }

    function _buildCourseOrderBy()
    {
        $filter_order = $this->getState('filter_order');
        $filter_order_dir = $this->getState('filter_order_dir');

        $orderby = ' ORDER BY ' . $filter_order . ' ' . $filter_order_dir . ', i.title';

        return $orderby;
    }

    function _buildCourseWhere()
    {
        global $mainframe, $option;

        $user = &JFactory::getUser();
        $gid = (int)$user->get('aid');

        $jnow = &JFactory::getDate();
        $now = $jnow->toMySQL();
        $nullDate = $this->_db->getNullDate();

        $state = 1;

        $params = &$mainframe->getParams('com_courseman');

        $where = ' WHERE rel.catid = ' . $this->_id;

        $where .= ' AND c.access <= ' . $gid;

        switch ($state)
        {
            case 1:

                $where .= ' AND i.state = 1' . ' AND ( publish_up = ' . $this->_db->Quote($nullDate) .
                    ' OR publish_up <= ' . $this->_db->Quote($now) . ' )' . ' AND ( publish_down = ' .
                    $this->_db->Quote($nullDate) . ' OR publish_down >= ' . $this->_db->Quote($now) .
                    ' )';

                break;

            case - 1:

                $year = JRequest::getInt('year', date('Y'));
                $month = JRequest::getInt('month', date('m'));

                $where .= ' AND i.state = -1';
                $where .= ' AND YEAR( i.created ) = ' . (int)$year;
                $where .= ' AND MONTH( i.created ) = ' . (int)$month;
                break;

            default:
                $where .= ' AND i.state = ' . (int)$state;
                break;
        }

    	//$where .= ' AND i.id in (SELECT id FROM #__courseman_sessions WHERE published = 1)';
    	$where .= ' AND ses.published = 1';


        if ($params->get('filter'))
        {

            $filter = JRequest::getString('filter', '', 'request');
            $filter_experience_level = JRequest::getString('filter_experience_level', '', 'request');
            $filter_positiontype = JRequest::getString('filter_positiontype', '', 'request');


            if ($filter)
            {

                $filter = $this->_db->getEscaped(trim(JString::strtolower($filter)));

                $where .= ' AND LOWER( i.title ) LIKE ' . $this->_db->Quote('%' . $this->_db->
                    getEscaped($filter, true) . '%', false);
            }
        }
//not in use


        if ($filter_experience_level)
        {
            $where .= ' AND LOWER( i.id_experience_level ) = ' . $filter_experience_level;
        }

        return $where;
    }

    function _buildChildsquery()
    {
        $user = &JFactory::getUser();
        $gid = (int)$user->get('aid');
        $ordering = 'ordering ASC';
        $jnow = &JFactory::getDate();
        $now = $jnow->toMySQL();
        $nullDate = $this->_db->getNullDate();

        $state = 1;

        $where = ' WHERE cc.published = 1';
        $where .= ' AND cc.parent_id = ' . $this->_id;
        $where .= ' AND cc.access <= ' . $gid;
        $where .= ' AND c.id = cc.id';

        switch ($state)
        {
            case 1:

                $where .= ' AND i.state = 1' . ' AND ( publish_up = ' . $this->_db->Quote($nullDate) .
                    ' OR publish_up <= ' . $this->_db->Quote($now) . ' )' . ' AND ( publish_down = ' .
                    $this->_db->Quote($nullDate) . ' OR publish_down >= ' . $this->_db->Quote($now) .
                    ' )';

                break;

            case - 1:

                $year = JRequest::getInt('year', date('Y'));
                $month = JRequest::getInt('month', date('m'));

                $where .= ' AND i.state = -1';
                $where .= ' AND YEAR( i.created ) = ' . (int)$year;
                $where .= ' AND MONTH( i.created ) = ' . (int)$month;
                break;

            default:
                $where .= ' AND i.state = ' . (int)$state;
                break;
        }

        $query = 'SELECT c.*,' . ' CASE WHEN CHAR_LENGTH( c.alias ) THEN CONCAT_WS( \':\', c.id, c.alias ) ELSE c.id END AS slug,' .
            ' (' . ' SELECT COUNT( DISTINCT i.id )' . ' FROM #__courseman_courses AS i' .
            ' LEFT JOIN #__courseman_cats_course_relations AS rel ON rel.courseid = i.id' .
            ' LEFT JOIN #__courseman_categories AS cc ON cc.id = rel.catid' . $where .
            ' GROUP BY cc.id' . ')' . ' AS assignedcoursemans' .
            ' FROM #__courseman_categories AS c' . ' WHERE c.published = 1' .
            ' AND c.parent_id = ' . $this->_id . ' AND c.access <= ' . $gid . ' ORDER BY ' .
            $ordering;

        return $query;
    }
    function getChilds()
    {
        $query = $this->_buildChildsquery();
        $this->_childs = $this->_getList($query, $this->getState('limitstart'), $this->
            getState('limit'));

        $k = 0;
        $count = count($this->_childs);
        for ($i = 0; $i < $count; $i++)
        {
            $category = &$this->_childs[$i];

            $category->subcats = $this->_getsubs($category->id);

            $k = 1 - $k;
        }

        return $this->_childs;
    }

    function _getsubs($id)
    {
        $user = &JFactory::getUser();
        $gid = (int)$user->get('aid');
        $ordering = 'ordering ASC';

        $query = 'SELECT *,' . ' CASE WHEN CHAR_LENGTH(alias) THEN CONCAT_WS(\':\', id, alias) ELSE id END as slug' .
            ' FROM #__courseman_categories' . ' WHERE published = 1' . ' AND parent_id = ' . (int)
            $id . ' AND access <= ' . $gid . ' ORDER BY ' . $ordering;

        $this->_db->setQuery($query);
        $this->_subs = $this->_db->loadObjectList();

        return $this->_subs;
    }

    function getCategory()
    {

        $user = &JFactory::getUser();
        $gid = (int)$user->get('aid');

        $query = 'SELECT c.*,' . ' CASE WHEN CHAR_LENGTH(c.alias) THEN CONCAT_WS(\':\', c.id, c.alias) ELSE c.id END as slug' .
            ' FROM #__courseman_categories AS c' . ' WHERE c.id = ' . $this->_id .
            ' AND c.published = 1' . ' AND c.access <= ' . $gid;

        $this->_db->setQuery($query);
        $this->_category = $this->_db->loadObject();

        if (!$this->_category->published)
        {
            JError::raiseError(404, JText::sprintf('CATEGORY #%d NOT FOUND', $this->_id));
            return false;
        }


        if ($this->_category->access > $gid)
        {
            JError::raiseError(403, JText::_("ALERTNOTAUTH"));
            return false;
        }

        return $this->_category;
    }

	function getFavourites($courseid)
	{
		$query = 'SELECT COUNT(id) AS favs FROM #__courseman_favourites WHERE courseid = ' . (int)
		    $courseid;
		$this->_db->setQuery($query);
		$favs = $this->_db->loadResult();
		return $favs;
	}

	function getFavoured($courseid)
	{
		$user = JFactory::getUser();

		$query = 'SELECT COUNT(id) AS fav FROM #__courseman_favourites WHERE courseid = ' . (int)
		    $courseid . ' AND userid= ' . (int)$user->id;
		$this->_db->setQuery($query);
		$fav = $this->_db->loadResult();
		return $fav;
	}

    function gettitles()
    {
        $user = &JFactory::getUser();
        $gid = (int)$user->get('aid');
        $ordering = 'ordering ASC';

        $query = 'SELECT id, title' . ' FROM #__courseman_experience_level' .
            ' WHERE published = 1' . ' ORDER BY ' . $ordering;

        $this->_db->setQuery($query);
        $this->_subs = $this->_db->loadObjectList();

        return $this->_subs;
    }

}

?>