<?php
/**
*
* @Copyright Copyright (C) 2010 www.profinvent.com. All rights reserved.
* @website http://www.profinvent.com
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 2 of the License, or
* any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.view');

class CoursemanViewCategory extends JView{
    function display($tpl = null)
    {
        global $mainframe, $option;

        $document = &JFactory::getDocument();
        $menus = &JSite::getMenu();
        $menu = $menus->getActive();
        $params = &$mainframe->getParams('com_courseman');
        $uri = &JFactory::getURI();
        $lang = &JFactory::getLanguage();

        $limitstart = JRequest::getInt('limitstart');

        $document->addStyleSheet($this->baseurl .
            '/components/com_courseman/assets/css/courseman.css');
        if ($lang->isRTL()){
            $document->addStyleSheet($this->baseurl .
                '/components/com_courseman/assets/css/courseman_rtl.css');
        }

        $document->addCustomTag('<!--[if IE]><style type="text/css">.floattext{zoom:1;}, * html #courseman dd { height: 1%; }</style><![endif]-->');

        $pathway = &$mainframe->getPathWay();

        $category = &$this->get('Category');
        $courses = &$this->get('Data');
        $limit = $mainframe->getUserStateFromRequest('com_courseman.' . $this->getLayout() .
            '.limit', 'limit', $params->def('limit', 0), 'int');
        $total = &$this->get('Total');

        $cats = new courseman_cats((int)$category->id);
        $parents = $cats->getParentlist();
        $categories = &$this->get('Childs');

        if (is_object($menu)){
            $menu_params = new JParameter($menu->params);

            if (!$menu_params->get('page_title')){
                $params->set('page_title', $category->title);
            }
        }else{
            $params->set('page_title', $category->title);
        }

        foreach ($parents as $parent){
            $pathway->addItem($this->escape($parent->title), JRoute::_('index.php?view=category&cid=' .
                    $parent->categoryslug));
        }

        $document->setTitle($params->get('page_title'));

        if ($category->meta_description){
            $document->setDescription($category->meta_description);
        }
        if ($category->meta_keywords){
            $document->setMetadata('keywords', $category->meta_keywords);
        }
        if ($mainframe->getCfg('MetaTitle') == '1'){
            $mainframe->addMetaTag('title', $category->title);
        }

        if ($params->get('show_feed_link', 1) == 1){
            $link = '&format=feed';
            $attribs = array('type' => 'application/rss+xml', 'title' => 'RSS 2.0');
            $document->addHeadLink(JRoute::_($link . '&type=rss'), 'alternate', 'rel', $attribs);
            $attribs = array('type' => 'application/atom+xml', 'title' => 'Atom 1.0');
            $document->addHeadLink(JRoute::_($link . '&type=atom'), 'alternate', 'rel', $attribs);
        }

        $count = count($courses);
        for($i = 0; $i < $count; $i++){
            $item = &$courses[$i];
            $item->count = $i;
            // $link = JRoute::_('index.php?view=courses&cid=' . $category->slug . '&id=' . $item->slug);
            $link = JRoute::_($item->url);
            $item->currency_price = $params->get('currency');

            $menuclass = 'category' . $params->get('pageclass_sfx');
            // $file    = JPATH_COMPONENT_ADMINISTRATOR.DS.'models'.DS.'course.xml';
            // $itemParams = new JParameter( $item->attribs, $file );
            //$params = &$mainframe->getParams('com_courseman');
            $itemParams = new JParameter($item->attribs);
            // $params->merge($itemParams);
            if (($item->url) <> 'http://'){
                switch ($params->get('target', $params->get('target'))){
                    // cases are slightly different
                    case 1:
                        // open in a new window
                        $item->link = '<a href="' . $link . '" target="_blank" class="' . $menuclass . '">' . JText::_('More details about ') . $this->escape($item->title) . '...</a>';
                        break;

                    case 2:
                        // open in a popup window
                        $item->link = "<a href=\"#\" onclick=\"javascript: window.open('" . $link . "', '', 'toolbar=no,location=no,status=no,menubar=no,scrollbars=yes,resizable=yes,width=780,height=550'); return false\" class=\"$menuclass\">" . JText::_('More details about ') . $this->escape($item->title) . "...</a>\n";
                        break;

                    default:
                        // formerly case 2
                        // open in parent window
                        $item->link = '<a href="' . $link . '" class="' . $menuclass . '">' . JText::_('More details about ') . $this->escape($item->title) . '...</a>';
                        break;
                }
            }else{
                $item->link = null;
            }
            // $item->title = '<strong>'. $this->escape($item->title) .'</strong>';
            // check for NEW icon
            switch ($itemParams->get('show_new', $params->get('show_new'))){
                // cases for a parameter - show new
                case 1:
                    // display new icon
                    $item->show_new_icon = '&nbsp;&nbsp;' . JHTML::_('image', 'administrator/components/com_courseman/assets/images/new_item.png', JText::_('New'));
                    break;
                default:
                    // nothing to display
                    $item->show_new_icon = '';
                    break;
            }
            // check for SALE icon
            switch ($itemParams->get('show_sale', $params->get('show_sale'))){
                // cases for a parameter - show sale
                case 1:
                    // display new icon
                    // $item->show_sale_icon = '&nbsp;&nbsp;<img src="'.JPATH_COMPONENT_ADMINISTRATOR.DS.'assets'.DS.'images'.DS.'sale_item.png"/>';
                    $item->show_sale_icon = '&nbsp;&nbsp;' . JHTML::_('image', 'administrator/components/com_courseman/assets/images/sale_item.png', JText::_('Sale'));
                    break;
                default:
                    // nothing to display
                    $item->show_sale_icon = '';
                    break;
            }
            if ($itemParams->get('current_capacity', $params->get('current_capacity')) > 0){
                switch ($itemParams->get('current_capacity', $params->get('current_capacity'))){
                    // cases for a parameter
                    case 1:
                        $current_capacity_setting = - 1;
                        break;

                    case 2:
                        $current_capacity_setting = 0;
                        break;

                    default:
                        $current_capacity_setting = - 1;
                        break;
                }
                // add currentbookings information
                $db = &JFactory::getDBO();
                $sql = 'SELECT SUM(b.attendees)'
                 . ' FROM #__courseman_application AS b'
                 . ' WHERE b.published = 1'
                 . ' AND b.course_id = ' . $item->id
                 . ' AND b.status > ' . $current_capacity_setting
                 . ' AND b.status < 3';
                $db->setQuery($sql);
                $item->currentBookings = ($item->capacity) - ($db->loadResult());

                if ($item->currentBookings > 0){
                    // create booking button
                    $item->book_link = '<div class="button2-left"><div class="blank"><a href="' . JRoute::_('index.php?view=courses&cid=' . $category->slug . '&id=' . $item->slug) . '">' . JText::_('Book Now') . '</a></div></div>';
                }else{
                    // if ($params->get('show_favourites'))
                    // {
                    // $model = & $this->getModel('category');
                    // $favourites = $model->getFavourites($item->id);
                    // $favoured = $model->getFavoured($item);
                    // $favicon =  courseman_html::favoure($item->id, $params, $favoured);
                    // }
                    $item->book_link = '<span class="centered italic">' . JText::_('FULL') . '</span>';
                }
            }else{
                // create booking button
                $item->book_link = '<div class="button2-left"><div class="blank"><a href="' . JRoute::_('index.php?view=courses&cid=' . $category->slug . '&id=' . $item->slug) . '">' . JText::_('Book Now') . '</a></div></div>';
            }
            // show sessions
            $db = &JFactory::getDBO();
            $sql = 'SELECT min(session_date) AS start_date, max(session_date) AS finish_date FROM #__courseman_sessions'
             . ' WHERE published = 1'
             . ' AND courseid = ' . $item->id
             . ' ORDER BY ordering';
            $db->setQuery($sql);
            $course_sessions_dates = $db->loadObjectList();

            foreach ($course_sessions_dates as $course_sessions2):
            $item->start_date = $course_sessions2->start_date;
            $item->finish_date = $course_sessions2->finish_date;
            endforeach;

            $sql = 'SELECT * FROM #__courseman_sessions'
             . ' WHERE published = 1'
             . ' AND courseid = ' . $item->id
             . ' ORDER BY ordering';
            $db->setQuery($sql);
            $course_sessions = $db->loadObjectList();
            $item->count_sessions = count($course_sessions);
            $item->course_sessions = $course_sessions;
            // set start and finish dates
            if ($itemParams->get('show_start_date', $params->get('show_start_date'))){
                // $item->start_date =JHTML::date($item->start_date);
            }else{
                $item->start_date = JText::_('Not Specified');
            }
            if ($itemParams->get('show_finish_date', $params->get('show_finish_date'))){
                // $item->finish_date =JHTML::date($item->finish_date);
            }else{
                $item->finish_date = JText::_('Not Specified');
            }
        }

        $filter_order = JRequest::getCmd('filter_order', 'i.title');
        $filter_order_Dir = JRequest::getCmd('filter_order_Dir', 'ASC');
        $filter = JRequest::getString('filter');
        $filter_experience_level = JRequest::getString('filter_experience_level');
        $filter_positiontype = JRequest::getString('filter_positiontype');

        $lists = array();
        $lists['filter_order'] = $filter_order;
        $lists['filter_order_Dir'] = $filter_order_Dir;
        $lists['filter'] = $filter;
        // $lists['filter_experience_level'] = $filter_experience_level;
        $experience_level[] = JHTML::_('select.option', '0', JText::_('All'), 'id', 'title');
        $titles = &$this->get('titles');
        $experience_level = array_merge($experience_level, $titles);
        $lists['filter_experience_level'] = JHTML::_('select.genericlist', $experience_level,
            'filter_experience_level', 'class="inputbox" size="1" ', 'id', 'title', $filter_experience_level);

        jimport('joomla.html.pagination');

        $pageNav = new JPagination($total, $limitstart, $limit);

        $this->assign('action', $uri->toString());

        $this->assignRef('params', $params);
        $this->assignRef('categories', $categories);
        $this->assignRef('courses', $courses);
        $this->assignRef('category', $category);
        $this->assignRef('pageNav', $pageNav);
        $this->assignRef('lists', $lists);

        parent::display($tpl);
    }
}

?>