<?php
/**
*
* @Copyright Copyright (C) 2010 www.profinvent.com. All rights reserved.
* @website http://www.profinvent.com
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 2 of the License, or
* any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.view');

class CoursemanViewCourses extends JView{
    function display($tpl = null)
    {
        global $mainframe;

        $document = &JFactory::getDocument();
        $user = &JFactory::getUser();
        $menus = &JSite::getMenu();
        $lang = &JFactory::getLanguage();
        $menu = $menus->getActive();
        $dispatcher = &JDispatcher::getInstance();
        $params = &$mainframe->getParams('com_courseman');
        $uri = &JFactory::getURI();

        $limitstart = JRequest::getVar('limitstart', 0, '', 'int');
        $cid = JRequest::getInt('cid', 0);

        if ($this->getLayout() == 'form'){
            $this->_displayForm($tpl);
            return;
        }
        
        if ($params->get('enable_bookings')==0) {
            return JError::raiseError(404,JText::_('Bookings are disabled'));
        }



        require_once (JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_courseman' . DS .
            'helpers' . DS . 'courseman.php');

        $document->addStyleSheet($this->baseurl .
            '/components/com_courseman/assets/css/courseman.css');
        if ($lang->isRTL()){
            $document->addStyleSheet($this->baseurl .
                '/components/com_courseman/assets/css/courseman_rtl.css');
        }

        $document->addCustomTag('<!--[if IE]><style type="text/css">.floattext{zoom:1;}, * html #courseman dd { height: 1%; }</style><![endif]-->');

        if (!$user->id || $user->id == 0){
            $document = &JFactory::getDocument();
            $document->addScript("includes/js/joomla.javascript.js");
        }

        $document = &JFactory::getDocument();
        //$document->addScript(JURI::base() . 'components/com_courseman/assets/js/validate-1.5.js');

        $course = &$this->get('Course');
        $course->currency_price = $params->get('currency');
        // If booking form is for registered only show login form
        if (($params->get('enable_bookings')) == '1'){
            if ($user->get('aid', 0) < 1){
                $redirectUrl = JRoute::_('index.php?option=com_courseman', false);
                $redirectUrl = base64_encode($redirectUrl);
                $redirectUrl = '&return=' . $redirectUrl;
                $joomlaLoginUrl = 'index.php?option=com_user&view=login';
                $finalUrl = $joomlaLoginUrl . $redirectUrl;
                $mainframe->redirect($finalUrl, JText::_('PLEASE LOGIN FIRST'));
            }
        }

        $attendeedata = &$this->get('attendee');

        if (($course->id == 0)){
            $id = JRequest::getInt('id', 0);
            return JError::raiseError(404, JText::sprintf('COURSE #%d NOT FOUND', $id));
        }

        if ($params->get('show_tags')){
            $tags = &$this->get('Tags');
        }

        if ($params->get('show_categories')){
            $categories = &$this->get('Categories');
        }

        if ($params->get('show_favourites')){
            $favourites = &$this->get('Favourites');
            $favoured = &$this->get('Favoured');
        }

        $files = &$this->get('Files');

        if ($params->get('trigger_onprepare_content')){
            JPluginHelper::importPlugin('content');
            $results = $dispatcher->trigger('onPrepareContent', array(&$course, &$params, $limitstart));
        }

        $cats = new courseman_cats($cid);
        $parents = $cats->getParentlist();
        $pathway = &$mainframe->getPathWay();

        foreach ($parents as $parent){
            $pathway->addItem($this->escape($parent->title), JRoute::_('index.php?view=category&cid=' .
                    $parent->categoryslug));
        }
        $pathway->addItem($this->escape($course->title), JRoute::_('index.php?view=courses&id=' .
                $course->slug));

        if (is_object($menu)){
            $menu_params = new JParameter($menu->params);
            if (!$menu_params->get('page_title')){
                $params->set('page_title', $course->title);
            }
        }else{
            $params->set('page_title', $course->title);
        }

        if ($cid){
            $parentcat = array_pop($parents);
            $doc_title = $parentcat->title . ' - ' . $params->get('page_title');
        }else{
            $doc_title = $params->get('page_title');
        }

        $document->setTitle($doc_title);

        if ($course->meta_description){
            $document->setDescription($course->meta_description);
        }

        if ($course->meta_keywords){
            $document->setMetadata('keywords', $course->meta_keywords);
        }

        if ($mainframe->getCfg('MetaTitle') == '1'){
            $mainframe->addMetaTag('title', $course->title);
        }

        if ($mainframe->getCfg('MetaAuthor') == '1'){
            $mainframe->addMetaTag('author', $course->author);
        }

        $mdata = new JParameter($course->metadata);
        $mdata = $mdata->toArray();
        foreach ($mdata as $k => $v){
            if ($v){
                $document->setMetadata($k, $v);
            }
        }
        // show sessions
        $db = &JFactory::getDBO();
        $sql = 'SELECT min(session_date) AS start_date, max(session_date) AS finish_date FROM #__courseman_sessions'
         . ' WHERE published = 1'
         . ' AND courseid = ' . $course->id
         . ' ORDER BY ordering';
        $db->setQuery($sql);
        $course_sessions_dates = $db->loadObjectList();

        foreach ($course_sessions_dates as $course_sessions2):
        $course->start_date = $course_sessions2->start_date;
        $course->finish_date = $course_sessions2->finish_date;
        endforeach;

        $sql = 'SELECT * FROM #__courseman_sessions'
         . ' WHERE published = 1'
         . ' AND courseid = ' . $course->id
         . ' ORDER BY session_date';
        $db->setQuery($sql);
        $course_sessions = $db->loadObjectList();
        $course->count_sessions = count($course_sessions);

        $itemParams = new JParameter($course->attribs);
        $params->merge($itemParams);
        // set start and finish dates
        if ($params->get('show_start_date')){
            $course->start_date = JHTML::date($course->start_date);
        }else{
            $course->start_date = JText::_('Not Specified');
        }
        if ($params->get('show_finish_date')){
            $course->finish_date = JHTML::date($course->finish_date);
        }else{
            $course->finish_date = JText::_('Not Specified');
        }

        $print_link = JRoute::_('index.php?view=courses&cid=' . $course->categoryslug .
            '&id=' . $course->slug . '&pop=1&tmpl=component');

        $lists['salutation'] = JHTMLCourseman::getListFromXML('Salutation', 'salutation', 0,
            $attendeedata->salutation);
        // capacity check
        switch ($params->get('current_capacity')){
            // cases for a parameter
            case 1:
                $current_capacity_setting = - 1;
                break;

            case 2:
                $current_capacity_setting = 0;
                break;

            default:
                $current_capacity_setting = - 1;
                break;
        }
        // add currentbookings information
        $db = &JFactory::getDBO();
        $sql = 'SELECT SUM(b.attendees)'
         . ' FROM #__courseman_application AS b'
         . ' WHERE b.published = 1'
         . ' AND b.course_id = ' . $course->id
         . ' AND b.status > ' . $current_capacity_setting
         . ' AND b.status < 3';
        $db->setQuery($sql);
        $course->currentAvailability = ($course->capacity) - ($db->loadResult());
        if ($params->get('current_capacity') && $course->currentAvailability < 1){
            // no more bookings can be made for the course selected

            //$mainframe->redirect(JRoute::_("index.php"), JText::_('The course is full'));

			JError::raiseError( 403, JText::_('The course is full') );
        }

        $data = new stdClass();
        $model = &$this->getModel('courses');
        $data->customfields = $model->getEditableCustomfields($attendeedata->id);
        CFactory::load('libraries' , 'customfields');

        $this->assignRef('fields', $data->customfields ['fields']);
        $this->assignRef('course', $course);
        $this->assignRef('tags', $tags);
        $this->assignRef('categories', $categories);
        $this->assignRef('attendeedata', $attendeedata);
        $this->assignRef('favourites', $favourites);
        $this->assignRef('favoured', $favoured);
        $this->assignRef('files', $files);
        $this->assignRef('user', $user);
        $this->assignRef('params', $params);
        $this->assignRef('print_link', $print_link);
        $this->assignRef('parentcat', $parentcat);
        $this->assignRef('course_sessions', $course_sessions);
        $this->assignRef('lists', $lists);
        $this->assign('action', $uri->toString());

        parent::display($tpl);
    }

    function _displayForm($tpl)
    {
        global $mainframe;

        $document = &JFactory::getDocument();
        $user = &JFactory::getUser();
        $uri = &JFactory::getURI();
        $course = &$this->get('Course');
        $tags = &$this->get('Alltags');
        $used = &$this->get('Usedtags');
        $params = &$mainframe->getParams('com_courseman');

        JHTML::_('behavior.formvalidation');
        JHTML::_('behavior.tooltip');

        if (!is_array($used)){
            $used = array();
        }

        $document->addStyleSheet($this->baseurl .
            '/components/com_courseman/assets/css/courseman.css');
        $document->addCustomTag('<!--[if IE]><style type="text/css">.floattext{zoom:1;}, * html #courseman dd { height: 1%; }</style><![endif]-->');

        if ($course->id > 1 && !($user->authorize('com_courseman', 'edit') || ($user->authorize('com_content', 'edit', 'content', 'own') && $course->created_by == $user->get('id')))){
            JError::raiseError(403, JText::_("ALERTNOTAUTH"));
        }

        if ($user->authorize('com_courseman', 'newtags')){
            $document->addScript('components/com_courseman/assets/js/tags.js');
        }

        $lists = $this->_buildEditLists();

        $editor = &JFactory::getEditor();

        $title = $course->id ? JText::_('Edit') : JText::_('New');

        $document->setTitle($title);

        $pathway = &$mainframe->getPathWay();
        $pathway->addItem($title, '');

        if (JString::strlen($course->fulltext) > 1){
            $course->text = $course->introtext . "<hr id=\"system-readmore\" />" . $course->fulltext;
        }else{
            $course->text = $course->introtext;
        }

        JFilterOutput::objectHTMLSafe($course, ENT_QUOTES);
        // custom fields
        // data structure $data['fields']['ungrouped'][field values] or $data['fields']['group title'][field values]
        // $data['id']		= $user->id;
        // $data['name']	= $user->name;
        // /  $data['email']	= $user->email;
        // Check if user is really allowed to edit
        $user = &JFactory::getUser();
        $data = new stdClass();
        $data->customfields = $model->getEditableCustomfields($user->id);

        CFactory::load('libraries' , 'customfields');
        // $tmpl	= new CTemplate();
        // $tmpl->set( 'fields' , $data->customfields ['fields'] );
        // echo $tmpl->fetch( 'customfields.edit' );
        $this->assign('action', $uri->toString());
        $this->assignRef('fields', $data->customfields ['fields']);
        $this->assignRef('course', $course);
        $this->assignRef('params', $params);
        $this->assignRef('lists', $lists);
        $this->assignRef('editor', $editor);
        $this->assignRef('user', $user);
        $this->assignRef('tags', $tags);
        $this->assignRef('used', $used);

        parent::display($tpl);
    }
}

?>