<?php
/**
* @Copyright Copyright (C) 2010 www.profinvent.com. All rights reserved.
* @website http://www.profinvent.com
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 2 of the License, or
* any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
**/

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.view');

class CoursemanViewCourses extends JView
{
    function display($tpl = null)
    {
        global $mainframe;

        $dispatcher = &JDispatcher::getInstance();

        $course = &$this->get('Course');
        $params = &$mainframe->getParams('com_courseman');

        JPluginHelper::importPlugin('content', 'image');
        $dispatcher->trigger('onPrepareContent', array(&$course, &$params, 0));

        $document = &JFactory::getDocument();

        $document->setTitle($course->title);
        $document->setName($course->alias);
        $document->setDescription($course->meta_description);
        $document->setMetaData('keywords', $course->meta_keywords);

        $document->setHeader($this->_getHeaderText($course, $params));



    	//show sessions
    	$db =& JFactory::getDBO();
    	$sql = 'SELECT *, min(session_date) AS start_date, max(session_date) AS finish_date FROM #__courseman_sessions'
    		. ' WHERE published = 1'
    		. ' AND courseid = '.$course->id
    		. ' ORDER BY ordering';
    	$db->setQuery($sql);
    	$course_sessions_dates = $db->loadObjectList();

    	foreach ($course_sessions_dates as $course_sessions2):
    		$course->start_date = $course_sessions2->start_date;
    		$course->finish_date = $course_sessions2->finish_date;
    	endforeach;
    	if ($params->get('show_start_date')):
    		echo JText::_('START DATE') . ' : ';
    		echo $course->start_date."\n";
    	endif;

    	if ($params->get('show_finish_date')):
    		echo JText::_('FINISH DATE') . ' : ';
    		echo $course->finish_date."\n";
    	endif;

    	if ($params->get('show_group')):
    		echo JText::_('Group') . ' : ';
    		echo $course->cgroup."\n";
    	endif;


    		echo JText::_('PRICE') . ' : ';
    		echo $course->price.' '.$params->get('currency')."\n";

    	if ($params->get('show_location')):
    		echo JText::_('Location') . ' : ';
    		echo $course->location."\n";
    	endif;

    	if ($params->get('show_experience_level')):
    		echo JText::_('LEVEL') . ' : ';
    		echo $course->level."\n";
    	endif;

        echo $course->text;
    }

    function _getHeaderText(&$course, &$params)
    {

        $text = '';
        if ($params->get('show_create_date') && $params->get('show_author'))
        {

            $text .= "\n";
        }

        if ($params->get('show_create_date'))
        {

            if (intval($course->created))
            {
                $create_date = JHTML::_('date', $course->created, JText::_('DATE_FORMAT_LC2'));
                $text .= $create_date;
            }
        }

        if ($params->get('show_modify_date') && ($params->get('show_author') || $params->
            get('show_create_date')))
        {

            $text .= " - ";
        }

        if ($params->get('show_modify_date'))
        {

            if (intval($course->modified))
            {
                $mod_date = JHTML::_('date', $course->modified);
                $text .= JText::_('LAST REVISED') . ' ' . $mod_date;
            }
        }
        return $text;
    }
}

?>